using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ChuPiao.AutoPrint.Common;
using ChuPiao.AutoPrint.Desktop.Dialogs;
using ChuPiao.AutoPrint.Desktop.Properties;
using ChuPiao.AutoPrint.Desktop.StatusBar;
using ChuPiao.AutoPrint.Machine;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.AutoPrint.Services;
using ChuPiao.AutoPrint.Services.AutoPrint;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using ChuPiao.Common.Utils;
using System.Threading;
using ChuPiao.Common.Communication.GtdJson.Packs;
using ChuPiao.Common.Communication.GtdJson;

namespace ChuPiao.AutoPrint.Desktop.AutoPrint
{
    public partial class AutoPrintView : BaseUserControl
    {
        private string _localConfig_SnapJcMatchMacKey = "SnapJcMatchMac";
        private static string _localConfig_SnapJcMatchMacValue = "";
        private string _localConfig_SnapZcPsKey = "SnapZcPs";
        private static string _localConfig_SnapZcPsValue = "";
        private string _localConfig_SnapOpenCodeKey = "SnapOpenCode";
        private static string _localConfig_SnapOpenCodeValue = "";
        private AutoPrintService _service;
        private string _errorMessage;
        private L_LotTicketEntity _ticket;

        private System.Windows.Forms.Timer refreshingTimer;
        private int updateInterval = 300000;

        private Thread _workThread;

        public AutoPrintView()
        {
            InitializeComponent();
            this.chkMacNumber.Checked = true;
            this.llblErrorView.Text = "";
            this.lblTotalMoney.Text = "0";
            this.llblViewLastTicket.Text = "0";
            //this.lblMoney.Text = "0";
            this.llblTicketSn.Text = "";
            this.llblViewQueue.Text = "0";
            this.lblTicketCode.Text = "";
            _ticket = new L_LotTicketEntity();

            //refreshingTimer = new Timer();
            //refreshingTimer.Interval = updateInterval;
            //refreshingTimer.Tick += delegate
            //{
            //    //refreshingTimer.Enabled = false;
            //    //_service.LotMachine.Log.Debug("¿ɳƱ淨");
            //    string playtype = GetMachinePlayType();
            //    this.toolTip1.SetToolTip(this.llblMachineConfig, playtype);
            //};
            //refreshingTimer.Enabled = true;

            //ʱ߳
            _workThread = new Thread(new ThreadStart(DoTask));
            _workThread.Start();
        }

        /// <summary>
        /// ָֹ߳
        /// </summary>
        public void StopWorkThread()
        {
            if (_workThread != null)
            {
                _workThread.Abort();
            }
        }

        private void DoTask()
        {
            while (true)
            {
                if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Error)
                {
                    try
                    {
                        //ȡָ
                        A10009GetCommand pack = new A10009GetCommand();
                        pack.AgentId = _service.LotMachine.MachineInfo.M_Number;
                        pack.Salt = _service.LotMachine.MachineInfo.M_Salt;
                        A10009GetCommandRet packRet = PackManager.Instance.Send(pack) as A10009GetCommandRet;
                        if (packRet.Code > 0)
                        {
                            Logger.Log.Info("״̬ȡָ:" + packRet.Command);
                            if (packRet.Command == "enter")    //Ѹı䣬嵯ƱָƱ״̬ȡƱ
                            {
                                //÷ֻСѸı
                                //if (_ticket.LotId == (int)Lottype.Jl)
                                if (_ticket.L_PlayId == (int)Playtype.JlRFSF || _ticket.L_PlayId == (int)Playtype.JlDXF ||
                                       (
                                           _ticket.L_PlayId == (int)Playtype.JlHHGG &&
                                          (
                                              _ticket.L_Code.Contains(Convert.ToString((int)Playtype.JlRFSF)) || _ticket.L_Code.Contains(Convert.ToString((int)Playtype.JlDXF))
                                          )
                                       )
                                   )                     
                                {
                                    try
                                    {
                                        //ȡƱ
                                        A10002NotifyTicket pack1 = new A10002NotifyTicket();
                                        pack1.AgentId = _service.LotMachine.MachineInfo.M_Number;
                                        pack1.Salt = _service.LotMachine.MachineInfo.M_Salt;
                                        _ticket.L_Status = 100;
                                        _ticket.L_LimitType = 0;
                                        _ticket.L_SucTime = DateTime.Now;
                                        pack1.Ticket = _ticket;
                                        A10002NotifyTicketRet packRet1 = PackManager.Instance.Send(pack1) as A10002NotifyTicketRet;
                                        if (packRet1.Code <= 0)
                                        {
                                            throw new Exception("򱨴Ѹı䡿ȡƱʧܣ" + packRet1.Code.ToString() + " " + packRet1.Message);
                                        }
                                        else
                                        {
                                            Logger.Log.Info("򱨴Ѹı䡿ȡƱɹ");
                                        }


                                        _service.ClearError((int)MachineErrorType.JlConditionChange);
                                        Logger.Log.Info("򱨴Ѹı䡿ƱָƱ");

                                        _service.UpdateMachineStatus(MachineStatusEnum.Printing);
                                        _service.Wait4Job.Set();
                                        WorkbenchSingleton.SafeThreadAsyncCall(new Action(ErrorCleared));
                                        Logger.Log.Info("򱨴Ѹı䡿ָƱ");


                                    }
                                    catch (Exception ex)
                                    {
                                        Logger.Log.Error("򱨴Ѹı䡿ʧܣ" + ex.ToString());
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        Logger.Log.Error("״̬ȡָʧܣ" + ex.ToString());
                    }
                }

                Thread.Sleep(5 * 1000);
            }
        }


        public void Checked()
        {
            this.chkMacNumber.Checked = true;
        }
        public bool IsSelected
        {
            get { return this.chkMacNumber.Checked; }
        }

        public AutoPrintService Service
        {
            get { return _service; }
            set
            {
                _service = value;
                ShowLotMachineInfo();
                _service.Printing += new EventHandler<TicketEventArgs>(_service_Printing);
                _service.Printed += new EventHandler<TicketEventArgs>(_service_Printed);
                _service.StatusChanged += new EventHandler<MachineStatusArgs>(LotMachine_StatusChanged);
                _service.PrintTicketError += new EventHandler<ErrorTicketEventArgs>(_service_PrintTicketError);

                _service.AmountCleared += new EventHandler(_service_AmountCleared);
                _service.ErrorCleared += new EventHandler(_service_ErrorCleared);
            }
        }

        void _service_ErrorCleared(object sender, EventArgs e)
        {
            try
            {
                WorkbenchSingleton.SafeThreadAsyncCall(new Action(ErrorCleared));

            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("ִвƱ¼쳣Ϣ", exception.Message));
            }
        }

        private void StopWarn()
        {
            bool hasError = false;
            foreach (KeyValuePair<string, ILotMachine> keyValuePair in LotMachineService.LotMachineList)
            {
                if (keyValuePair.Value.MachineInfo.M_Status == (int)MachineStatusEnum.Error)
                {
                    hasError = true;
                    break;
                }
            }
            if (!hasError)
            {
                StatusBarService.StopWarnButton();
            }
        }

        private void ErrorCleared()
        {
            this.llblErrorView.Text = "";
            StopWarn();
        }

        void _service_AmountCleared(object sender, EventArgs e)
        {
            try
            {
                //WorkbenchSingleton.SafeThreadCall(new Action<L_LotTicketEntity>(ShowTicketPrinting), e.TicketEntity);
                WorkbenchSingleton.SafeThreadAsyncCall(new Action(ShowAmount));
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("³Ʊϼƽ쳣Ϣ", exception.Message));
            }
        }

        public void ShowAmount()
        {
            this.lblTotalMoney.Text = _service.TotalMoney.ToString("0");
            this.llblViewLastTicket.Text = _service.TotalTicket.ToString();
        }

        private DecodePrintData _decodePrintData = null;

        void _service_PrintTicketError(object sender, ErrorTicketEventArgs e)
        {
            try
            {
                //_service.LotMachine.Log.Debug(string.Concat("ˮţ", e.Ticket.L_TicketSn, " ʼ´Ϣ"));
                _ticket = e.Ticket;
                _decodePrintData = e.DecodePrintData;
                _errorMessage = e.Message;
                //WorkbenchSingleton.SafeThreadCall(new Action<L_LotTicketEntity, string>(ShowError), e.TicketEntity, e.Message);
                WorkbenchSingleton.SafeThreadAsyncCall(new Action<L_LotTicketEntity, string>(ShowError), e.Ticket, e.Message);
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("Ʊ½쳣Ϣ", exception.Message));
            }
        }

        void LotMachine_StatusChanged(object sender, MachineStatusArgs e)
        {
            try
            {
                //_service.LotMachine.Log.Debug(string.Concat("»״̬", e.MachineStatus, "濪ʼ"));
                //WorkbenchSingleton.SafeThreadCall(new Action<MachineStatusEnum>(ShowMachineStatus), e.MachineStatus);
                WorkbenchSingleton.SafeThreadAsyncCall(new Action<MachineStatusEnum>(ShowMachineStatus), e.MachineStatus);
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("״̬仯½쳣Ϣ", exception.Message));
            }
        }

        void _service_Printed(object sender, TicketEventArgs e)
        {
            //WorkbenchSingleton.SafeThreadCall(new Action<L_LotTicketEntity>(ShowTicketPrinted), e.TicketEntity);
            try
            {
                //_service.LotMachine.Log.Debug(string.Concat("ˮţ", e.TicketEntity.L_TicketSn, " ʼ³Ʊɽ"));
                WorkbenchSingleton.SafeThreadAsyncCall(new Action<L_LotTicketEntity>(ShowTicketPrinted), e.TicketEntity);
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("³Ʊɽ쳣Ϣ", exception.Message));
            }

        }

        void _service_Printing(object sender, TicketEventArgs e)
        {
            try
            {
                //WorkbenchSingleton.SafeThreadCall(new Action<L_LotTicketEntity>(ShowTicketPrinting), e.TicketEntity);
                WorkbenchSingleton.SafeThreadAsyncCall(new Action<L_LotTicketEntity>(ShowTicketPrinting), e.TicketEntity);
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("³Ʊн쳣Ϣ", exception.Message));
            }

        }

        private void ShowError(L_LotTicketEntity ticketEntity, string message)
        {
            try
            {
                //new RedisClient().Publish(_service.LotMachine.MachineInfo.M_Number + " ˣ" + message);

                this.llblErrorView.Text = "Ʊ";
                this.toolTip1.SetToolTip(this.llblErrorView, message);
                this.lblStatus.Image = Resources.Warning;

                //this.llblInputTicketCode.Visible = true;
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("´Ϣ쳣Ϣ", exception.Message));
            }

        }
        void ShowMachineStatus(MachineStatusEnum machineStatus)
        {
            try
            {
                switch (machineStatus)
                {
                    case MachineStatusEnum.Printing:
                        this.lblStatus.Image = Resources.Run;
                        this.gbxMachine.BackColor = Color.Empty;

                        this.chkMacNumber.Checked = false;
                        break;
                    case MachineStatusEnum.Stopped:
                        this.lblStatus.Image = Resources.Stop;
                        this.gbxMachine.BackColor = Color.Empty;
                        this.chkMacNumber.Checked = true;
                        break;
                    case MachineStatusEnum.Stopping:
                        this.lblStatus.Image = Resources.Pause;
                        this.gbxMachine.BackColor = Color.Empty;
                        break;
                    case MachineStatusEnum.Error:
                        this.lblStatus.Image = Resources.Warning;
                        //this.gbxMachine.BackColor = Color.Orange;
                        //this.gbxMachine.BackColor = Color.RosyBrown;//001
                        //this.gbxMachine.BackColor = Color.DarkKhaki;//002
                        //this.gbxMachine.BackColor = Color.DarkSeaGreen;//003
                        this.gbxMachine.BackColor = Color.PaleGoldenrod;//004
                        this.chkMacNumber.Checked = true;
                        break;
                    case MachineStatusEnum.Encashing:
                        this.lblStatus.Image = Resources.Run;
                        this.gbxMachine.BackColor = Color.Empty;
                        this.chkMacNumber.Checked = false;
                        break;
                }
                //_service.LotMachine.Log.Info(string.Concat("»״̬", machineStatus, ""));
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("»״̬쳣Ϣ", exception.Message));
            }

        }
        void ShowTicketPrinting(L_LotTicketEntity ticketEntity)
        {
            try
            {
                _ticket = ticketEntity;

                int length = _service.WaitPrintTicketCount;
                this.llblViewQueue.Text = length.ToString();

                this.llblErrorView.Text = "";
                if (ticketEntity.L_Code == "recharge")
                {
                    this.lblTicketCode.Text = "ֵС";
                }
                else if (ticketEntity.L_Code == "getbouns")
                {
                    this.lblTicketCode.Text = "ҽС";
                }
                else
                {
                    this.lblTicketCode.Text = "ƱС";
                }
                this.llblTicketSn.Text = ticketEntity.L_TicketSn;
                //this.lblMoney.Text = ticketEntity.L_Money.ToString("0");

                this.llblViewLastTicket.Text = Service.TotalTicket.ToString();
                this.lblTotalMoney.Text = Service.TotalMoney.ToString("0");
                //Application.DoEvents();
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("³Ʊн쳣Ϣ", exception.Message));
            }

        }
        void ShowTicketPrinted(L_LotTicketEntity ticketEntity)
        {
            try
            {
                _ticket = ticketEntity;

                this.lblTicketCode.Text = "ɣ";
                this.llblTicketSn.Text = "";
                this.llblViewLastTicket.Text = Service.TotalTicket.ToString();
                this.lblTotalMoney.Text = Service.TotalMoney.ToString("0");

                //_service.LotMachine.Log.Debug(string.Concat("ˮţ", ticketEntity.L_TicketSn, " ³Ʊɽ"));
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("³Ʊɽ쳣Ϣ", exception.Message));
            }

        }
        public void ShowLotMachineInfo()
        {
            try
            {
                M_MachineEntity machineEntity = Service.LotMachine.MachineInfo;
                string typeDesc = EnumDescription.GetFieldText((MachineType)machineEntity.M_Type);

                this.gbxMachine.Text = string.Concat(machineEntity.M_ZxNumber, "[", typeDesc, "]");
                //this.chkMacNumber.Text = machineEntity.M_Number;
                this.llblMachineConfig.Text = machineEntity.M_Number;
                //string playtype = GetMachinePlayType();
                //this.toolTip1.SetToolTip(this.llblMachineConfig, playtype);
                //this.lblPlayType.
                //Application.DoEvents();

                //ץȡʶ
                this.chkAllowSnapJcMatch.Checked = false;
                string address = System.Configuration.ConfigurationManager.AppSettings.Get("Address");
                if (address == null) address = "";
                //if (machineEntity.M_Type == (int)MachineType.TjJingCaiV1||machineEntity.M_Type == (int)MachineType.JxJingCaiV1 || (machineEntity.M_Type == (int)MachineType.HnTiCai && address.IndexOf("") > -1) || (machineEntity.M_Type == (int)MachineType.JsTiCai && address.IndexOf("") > -1))
                //{
                //    this.chkAllowSnapJcMatch.Visible = true;

                //    //ץȡѡ浽
                //    string macStr = LocalConfigUtil.GetConfig(_localConfig_SnapJcMatchMacKey);
                //    if (null != macStr)
                //    {
                //        _localConfig_SnapJcMatchMacValue = macStr;
                //        this.chkAllowSnapJcMatch.Checked = _localConfig_SnapJcMatchMacValue.Contains("[" + machineEntity.M_Number + "]");
                //    }
                //}
                //else
                //{
                //    this.chkAllowSnapJcMatch.Visible = false;

                //}


                ////ץȡʶ޺
                //this.checkBoxSnapZcPs.Checked = false;
                //if (machineEntity.M_Type == (int)MachineType.JxTiCaiMachineV2 || (machineEntity.M_Type == (int)MachineType.JsTiCai && address.IndexOf("") > -1) || (machineEntity.M_Type == (int)MachineType.HnTiCai && address.IndexOf("") > -1))
                //{
                //    this.checkBoxSnapZcPs.Visible = true;

                //    //ץȡѡ浽
                //    string macStr = LocalConfigUtil.GetConfig(_localConfig_SnapZcPsKey);
                //    if (null != macStr)
                //    {
                //        _localConfig_SnapZcPsValue = macStr;
                //        this.checkBoxSnapZcPs.Checked = _localConfig_SnapZcPsValue.Contains("[" + machineEntity.M_Number + "]");
                //    }
                //}
                //else
                //{
                //    this.checkBoxSnapZcPs.Visible = false;
                //}



                //ץȡֲʿ
                //this.checkBoxSnapOpenCode.Checked = true;
                //this.checkBoxSnapOpenCode_force.Checked = false;
                //if (machineEntity.M_Type == (int)MachineType.JxTiCaiMachineV3 || (machineEntity.M_Type == (int)MachineType.JsTiCai && address.IndexOf("ֲ") > -1) || machineEntity.M_Type == (int)MachineType.HbGaoPinCai)
                //{

                //ץȡѡ浽
                string macStr = LocalConfigUtil.GetConfig(_localConfig_SnapOpenCodeKey);
                if (null != macStr)
                {
                    _localConfig_SnapOpenCodeValue = macStr;
                    this.checkBoxSnapOpenCode.Checked = _localConfig_SnapOpenCodeValue.Contains("[" + machineEntity.M_Number + "]");
                }
                //}
                //else
                //{
                //    this.checkBoxSnapOpenCode.Visible = false;
                //}
            }
            catch (Exception exception)
            {
                LoggingService.Info(string.Concat("»Ϣ쳣Ϣ", exception.Message));
            }

        }
        //private string GetMachinePlayType()
        //{
        //    try
        //    {
        //        M_MachinePlayService MachinePlayService = new M_MachinePlayService();
        //        List<M_MachinePlayEntity> MachinePlayList = MachinePlayService.GetMachineLotListByMid(Service.LotMachine.MachineInfo);
        //        if (null != MachinePlayList && MachinePlayList.Count > 0)
        //        {
        //            StringBuilder PlayTypesString = new StringBuilder();
        //            foreach (M_MachinePlayEntity MachinePlay in MachinePlayList)
        //            {
        //                if (PlayTypesString.Length > 0)
        //                {
        //                    PlayTypesString.Append("");
        //                }
        //                PlayTypesString.Append(LotPlayTypeHashTable.GetLotName(MachinePlay.P_LotId));
        //                PlayTypesString.Append(LotPlayTypeHashTable.GetPlayName(MachinePlay.P_PlayId));
        //            }
        //            if (PlayTypesString.Length > 0)
        //            {
        //                return string.Format("{0}", PlayTypesString.ToString());
        //            }
        //            else
        //            {
        //                return "õĿɳƱͲá";
        //            }
        //        }
        //        else
        //        {
        //            return "ûÿɳƱ͡";
        //        }
        //    }
        //    catch (Exception exception)
        //    {
        //        LoggingService.Info(string.Concat("»ɳƱ淨쳣Ϣ", exception.Message));
        //        return "";
        //    }
        //}

        public void ReverseSelect()
        {
            this.chkMacNumber.Checked = !this.chkMacNumber.Checked;
        }

        public void Start()
        {
            if (IsSelected)
            {
                Service.Start();
                this.chkMacNumber.Checked = false;//Ĭȡŵѡ״̬
            }
        }

        public void Stop()
        {
            if (IsSelected)
            {
                Service.Stop();
            }
        }
        public void ReGetdata()
        {
            if (IsSelected)
            {
                try
                {
                    DecodePrintData decodePrintData = new DecodePrintData();
                    Service.ReGetdata(Service.CurrentTicket, decodePrintData);
                    this.llblErrorView.Text = "";
                    StopWarn();
                }
                catch (Exception ex)
                {
                    Service.Stop();
                    Service.LotMachine.Log.Error(ex);
                }
                Service.Wait4Job.Set();
            }
        }
        public void Continue()
        {
            if (IsSelected)
            {
                if (Service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Error)
                {
                    Service.LotMachine.Log.Info("󲢼Ʊ");
                    Service.ClearError((int)MachineErrorType.BetFail);
                }
            }
        }
        public void ClearLimitError()
        {
            if (IsSelected)
            {
                if (Service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Error)
                {
                    Service.LotMachine.Log.Info("ͣ/޺ŵƱ");
                    Service.ClearError((int)MachineErrorType.JcStopSale);
                }
            }
        }
        public void ForceStop()
        {
            if (IsSelected)
            {
                Service.LotMachine.ForceStop();
            }
        }
        public void ReturnTopGui()
        {
            if (IsSelected)
            {
                if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
                {
                    new MethodInvoker(_service.LotMachine.ReturnTopGui).BeginInvoke(null, null);
                }
            }
        }
        public void Login()
        {
            if (IsSelected)
            {
                if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
                {
                    new MethodInvoker(_service.LotMachine.Login).BeginInvoke(null, null);
                }
            }
        }
        public void Test()
        {
            if (IsSelected)
            {
                if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
                {
                    new MethodInvoker(_service.PrintTestTicket).BeginInvoke(null, null);
                }
            }
        }
        public void UpdateMoney()
        {
            if (IsSelected)
            {
                if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
                {
                    new MethodInvoker(_service.UpdateMachineMoney).BeginInvoke(null, null);
                    //new Action<int, string, DateTime, DateTime>(_service.UpdateMachineMoney).BeginInvoke(type, typename, from, to, null, null);
                }
            }
        }
        public void PrintDayReport(int type, string typename, DateTime from, DateTime to)
        {
            if (IsSelected)
            {
                if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
                {
                    //new MethodInvoker(_service.PrintDayReport).BeginInvoke(null, null);
                    new Action<int, string, DateTime, DateTime>(_service.PrintDayReport).BeginInvoke(type, typename, from, to, null, null);
                }
            }
        }
        public void Clear()
        {
            if (IsSelected)
            {
                if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
                {
                    new MethodInvoker(_service.ClearAmount).BeginInvoke(null, null);
                }
            }
        }
        public void GetAndPrintLastTicket()
        {
            if (IsSelected)
            {
                new MethodInvoker(_service.GetAndPrintLastTicket).BeginInvoke(null, null);
            }
        }

        //public void TransferTasks(List<M_MachineEntity> desMachineList)
        //{
        //    if(IsSelected)
        //    {
        //        try
        //        {
        //            string srcMachineNumber = _service.LotMachine.MachineInfo.M_Number;
        //            if (_service.LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
        //            {
        //                _service.TransferTasks(desMachineList);
        //            }
        //            else
        //            {
        //                MessageService.ShowMessage(string.Concat("Ʊǰֹͣ", srcMachineNumber, "Ʊ"),"ʾ");
        //            }
        //        }
        //        catch(Exception exception)
        //        {
        //            MessageService.ShowMessage(string.Concat("תƱ쳣Ϣ", exception), "ʾ");
        //        }
        //    }
        //}

        public event EventHandler CheckedChanged;
        private void chkMacNumber_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckedChanged != null)
            {
                CheckedChanged(sender, e);
            }
        }

        private void llblErrorView_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(this.llblErrorView.Text))
                {
                    return;
                }
                ErrorDialog errorDialog = new ErrorDialog(_service, _ticket, _decodePrintData, _errorMessage);
                errorDialog.ShowDialog();
                switch (errorDialog.Result)
                {
                    case ErrorProcessEnum.Abort:
                        this.chkMacNumber.Checked = true;
                        break;
                }
                this.llblErrorView.Text = "";
            }
            catch (Exception exception)
            {
                MessageService.ShowMessage(string.Concat("Ի쳣Ϣ", exception.Message));
            }
        }

        private void llblViewQueue_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                TicketList ticketList = new TicketList(_service.LotMachine.MachineInfo.M_Number, _service.WaitPrintTickets.ToArray());
                ticketList.Show();
            }
            catch (Exception exception)
            {
                MessageService.ShowMessage(string.Concat("鿴ȴƱ쳣Ϣ", exception.Message));
            }
        }

        private void llblViewLastTicket_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                LastTicket ticketList = new LastTicket(_service.LotMachine.MachineInfo.M_Number, _service.LotMachine.VirtualPrinter.LogPath);
                ticketList.Show();
            }
            catch (Exception exception)
            {
                MessageService.ShowMessage(string.Concat("鿴Ʊ¼쳣Ϣ", exception.Message));
            }
        }

        private void llblMachineConfig_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                if (_service.LotMachine.MachineInfo.M_Status != (int)MachineStatusEnum.Stopped)
                {
                    MessageService.ShowMessage("޸ĻǰҪֹͣƱ");
                    return;
                }
                DlgMachineEdit dlgMachineEdit = new DlgMachineEdit(_service.LotMachine.MachineInfo);
                dlgMachineEdit.ShowDialog();
            }
            catch (Exception exception)
            {
                MessageService.ShowMessage(string.Concat("鿴쳣Ϣ", exception.Message));
            }
        }

        private void llblInputTicketCode_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                InputTicketCodeDialog dlgInputTicketCode = new InputTicketCodeDialog(_service);
                DialogResult dialogResult = dlgInputTicketCode.ShowDialog();
                if (dialogResult == DialogResult.OK)
                {
                    ShowTicketPrinted(_service.CurrentTicket);
                }
            }
            catch (Exception exception)
            {
                MessageService.ShowMessage(string.Concat("ֹƱŶԻ쳣Ϣ", exception.Message));
            }
        }

        private void chkAllowSnapJcMatch_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                _service.LotMachine.MachineInfo.AllowSnapJcMatch = this.chkAllowSnapJcMatch.Checked;

                string macStr = "[" + Service.LotMachine.MachineInfo.M_Number + "]";
                _localConfig_SnapJcMatchMacValue = _localConfig_SnapJcMatchMacValue.Replace(macStr, "");
                if (this.chkAllowSnapJcMatch.Checked)
                {
                    _localConfig_SnapJcMatchMacValue += macStr;
                }

                LocalConfigUtil.SaveConfig(_localConfig_SnapJcMatchMacKey, _localConfig_SnapJcMatchMacValue);
            }
            catch (Exception exception)
            {
                Service.LotMachine.Log.Info(string.Concat("ץȡʶѡ쳣Ϣ", exception.ToString()));
                MessageService.ShowMessage(string.Concat("ץȡʶѡ쳣Ϣ", exception.Message));
            }
        }

        private void llblTicketSn_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                TicketInfo ticket = new TicketInfo(_ticket);
                ticket.Show();
            }
            catch (Exception exception)
            {
                MessageService.ShowMessage(string.Concat("鿴ƱϢ쳣Ϣ", exception.Message));
            }
        }

        private void checkBoxSnapZcPs_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                _service.LotMachine.MachineInfo.AllowSnapZcPs = this.checkBoxSnapZcPs.Checked;

                string macStr = "[" + Service.LotMachine.MachineInfo.M_Number + "]";
                _localConfig_SnapZcPsValue = _localConfig_SnapZcPsValue.Replace(macStr, "");
                if (this.checkBoxSnapZcPs.Checked)
                {
                    _localConfig_SnapZcPsValue += macStr;
                }

                LocalConfigUtil.SaveConfig(_localConfig_SnapZcPsKey, _localConfig_SnapZcPsValue);
            }
            catch (Exception exception)
            {
                Service.LotMachine.Log.Info(string.Concat("ץȡʶ޺бѡ쳣Ϣ", exception.ToString()));
                MessageService.ShowMessage(string.Concat("ץȡʶ޺бѡ쳣Ϣ", exception.Message));
            }
        }

        private void checkBoxSnapOpenCode_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                _service.LotMachine.MachineInfo.AllowSnapOpenCode = this.checkBoxSnapOpenCode.Checked;

                string macStr = "[" + Service.LotMachine.MachineInfo.M_Number + "]";
                _localConfig_SnapOpenCodeValue = _localConfig_SnapOpenCodeValue.Replace(macStr, "");
                if (this.checkBoxSnapOpenCode.Checked)
                {
                    _localConfig_SnapOpenCodeValue += macStr;
                }

                LocalConfigUtil.SaveConfig(_localConfig_SnapOpenCodeKey, _localConfig_SnapOpenCodeValue);
            }
            catch (Exception exception)
            {
                Service.LotMachine.Log.Info(string.Concat("ץȡֲʿ롿ѡ쳣Ϣ", exception.ToString()));
                MessageService.ShowMessage(string.Concat("ץȡֲʿ롿ѡ쳣Ϣ", exception.Message));
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            new DlgMachineLot(_service.LotMachine.MachineInfo).ShowDialog();
        }

        private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            new DlgDaySales(_service.LotMachine.MachineInfo).ShowDialog();
        }

        private void checkBoxSnapOpenCode_force_CheckedChanged(object sender, EventArgs e)
        {
            _service.LotMachine.MachineInfo.AllowSnapOpenCode_force = this.checkBoxSnapOpenCode_force.Checked;
        }
    }
}

