using System;
using System.Collections.Generic;
using System.IO;
using System.Threading;
using System.Windows.Forms;
using ChuPiao.AutoPrint.Configuration;
using ChuPiao.AutoPrint.Desktop.StatusBar;
using ChuPiao.AutoPrint.Machine;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.AutoPrint.Services;
using ChuPiao.AutoPrint.Services.AutoPrint;
using ChuPiao.Common.Core.Utils;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using ChuPiao.Common.Utils;
using ChuPiao.Common.Communication.GtdJson.Packs;
using ChuPiao.Common.Communication.GtdJson;
using ChuPiao.AutoPrint.Services.TicketFile;
using System.Configuration;

namespace ChuPiao.AutoPrint.Desktop.AutoPrint
{
    
    public partial class ErrorDialog : Form
    {
        public ErrorDialog(AutoPrintService service,L_LotTicketEntity ticket, DecodePrintData decodePrintData,string message)
        {
            InitializeComponent();
            _service = service;
            _ticket = ticket;
            _decodePrintData = decodePrintData;
            _message = message;
        }
        private ErrorProcessEnum _result;
        public ErrorProcessEnum Result
        {
            get
            {
                return _result;
            }
            set
            {
                _result = value;
            }
        }

        private AutoPrintService _service;
        private L_LotTicketEntity _ticket;
        private DecodePrintData _decodePrintData;
        private string _message;
        

        private void ErrorDialog_Load(object sender, EventArgs e)
        {
           

            //string path = @"E:\work\Ʊ\22ѡ5\ʽ\00003050470000018242.prn";
            //byte[] arr = File.ReadAllBytes(path);

            if(_decodePrintData!=null && _decodePrintData.InputData!=null && _decodePrintData.InputData.CaptureDataBytes.Length>0)
            {
                byte[] arr = _decodePrintData.InputData.CaptureDataBytes;
                using (MemoryStream ms = new MemoryStream())
                {
                    ms.Write(_decodePrintData.InputData.CaptureDataBytes, 0, arr.Length);
                    ms.Position = 0;
                    this.richTextBoxTicket.LoadFile(ms, RichTextBoxStreamType.PlainText);
                }
                
            }
            this.richTextBoxErrorMsg.Text = _message;
            if(_ticket!=null)
            {
                this.lblCode.Text = _ticket.L_Code;
                this.lblTicketCode.Text = _decodePrintData==null?"":_decodePrintData.L_PrintTicketEntity.P_TicketCode;
                this.lblTicketSn.Text = _ticket.L_TicketSn;
                this.lblMutiple.Text = _ticket.L_Mutiple.ToString();
                this.lblMoney.Text = _ticket.L_Money.ToString("0");
                this.lblOrderSn.Text = _ticket.L_OrderSn;
                this.lblEndTime.Text = _ticket.L_EndTime.ToString("yyyy-MM-dd HH:mm:ss");
                string codetype = "";
                if (_ticket.LotId == (int)Lottype.Jz || _ticket.LotId == (int)Lottype.Jl || _ticket.LotId == (int)Lottype.Bd)
                {
                    JcCodeTypeEnum codeTypeEnum = (JcCodeTypeEnum)_ticket.L_CodeType;
                    codetype = EnumDescription.GetFieldText(codeTypeEnum);
                }
                this.lblCurrentTicketName.Text = string.Concat(LotPlayTypeHashTable.LotTypeHashTable[_ticket.LotId], LotPlayTypeHashTable.PlayTypeHashTable[_ticket.L_PlayId], codetype);
                this.lblExpect.Text = _ticket.L_Expect;
                //if (_ticket.LotId == (int)Lottype.Ps || _ticket.LotId == (int)Lottype.Dl || _ticket.LotId == (int)Lottype.Hd || _ticket.LotId == (int)Lottype.Jd || _ticket.LotId == (int)Lottype.Xs || _ticket.LotId == (int)Lottype.Jz || _ticket.LotId == (int)Lottype.Jl || _ticket.LotId == (int)Lottype.Jm)
                //{
                //    //ֲֻʡ㡢޺
                //    btnLimit.Enabled = true;
                //}
                //else
                //{
                //    btnLimit.Enabled = false;
                //}
                if (_ticket.LotId == (int)Lottype.Ps || _ticket.LotId == (int)Lottype.Dl || _ticket.LotId == (int)Lottype.Hd || _ticket.LotId == (int)Lottype.Jd || _ticket.LotId == (int)Lottype.Xs || _ticket.LotId == (int)Lottype.Jz || _ticket.LotId == (int)Lottype.Jl || _ticket.LotId == (int)Lottype.Jm)
                {
                    //ֻогͣ
                    btnJcStopSale.Enabled = true;
                }
                else
                {
                    btnJcStopSale.Enabled = false;
                }

                //÷ֻܷѸı
                //if (_ticket.LotId == (int)Lottype.Jl)
                if (_ticket.L_PlayId == (int)Playtype.JlRFSF || _ticket.L_PlayId == (int)Playtype.JlDXF|| 
                      (
                          _ticket.L_PlayId == (int)Playtype.JlHHGG && 
                          (
                              _ticket.L_Code.Contains(Convert.ToString((int)Playtype.JlRFSF)) || _ticket.L_Code.Contains(Convert.ToString((int)Playtype.JlDXF))
                          )
                       )
                    )
                {
                    button2.Enabled = true;
                }
                else
                {
                    button2.Enabled = false;
                }
            }

           
            
        }

        

        private void clickJLConditionChanged()
        {
            button2.PerformClick();
        }

        private void btnAbort_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK != MessageBox.Show("ƱʵѳƱֹظƱ´ƱȷֹƱô", "ȷ", MessageBoxButtons.OKCancel))
            {
                this.DialogResult = DialogResult.None;
                return;
            }

            _service.Stop();
            _service.OnPrinted(_ticket);
            _service.Wait4Job.Set();
            Result = ErrorProcessEnum.Abort;
            _service.Result = Result;
            this.DialogResult = DialogResult.OK;
            StopWarn();
        }

        private void btnRetry_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK != MessageBox.Show("ƱʵѳƱԽظƱ´ƱȷԳƱô", "ȷ", MessageBoxButtons.OKCancel))
            {
                this.DialogResult = DialogResult.None;
                return;
            }

            try
            {
                _service.UpdateMachineStatus(MachineStatusEnum.Printing);
                _service.RePrint(_ticket);
                _service.Wait4Job.Set();
                Result = ErrorProcessEnum.Ignore;
                _service.Result = Result;
                this.DialogResult = DialogResult.OK;
                StopWarn();
            }
            catch (Exception ex)
            {
                Logger.Log.Error("ʧܣ");
            }
        }

        private void ErrorDialog_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (DialogResult == DialogResult.Cancel)
            {
                _service.Stop();
                _service.Wait4Job.Set();
            }
            //else
            //{
            //    new RedisClient().Publish(_service.LotMachine.MachineInfo.M_Number + " Ѵ");
            //}
        }

        private void btnPrint_Click(object sender, EventArgs e)
        {
            try
            {
                if (_decodePrintData != null && _decodePrintData.InputData != null && _decodePrintData.InputData.CaptureDataBytes != null && _decodePrintData.InputData.CaptureDataBytes.Length > 0)
                {
                    LotMachineService.PrintETicket(_service.LotMachine.MachineInfo.M_Number, _decodePrintData.InputData.CaptureDataBytes);
                    //LotMachineService.PrinterClient.AddBytes(_decodePrintData.InputData.CaptureDataBytes);
                    //ChuPiao.Common.Communication.CpdJson.Packs.P12014PrintTicketFile reqPack = new ChuPiao.Common.Communication.CpdJson.Packs.P12014PrintTicketFile();
                    //reqPack.MacNumber = _service.LotMachine.MachineInfo.M_Number;
                    //reqPack.PrnText =
                    //    HexStringUtil.ByteToString(_decodePrintData.InputData.CaptureDataBytes);
                    //ChuPiao.Common.Communication.CpdJson.PackRetBase packRetBase = ChuPiao.Common.Communication.CpdJson.PackManager.Instance.Transaction(_service.LotMachine.MachineInfo.M_Number, reqPack);
                    //if (packRetBase == null)
                    //{
                    //    throw new Exception(string.Concat("ִʧܡţ", _service.LotMachine.MachineInfo.M_Number));
                    //}
                    //if (packRetBase.ReturnCode != 0)
                    //{
                    //    throw new Exception(string.Concat("Ʊش룺", packRetBase.ReturnCode, " Ϣ", packRetBase.ReturnMessage));
                    //}
                }
            }
            catch (Exception exception)
            {
                MessageService.ShowError(string.Concat("ӡƱ쳣Ϣ",exception.Message));
            }
        }

        private void btnIgnore_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK != MessageBox.Show("ƱʵѳƱȡ´ƱȷҪȡ", "ȷ", MessageBoxButtons.OKCancel))
            {
                this.DialogResult = DialogResult.None;
                return;
            }
            Logger.Log.Info("ʼ֪ͨȡ...");
            try
            {
                //֪ͨƱ
                A10002NotifyTicket pack = new A10002NotifyTicket();
                pack.AgentId = _service.LotMachine.MachineInfo.M_Number;
                pack.Salt = _service.LotMachine.MachineInfo.M_Salt;
                _ticket.L_Status = 100;
                _ticket.L_LimitType = 0;
                _ticket.L_SucTime = DateTime.Now;
                pack.Ticket = _ticket;
                A10002NotifyTicketRet packRet = PackManager.Instance.Send(pack) as A10002NotifyTicketRet;
                if (packRet.Code <= 0)
                {
                    throw new Exception("ȡʧܣ" + packRet.Code.ToString() + " " + packRet.Message);
                }
                else
                {
                    MessageBox.Show("ȡɹ");
                }

                _service.Stop();
                _service.OnPrinted(_ticket);
                _service.Wait4Job.Set();
                Result = ErrorProcessEnum.Abort;
                _service.Result = Result;
                this.DialogResult = DialogResult.OK;
                StopWarn();
            }
            catch (Exception ex)
            {
                Logger.Log.Error("ȡʧܣ" + ex.ToString());
                MessageBox.Show("ȡʧܣԣ");
            }
        }
       

        private void btnReGetdata_Click(object sender, EventArgs e)
        {
            Logger.Log.Info("ʼλȡ...");
            try
            {
                DecodePrintData decodePrintData = new DecodePrintData();
                _service.ReGetdata(_ticket,decodePrintData);

                if (decodePrintData.DecodeSuccess)
                {
                    _service.LotMachine.Log.Info(string.Concat("λȡݽɹ"));

                    //string ticketFilePath = FileService.GetErrorTicketFilePath(_service.LotMachine.MachineInfo.M_Number, _ticket.L_TicketCode); ;
                    //File.WriteAllText(ticketFilePath, decodePrintData.L_PrintTicketEntity.P_PrnText);
                    //_service.LotMachine.Log.Info(string.Concat("Ʊļ", ticketFilePath));
                    //if (_service.LotMachine.MachineInfo.M_AllowPaperout)
                    //{
                    //    LotMachineService.PrintETicket(_service.LotMachine.MachineInfo.M_Number, ticketFilePath, true);
                    //}

                    //MessageBox.Show("λȡݳɹ֪ͨƱ֪ͨ");
                    button1.PerformClick();
                }
                else
                {
                    MessageBox.Show("λȡʧܣ»ȡԼΣ");
                }
            }
            catch (Exception ex)
            {
                //_service.Wait4Job.Set();
                _service.Stop();
                _service.LotMachine.Log.Warn("Ʊʧܣ" + ex.Message + "\r\n" + ex.StackTrace);
                MessageBox.Show("λȡ쳣֪ͨ");
            }
            
        }

        private void StopWarn()
        {
            bool hasError = false;
            foreach (KeyValuePair<string, ILotMachine> keyValuePair in LotMachineService.LotMachineList)
            {
                if(keyValuePair.Value.MachineInfo.M_Status==(int)MachineStatusEnum.Error)
                {
                    hasError = true;
                    break;
                }
            }
            if(!hasError)
            {
                StatusBarService.StopWarnButton();
            }
        }

        private void btnJcStopSale_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK != MessageBox.Show("Ʊʾ޺ŻۣͣʹȷۣͣҪô", "ȷ", MessageBoxButtons.OKCancel))
            {
                this.DialogResult = DialogResult.None;
                return;
            }

            Logger.Log.Info("ʼ֪ͨ...");
            try
            {
                //֪ͨƱ
                A10002NotifyTicket pack = new A10002NotifyTicket();
                pack.AgentId = _service.LotMachine.MachineInfo.M_Number;
                pack.Salt = _service.LotMachine.MachineInfo.M_Salt;
                _ticket.L_Status = -300;
                _ticket.L_LimitType = -300;
                _ticket.L_SucTime = DateTime.Now;
                pack.Ticket = _ticket;
                A10002NotifyTicketRet packRet = PackManager.Instance.Send(pack) as A10002NotifyTicketRet;
                if (packRet.Code <= 0)
                {
                    throw new Exception("ʧܣ" + packRet.Code.ToString() + " " + packRet.Message);
                }
                else
                {
                    MessageBox.Show("ɹ");
                }

                _service.Stop();
                _service.OnPrinted(_ticket);
                _service.Wait4Job.Set();
                Result = ErrorProcessEnum.Abort;
                _service.Result = Result;
                this.DialogResult = DialogResult.OK;
                StopWarn();
            }
            catch (Exception ex)
            {
                Logger.Log.Error("ʧܣ" + ex.ToString());
                MessageBox.Show("ʧܣԣ");
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //if (DialogResult.OK != MessageBox.Show("ƱѾˣֻ֪ͨʧܣҪ֪ͨô", "ȷ", MessageBoxButtons.OKCancel))
            //{
            //    return;
            //}
            Logger.Log.Info("ʼ֪ͨƱ...");
            try
            {
                A10002NotifyTicket pack = new A10002NotifyTicket();
                pack.AgentId = _service.LotMachine.MachineInfo.M_Number;
                pack.Salt = _service.LotMachine.MachineInfo.M_Salt;
                pack.Ticket = _ticket;
                A10002NotifyTicketRet packRet = PackManager.Instance.Send(pack) as A10002NotifyTicketRet;
                if (packRet.Code <= 0)
                {
                    throw new Exception("Ʊ֪ͨʧܣ" + packRet.Code.ToString() + " " + packRet.Message);
                }
                
                MessageBox.Show("Ʊ֪ͨɹ");

                //ɾlastĿ¼һļ
                _service.LotMachine.VirtualPrinter.DeleteLastFile();

                _service.TotalMoney += _ticket.L_Money;
                _service.TotalTicket += 1;

                _service.Stop();
                _service.OnPrinted(_ticket);
                _service.Wait4Job.Set();
                Result = ErrorProcessEnum.Abort;
                _service.Result = Result;
                this.DialogResult = DialogResult.OK;
                StopWarn();
            }
            catch (Exception ex)
            {
                Logger.Log.Error("Ʊ֪ͨʧܣ"+ex.ToString());
                MessageBox.Show("Ʊ֪ͨʧܣ֪ͨԼΣ");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                //ȡƱ
                A10002NotifyTicket pack = new A10002NotifyTicket();
                pack.AgentId = _service.LotMachine.MachineInfo.M_Number;
                pack.Salt = _service.LotMachine.MachineInfo.M_Salt;
                _ticket.L_Status = 100;
                _ticket.L_LimitType = 0;
                _ticket.L_SucTime = DateTime.Now;
                pack.Ticket = _ticket;
                A10002NotifyTicketRet packRet = PackManager.Instance.Send(pack) as A10002NotifyTicketRet;
                if (packRet.Code <= 0)
                {
                    throw new Exception("򱨴Ѹı䡿ȡƱʧܣ" + packRet.Code.ToString() + " " + packRet.Message);
                }
                else
                {
                    Logger.Log.Info("򱨴Ѹı䡿ȡƱɹ");
                }


                _service.ClearError((int)MachineErrorType.JlConditionChange);
                Logger.Log.Info("򱨴Ѹı䡿ƱָƱ");

                _service.UpdateMachineStatus(MachineStatusEnum.Printing);
                //_service.RePrint(_ticket);
                _service.Wait4Job.Set();
                Result = ErrorProcessEnum.Ignore;
                _service.Result = Result;
                this.DialogResult = DialogResult.OK;
                StopWarn();
                Logger.Log.Info("򱨴Ѹı䡿ָƱ");
            }
            catch (Exception ex)
            {
                Logger.Log.Error("򱨴Ѹı䡿ʧܣ"+ex.ToString());
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK != MessageBox.Show("ƱǴƱȷϵô", "ȷ", MessageBoxButtons.OKCancel))
            {
                this.DialogResult = DialogResult.None;
                return;
            }

            //̴߳Ʊȷϵ
            new Thread(BigTicketAlertThread).Start();
        }

        delegate void uiDelegate(); // ίд
        private void BigTicketAlertThread()
        {
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            keycodeList.Add(new KeycodeInfo("enter", 300));                     //ʵ֤Ʊȷϵ㲻ֻĬϵ5Զʧ
            _service.LotMachine.VirtualKeyboard.Input(keycodeList);

            Thread.Sleep(3000);

            this.BeginInvoke(new uiDelegate(clickReGetData));
        }

        private void clickReGetData()
        {
            btnReGetdata.PerformClick();
        }
    }
}