using System;
using System.Collections.Generic;
using System.Net.Mime;
using System.Threading;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.AutoPrint.Machine.Printer;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using log4net;

namespace ChuPiao.AutoPrint.Machine
{
    public abstract class BaseLotMachine:ILotMachine
    {
        private L_LotTicketEntity _lastSucTicket = null;

        /// <summary>
        /// һųɹƱ
        /// </summary>
        public L_LotTicketEntity LastSucTicket
        {
            get { return _lastSucTicket; }
            set { _lastSucTicket = value; }

        }

        private L_LotTicketEntity _currentTicket=null;

        /// <summary>
        /// ǰƱ
        /// </summary>
        public L_LotTicketEntity CurrentTicket
        {
            get { return _currentTicket; }
            set { _currentTicket = value; }
        }


        #region Implementation of ILotMachine

        private ILog _log;

        private M_MachineEntity _machineInfo;

        private IVirtualKeyboard _virtualKeyboard;


        private IVirtualPrinter _virtualPrinter;
        private bool _isPrintedTest = false;
        private M_MachineModeConfigEntity _macCurrentMode;
        private IPrinterClient _printerClient;

        private R_MachineReportEntity _lastMachineReport;

        private bool _lastEncashSuc=false;

        /// <summary>
        /// ǰڵͶעģʽ
        /// </summary>
        public M_MachineModeConfigEntity MacCurrentMode
        {
            get { return _macCurrentMode; }
            set { _macCurrentMode = value; }
        }

        private string _macCurrentExpect;
        /// <summary>
        /// ǰ
        /// </summary>
        public string MacCurrentExpect
        {
            get { return _macCurrentExpect; }
            set { _macCurrentExpect = value; }
        }

        /// <summary>
        /// ־¼
        /// </summary>
        public ILog Log
        {
            get { return _log; }
            set { _log = value; }
        }

        /// <summary>
        /// ƱϢ
        /// </summary>
        public M_MachineEntity MachineInfo
        {
            get { return _machineInfo; }
            set { _machineInfo = value; }
        }

        /// <summary>
        /// ģ̣ߣ
        /// </summary>
        public IVirtualKeyboard VirtualKeyboard
        {
            get { return _virtualKeyboard; }
            set { _virtualKeyboard = value; }
        }


        /// <summary>
        /// ģӡӡģ飩
        /// </summary>
        public IVirtualPrinter VirtualPrinter
        {
            get { return _virtualPrinter; }
            set { _virtualPrinter = value; }
        }

        /// <summary>
        /// Ʊӡ
        /// </summary>
        public IPrinterClient PrinterClient
        {
            get { return _printerClient; }
            set { _printerClient=value; }
        }

        /// <summary>
        /// ǷѴӡƱ
        /// </summary>
        public bool IsPrintedTest
        {
            get { return _isPrintedTest; }
            set { _isPrintedTest=value; }
        }

        /// <summary>
        /// 淨ӳ
        /// </summary>
        public abstract Dictionary<int, M_LotPlayModeMapEntity> LotPlayMap { get; }

        /// <summary>
        /// һλ
        /// </summary>
        public R_MachineReportEntity LastMachineReport
        {
            get { return _lastMachineReport; }
            set { _lastMachineReport = value; }
        }

        /// <summary>
        /// һζҽǷɹ
        /// </summary>
        public bool LastEncashSuc
        {
            get { return _lastEncashSuc; }
            set { _lastEncashSuc = value; }
        }

        /// <summary>
        /// Ʊֵ
        /// </summary>
        public abstract void Recharge(int money);

        /// <summary>
        /// Ʊʼ
        /// </summary>
        public abstract void Initialize();

        /// <summary>
        /// 
        /// </summary>
        public abstract void StartDriver();

        /// <summary>
        /// ֹͣ
        /// </summary>
        public abstract void StopDriver();

        /// <summary>
        /// 
        /// </summary>
        public abstract void ReStartDriver();

        /// <summary>
        /// ӡָƱ
        /// </summary>
        public abstract void Print(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData);

        /// <summary>
        /// ԵƱ
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="decodePrintData"></param>
        public abstract void TestDecodeTicket(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData);

        /// <summary>
        /// »ȡ
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="decodePrintData"></param>
        public abstract void ReGetdata(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData);

        /// <summary>
        /// ȡƱ
        /// </summary>
        /// <returns></returns>
        public abstract CaptureDataInfo GetCacheTicket();

        /// <summary>
        /// ȡһƱ
        /// </summary>
        /// <returns></returns>
        public abstract CaptureDataInfo GetLastTicket();

        /// <summary>
        /// ǿֹͣǰƱ
        /// </summary>
        public void ForceStop()
        {
            VirtualPrinter.ForceStop();
        }

        /// <summary>
        /// ҽָƱ
        /// </summary>
        /// <param name="ticketEntity"></param>
        public abstract void Encash(L_LotTicketEntity ticketEntity);

        /// <summary>
        /// ӡɿ
        /// </summary>
        /// <param name="isPaperOut">Ƿֽ</param>
        /// <param name="decodePrintData"></param>
        public abstract void PrintPayMoneyReport(DecodeMachinePayMoneyReport decodePrintData, bool isPaperOut);

        /// <summary>
        /// ӡ
        /// </summary>
        /// <returns></returns>
        public abstract void PrintReport(DateTime startTime, DateTime endTime, DecodeMachineReport decodePrintData, bool isPaperOut);

        /// <summary>
        /// ӡʻ
        /// </summary>
        /// <returns></returns>
        public abstract void PrintJcReport(DateTime startTime, DateTime endTime, DecodeMachineReport decodePrintData, bool isPaperOut);

        /// <summary>
        /// ӡ챨
        /// </summary>
        /// <param name="decodePrintData"></param>
        public abstract void PrintCurrentDayReport(DecodeMachineReport decodePrintData, bool isPaperOut);

        /// <summary>
        /// ӡ淨
        /// </summary>
        /// <returns></returns>
        public abstract void PrintPlayReport(M_PlayTypeEntity playTypeEntity, DateTime startTime, DateTime endTime, DecodeMachinePlayReport decodePrintData, bool isPaperOut);

        /// <summary>
        /// 鿴н
        /// </summary>
        /// <param name="ticketEntity"></param>
        public abstract void ViewPrizeMoney(L_LotTicketEntity ticketEntity);

        /// <summary>
        /// ¼Ʊ
        /// </summary>
        public abstract void Login();

        /// <summary>
        /// رղƱ
        /// </summary>
        public abstract void Shutdown();

        /// <summary>
        /// ӡƱ
        /// </summary>
        public abstract CaptureDataInfo PrintTestTicket(bool isPaperOut);

        /// <summary>
        /// ӡϢ
        /// </summary>
        public abstract CaptureDataInfo PrintMatch(int lotId);

        /// <summary>
        /// ӡʶϢ
        /// </summary>
        /// <param name="lotId">ʲid</param>
        /// <param name="index">1-ǰڣ2-һڣ3-</param>
        /// <returns></returns>
        public abstract CaptureDataInfo PrintZcMatch(int lotId, int index);

        /// <summary>
        /// ӡ
        /// </summary>
        public abstract CaptureDataInfo PrintOpenCodeReport(int lotId);

        /// <summary>
        /// Ʊϼƽ
        /// </summary>
        /// <returns>Ƿɹ</returns>
        public abstract void ClearMahineMoney();

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="errorType"></param>
        public abstract void ClearError(int errorType);

        /// <summary>
        /// ƱѸ¡ʣ
        /// </summary>
        public abstract void ClearExpectUpdate();

        /// <summary>
        /// ˢ»
        /// </summary>
        /// <returns></returns>
        public abstract void RefreshMahineMoney();

        /// <summary>
        /// ˢ¹㲥Ϣ
        /// </summary>
        /// <returns></returns>
        public abstract void RefreshMahineBroadcast();

        /// <summary>
        /// սݻ
        /// </summary>
        public void ClearBuffer()
        {
            try
            {
                VirtualPrinter.ClearBuffer();
                Log.Debug("սݻ");
            }
            catch (Exception exception)
            {
                Log.Info(string.Concat("սݻ쳣Ϣ", exception.Message));
            }
        }

        /// <summary>
        /// ͼ
        /// </summary>
        /// <param name="keycodeInfoList"></param>
        public void SendKeys(List<KeycodeInfo> keycodeInfoList)
        {
            try
            {
                //VirtualPrinter.ClearBuffer();
                VirtualKeyboard.Input(keycodeInfoList);
            }
            catch (Exception exception)
            {
                Log.Info(string.Concat("ͼ쳣Ϣ",exception.Message));
            }
            
        }

        /// <summary>
        /// мʱ
        /// </summary>
        /// <param name="keycodeInfoList"></param>
        public int SendKeysTime(List<KeycodeInfo> keycodeInfoList)
        {
            int time = 0;
            foreach(KeycodeInfo keycode in keycodeInfoList)
            {
                time += keycode.SendInterval;
            }
            return time;
        }

        /// <summary>
        /// ȡ
        /// </summary>
        /// <returns></returns>
        public CaptureDataInfo GetData()
        {
            CaptureDataInfo captureDataInfo = new CaptureDataInfo(new byte[] { });
            try
            {
                captureDataInfo=VirtualPrinter.Output();
            }
            catch (Exception exception)
            {
                Log.Info(string.Concat("ȡ쳣Ϣ", exception.Message));
            }
            return captureDataInfo;
        }

        /// <summary>
        /// лǰ淨
        /// </summary>
        /// <param name="ticketEntity"></param>
        public abstract void SetCurrentLotPlayMode(L_LotTicketEntity ticketEntity);

        /// <summary>
        /// ض
        /// </summary>
        public abstract void ReturnTopGui();

        /// <summary>
        /// 棨ʣ
        /// </summary>
        public abstract void EnterSaleGui();

        /// <summary>
        /// Ʊ
        /// </summary>
        public event EventHandler<TicketEventArgs> Printing;
        /// <summary>
        /// Ʊ
        /// </summary>
        public event EventHandler<TicketEventArgs> Printed;
        /// <summary>
        /// ҽ
        /// </summary>
        public event EventHandler<TicketEventArgs> Encashing;
        /// <summary>
        /// ҽ
        /// </summary>
        public event EventHandler<TicketEventArgs> Encashed;

        public virtual void OnPrinting(L_LotTicketEntity ticketEntity)
        {
            EventHandler<TicketEventArgs> handler = Printing;
            if (handler != null)
            {
                handler(this, new TicketEventArgs(ticketEntity));
            }
        }
        public virtual void OnPrinted(L_LotTicketEntity ticketEntity)
        {
            EventHandler<TicketEventArgs> handler = Printed;
            if (handler != null)
            {
                handler(this, new TicketEventArgs(ticketEntity));
            }
        }

        public virtual void OnEncashing(L_LotTicketEntity ticketEntity)
        {
            EventHandler<TicketEventArgs> handler = Encashing;
            if (handler != null)
            {
                handler(this, new TicketEventArgs(ticketEntity));
            }
        }
        public virtual void OnEncashed(L_LotTicketEntity ticketEntity)
        {
            EventHandler<TicketEventArgs> handler = Encashed;
            if (handler != null)
            {
                handler(this, new TicketEventArgs(ticketEntity));
            }
        }
        //public virtual void OnStatusChanged(MachineStatusEnum machineStatus)
        //{
        //    EventHandler<MachineStatusArgs> handler = StatusChanged;
        //    if (handler != null)
        //    {
        //        handler(this, new MachineStatusArgs(machineStatus));
        //    }
        //}

        #endregion

        private List<int> _fuShiModeList = null;
        protected List<int> FuShiModeList
        {
            get
            {
                if (_fuShiModeList == null)
                {
                    _fuShiModeList = new List<int>();
                    _fuShiModeList.AddRange(new int[] { 6010102, 6011102, 6020102, 6030102, 7010102, 7010103, 7011102, 7011103, 7012102, 7020102, 7020103, 7020104, 7020105, 7020106, 7021103, 7021202, 7021204, 7021205, 7022202, 7022204, 7022205, 7025202, 7040102, 7050102 });

                }
                return _fuShiModeList;
            }
        }

        private List<int> _fuShiPlayList = null;
        protected  List<int> FuShiPlayList
        {
            get
            {
                if (_fuShiPlayList == null)
                {
                    _fuShiPlayList=new List<int>();
                    _fuShiPlayList.AddRange(new int[] { 70502, 70402, 70302, 70202,70203, 70212, 70222, 70232, 70206, 70204, 70214, 70224, 70205, 70215, 70225, 70102, 70103, 70112, 70113, 70122, 60302, 60202, 60102, 60112 });
                }
                return _fuShiPlayList;
            }
        }

        protected void Wait(int wait)
        {
            Log.Info(string.Concat("ȴ ", wait, " "));
            while (wait > 0)
            {
                wait -= 100;
                Thread.Sleep(100);
                if (MachineInfo.M_Status != (int)MachineStatusEnum.Printing)
                {
                    break;
                }
            }
        }

        protected void Wait2(int wait)
        {
            Log.Info(string.Concat("ȴ", wait, ""));
            Thread.Sleep(wait);
            //while (wait > 0)
            //{
            //    wait -= 100;
            //    Thread.Sleep(100);
            //    if (MachineInfo.M_Status == (int)MachineStatusEnum.Stopping)
            //    {
            //        break;
            //    }
            //}
            
        }



    }
}
