using System;
using System.Collections.Generic;
using System.IO.Ports;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using log4net;

namespace ChuPiao.AutoPrint.Machine
{
    public abstract class BaseVirtualKeyboard:IVirtualKeyboard
    {
        #region Implementation of IVirtualKeyboard

        private VirtualKeyboardStatus _status;

        private ILog _log;

        private SerialPort _keyboardPort;

        private KeyboardType _keyboardType;

        private M_MachineEntity _machineInfo;

        private string _port;

        private int _portBps;

        private bool _isSend = false;

        private SortedDictionary<string, M_KeycodeConfigEntity> _keycodeDictionary;

        private KeycodeInfo _clearScreenSaverKeycode;

        private Queue<KeycodeInfo> _waitSendKeycodeQueue;

        /// <summary>
        /// ״̬
        /// </summary>
        public VirtualKeyboardStatus Status
        {
            get { return _status; }
            set { _status=value; }
        }

        /// <summary>
        /// ־¼
        /// </summary>
        public ILog Log
        {
            get { return _log; }
            set { _log = value; }
        }

        /// <summary>
        /// ˿
        /// </summary>
        public SerialPort KeyboardPort
        {
            get { return _keyboardPort; }
            set { _keyboardPort = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public KeyboardType KeyboardType
        {
            get { return _keyboardType; }
            set { _keyboardType = value; }
        }

        /// <summary>
        /// ʵ
        /// </summary>
        public SortedDictionary<string, M_KeycodeConfigEntity> KeycodeDictionary
        {
            get { return _keycodeDictionary; }
            set { _keycodeDictionary = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public KeycodeInfo ClearScreenSaverKeycode
        {
            get { return _clearScreenSaverKeycode; }
            set { _clearScreenSaverKeycode=value; }
        }

        /// <summary>
        /// ȴ͵ļ
        /// </summary>
        public Queue<KeycodeInfo> WaitSendKeycodeQueue
        {
            get { return _waitSendKeycodeQueue; }
            set { _waitSendKeycodeQueue=value; }
        }

        /// <summary>
        /// ƱϢ
        /// </summary>
        public M_MachineEntity MachineInfo
        {
            get { return _machineInfo; }
            set { _machineInfo = value; }
        }

        /// <summary>
        /// ˿ں
        /// </summary>
        public string Port
        {
            get { return _port; }
            set { _port = value; }
        }

        /// <summary>
        /// ˿ڲ
        /// </summary>
        public int PortBps
        {
            get { return _portBps; }
            set { _portBps = value; }
        }
        /// <summary>
        /// Ƿ
        /// </summary>
        public bool IsSend
        {
            get { return _isSend; }
            set { _isSend = value; }
        }

        /// <summary>
        /// ʼ
        /// </summary>
        public abstract void Initialize();

        /// <summary>
        /// 
        /// </summary>
        public abstract void Start();

        /// <summary>
        /// ֹͣ
        /// </summary>
        public abstract void Stop();

        /// <summary>
        /// 
        /// </summary>
        public abstract void Input(List<KeycodeInfo> keycodeInfo);

        #endregion

        #region 
        #endregion
    }
}
