using System;
using System.Collections.Generic;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.AutoPrint.Machine.Printer;
using ChuPiao.Common.Models;
using log4net;

namespace ChuPiao.AutoPrint.Machine
{
    /// <summary>
    /// Ʊӿ
    /// </summary>
    public interface ILotMachine
    {
        L_LotTicketEntity CurrentTicket { get;set;}

        #region 
        /// <summary>
        /// ־¼
        /// </summary>
        ILog Log { get; set; }
        /// <summary>
        /// ǰͶעģʽ
        /// </summary>
        M_MachineModeConfigEntity MacCurrentMode { get; set; }
        /// <summary>
        /// ǰ
        /// </summary>
        string MacCurrentExpect { get; set; }
        /// <summary>
        /// ƱϢ
        /// </summary>
        M_MachineEntity MachineInfo { get; set; }
        /// <summary>
        /// ģ̣ߣ
        /// </summary>
        IVirtualKeyboard VirtualKeyboard { get; set; }

        /// <summary>
        /// ģӡӡģ飩
        /// </summary>
        IVirtualPrinter VirtualPrinter { get; set; }

        /// <summary>
        /// Ʊӡ
        /// </summary>
        IPrinterClient PrinterClient { get; set; }
        /// <summary>
        /// ǷѴӡƱ
        /// </summary>
        bool IsPrintedTest { get; set; }

        /// <summary>
        /// 淨ӳ
        /// </summary>
        Dictionary<int, M_LotPlayModeMapEntity> LotPlayMap { get; }

        /// <summary>
        /// һλ
        /// </summary>
        R_MachineReportEntity LastMachineReport { get; set; }

        /// <summary>
        /// һζҽǷɹ
        /// </summary>
        bool LastEncashSuc { get; set; }
        #endregion

        /// <summary>
        /// Ʊֵ
        /// </summary>
        void Recharge(int money);

        #region 
        /// <summary>
        /// Ʊʼ
        /// </summary>
        void Initialize();

        /// <summary>
        /// 
        /// </summary>
        void StartDriver();

        /// <summary>
        /// ֹͣ
        /// </summary>
        void StopDriver();

        /// <summary>
        /// 
        /// </summary>
        void ReStartDriver();

        /// <summary>
        /// ӡָƱ
        /// </summary>
        void Print(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData);

        /// <summary>
        /// ԵƱ
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="decodePrintData"></param>
        void TestDecodeTicket(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData);

        /// <summary>
        /// »ȡ
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="decodePrintData"></param>
        void ReGetdata(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData);

        /// <summary>
        /// ȡƱ
        /// </summary>
        /// <returns></returns>
        CaptureDataInfo GetCacheTicket();
        /// <summary>
        /// ȡһƱ
        /// </summary>
        /// <returns></returns>
        CaptureDataInfo GetLastTicket();

        /// <summary>
        /// ǿֹͣǰƱ
        /// </summary>
        void ForceStop();

        /// <summary>
        /// ҽָƱ
        /// </summary>
        /// <param name="ticketEntity"></param>
        void Encash(L_LotTicketEntity ticketEntity);

        /// <summary>
        /// ӡɿ
        /// </summary>
        /// <returns></returns>
        void PrintPayMoneyReport(DecodeMachinePayMoneyReport decodePrintData, bool isPaperOut);
        /// <summary>
        /// ӡ
        /// </summary>
        /// <returns></returns>
        void PrintReport(DateTime startTime, DateTime endTime, DecodeMachineReport decodePrintData, bool isPaperOut);
        /// <summary>
        /// ӡʻ
        /// </summary>
        /// <returns></returns>
        void PrintJcReport(DateTime startTime, DateTime endTime, DecodeMachineReport decodePrintData, bool isPaperOut);

        /// <summary>
        /// ӡ챨
        /// </summary>
        /// <param name="decodePrintData"></param>
        void PrintCurrentDayReport(DecodeMachineReport decodePrintData, bool isPaperOut);
        /// <summary>
        /// ӡ淨
        /// </summary>
        /// <returns></returns>
        void PrintPlayReport(M_PlayTypeEntity playTypeEntity, DateTime startTime, DateTime endTime, DecodeMachinePlayReport decodePrintData, bool isPaperOut);

        /// <summary>
        /// 鿴н
        /// </summary>
        /// <param name="ticketEntity"></param>
        void ViewPrizeMoney(L_LotTicketEntity ticketEntity);

        /// <summary>
        /// ¼Ʊ
        /// </summary>
        void Login();

        /// <summary>
        /// رղƱ
        /// </summary>
        void Shutdown();

        /// <summary>
        /// ӡƱ
        /// </summary>
        CaptureDataInfo PrintTestTicket(bool isPaperOut);

        /// <summary>
        /// ӡϢ
        /// </summary>
        CaptureDataInfo PrintMatch(int lotId);

        /// <summary>
        /// ӡʶϢ
        /// </summary>
        /// <param name="lotId">ʲid</param>
        /// <param name="index">1-ǰڣ2-һڣ3-</param>
        /// <returns></returns>
        CaptureDataInfo PrintZcMatch(int lotId, int index);

        /// <summary>
        /// ӡ
        /// </summary>
        CaptureDataInfo PrintOpenCodeReport(int lotId);

        /// <summary>
        /// Ʊϼƽ
        /// </summary>
        /// <returns>Ƿɹ</returns>
        void ClearMahineMoney();

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="errorType"></param>
        void ClearError(int errorType);

        /// <summary>
        /// ƱѸ¡ʣ
        /// </summary>
        void ClearExpectUpdate();

        /// <summary>
        /// ˢ»
        /// </summary>
        /// <returns></returns>
        void RefreshMahineMoney();
        /// <summary>
        /// ˢ¹㲥Ϣ
        /// </summary>
        /// <returns></returns>
        void RefreshMahineBroadcast();

        /// <summary>
        /// սݻ
        /// </summary>
        void ClearBuffer();

        /// <summary>
        /// ͼ
        /// </summary>
        /// <param name="keycodeInfoList"></param>
        void SendKeys(List<KeycodeInfo> keycodeInfoList);

        /// <summary>
        /// ȡ
        /// </summary>
        /// <returns></returns>
        CaptureDataInfo GetData();

        /// <summary>
        /// лǰ淨
        /// </summary>
        /// <param name="ticketEntity"></param>
        void SetCurrentLotPlayMode(L_LotTicketEntity ticketEntity);

        /// <summary>
        /// ض棨ֲʣ
        /// </summary>
        void ReturnTopGui();

        /// <summary>
        /// 棨ʣ
        /// </summary>
        void EnterSaleGui();
        #endregion

        #region ¼
        /// <summary>
        /// Ʊ
        /// </summary>
        event EventHandler<TicketEventArgs> Printing;
        /// <summary>
        /// Ʊ
        /// </summary>
        event EventHandler<TicketEventArgs> Printed;
        /// <summary>
        /// ҽ
        /// </summary>
        event EventHandler<TicketEventArgs> Encashing;
        /// <summary>
        /// ҽ
        /// </summary>
        event EventHandler<TicketEventArgs> Encashed;
        /// <summary>
        /// ״̬仯
        /// </summary>
        //event EventHandler<MachineStatusArgs> StatusChanged;

        #endregion
    }
}
