﻿using System.Collections.Generic;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Models;

namespace ChuPiao.AutoPrint.Machine
{
    /// <summary>
    /// 彩种玩法投注模式（键码发送、电子票解析）
    /// </summary>
    public interface IMacLotPlayModeService
    {
        /// <summary>
        /// 机器投注模式配置信息
        /// </summary>
        //M_MachineModeConfigEntity MachineModeConfig { get; set; }


        /// <summary>
        /// 获取大额票密码的键码
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="machineEntity"></param>
        /// <returns></returns>
        List<KeycodeInfo> GetPasswordKeycodeList(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity);

        /// <summary>
        /// 获得投注需要发送的键码列表
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="machineEntity"></param>
        /// <returns></returns>
        List<KeycodeInfo> GetSendKeycodeList(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity);

        /// <summary>
        /// 电子票解析
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="machineEntity"></param>
        /// <param name="decodePrintData"></param>
        void DecodeData(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity, DecodePrintData decodePrintData);
    }
}
