using System.Collections.Generic;
using System.IO.Ports;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using log4net;

namespace ChuPiao.AutoPrint.Machine
{
    public enum VirtualKeyboardStatus
    {
        Running,
        Stopping,
        Stopped,
        Exception
    }
    /// <summary>
    /// ģ̣ߣӿ
    /// </summary>
    public interface IVirtualKeyboard
    {
        #region 
        /// <summary>
        /// ״̬
        /// </summary>
        VirtualKeyboardStatus Status { get; set; }

        /// <summary>
        /// ־¼
        /// </summary>
        ILog Log { get; set; }

        /// <summary>
        /// ˿
        /// </summary>
        SerialPort KeyboardPort { get; set; }
        /// <summary>
        /// 
        /// </summary>
        KeyboardType KeyboardType { get; set; }

        /// <summary>
        /// ʵ
        /// </summary>
        SortedDictionary<string, M_KeycodeConfigEntity> KeycodeDictionary { get; set; }

        /// <summary>
        /// 
        /// </summary>
        KeycodeInfo ClearScreenSaverKeycode { get; set; }

        /// <summary>
        /// ȴ͵ļ
        /// </summary>
        Queue<KeycodeInfo> WaitSendKeycodeQueue { get; set; }

        /// <summary>
        /// ƱϢ
        /// </summary>
        M_MachineEntity MachineInfo { get; set; }

        /// <summary>
        /// ˿ں
        /// </summary>
        string Port { get; set; }
        /// <summary>
        /// ˿ڲ
        /// </summary>
        int PortBps { get; set; }

        /// <summary>
        /// Ƿ
        /// </summary>
        bool IsSend { get; set; }

        #endregion

        #region 
        /// <summary>
        /// ʼ
        /// </summary>
        void Initialize();

        /// <summary>
        /// 
        /// </summary>
        void Start();

        /// <summary>
        /// ֹͣ
        /// </summary>
        void Stop();

        /// <summary>
        /// 
        /// </summary>
        void Input(List<KeycodeInfo> keycodeInfo);

        #endregion
    }
}
