using System.IO.Ports;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.AutoPrint.Machine.Printer;
using ChuPiao.Common.Models;
using log4net;

namespace ChuPiao.AutoPrint.Machine
{
    public enum VirtualPrinterStatus
    {
        Running,
        Stopping,
        Stopped,
        Exception
    }
    public interface IVirtualPrinter
    {
        #region 
        /// <summary>
        /// ӡ״̬
        /// </summary>
        VirtualPrinterStatus Status { get; set; }
        /// <summary>
        /// ־¼
        /// </summary>
        ILog Log { get; set; }
        /// <summary>
        /// ־·־вƱĵƱļȶ·棬ʽ磺C:\example\
        /// </summary>
        string LogPath { get;set;}
        /// <summary>
        /// ˿
        /// </summary>
        SerialPort PrinterPort { get; set; }
        /// <summary>
        /// ˿ں
        /// </summary>
        string Port { get; set; }
        /// <summary>
        /// ˿ڲ
        /// </summary>
        int PortBps { get; set; }

        /// <summary>
        /// ƱϢ
        /// </summary>
        M_MachineEntity MachineInfo { get; set; }
        /// <summary>
        /// 
        /// </summary>
        ILotMachine LotMachine { get;set;}
        /// <summary>
        /// Ʊӡ
        /// </summary>
        IPrinterClient PrinterClient { get; set; }

        #endregion

        #region 
        /// <summary>
        /// ʼ
        /// </summary>
        void Initialize();

        /// <summary>
        /// 
        /// </summary>
        void Start();

        /// <summary>
        /// ֹͣ
        /// </summary>
        void Stop();

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <returns></returns>
        CaptureDataInfo Output();

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <returns></returns>
        CaptureDataInfo ReOutput();



        /// <summary>
        /// ǿֹͣǰƱ
        /// </summary>
        void ForceStop();

        /// <summary>
        /// սջ
        /// </summary>
        void ClearBuffer();

        /// <summary>
        /// ӡ
        /// </summary>
        int LastPrintCounter { get; set; }

        /// <summary>
        /// Ĵӡļ·
        /// </summary>
        string LastPrintFilePath { get; set; }

        void SaveLastFile(byte[] captureDataBytes);

        void DeleteLastFile();

        #endregion
    }
}
