using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Core.Utils;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;

namespace ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacLotPlayMode
{
    /// <summary>
    /// С
    /// </summary>
    public class MacLotPlayModeJlDxfService : MacLotPlayModeService
    {
        public MacLotPlayModeJlDxfService()
        {
            PlayFullName = "С";
        }
        #region Overrides of MacLotPlayModeService

        /// <summary>
        /// ͶעģʽϢ
        /// </summary>
        /// <summary>
        /// ͶעҪ͵ļб
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="machineEntity"></param>
        /// <returns></returns>
        public override List<KeycodeInfo> GetSendKeycodeList(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity)
        {
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ʼÿζҪ淨Ͷע
            keycodeList.AddRange(GetInitKeycodeList(machineModeConfig));

            //Ͷע
            List<JcCodeEntity> codeList = DealPrintCode(ticketEntity.L_Code);
            foreach (JcCodeEntity jcCodeEntity in codeList)
            {
                //볡ѡ
                //keycodeList.Add(new KeycodeInfo(WeekInitKey, machineModeConfig.C_SendKeyInterval));
                //ѡ񳡴
                for (int i = 0; i < jcCodeEntity.ChangCi.Length; i++)
                {
                    keycodeList.Add(new KeycodeInfo(jcCodeEntity.ChangCi.Substring(i, 1), machineModeConfig.C_SendKeyInterval));
                }
                //ѡͶע
                foreach (string s in jcCodeEntity.OneCodeList)
                {
                    keycodeList.Add(new KeycodeInfo(s, machineModeConfig.C_SendKeyInterval));
                }
                //Ͷעȷ
                keycodeList.Add(new KeycodeInfo(ResultEnterKey, machineModeConfig.C_SendKeyInterval));
            }

            //Ͷ
            if (ticketEntity.L_Mutiple > 1)
            {
                keycodeList.AddRange(GetMultipleKeycodeList(ticketEntity.L_Mutiple, machineModeConfig));
            }

            //طʽ
            keycodeList.AddRange(GetGuoGuanKeycodeList(ticketEntity.L_CodeType, machineModeConfig));

            //ӡȷ
            keycodeList.Add(new KeycodeInfo(machineModeConfig.C_PrintConfirmKey, machineModeConfig.C_PrintConfirmKeyInterval));

            //Ƿ
            keycodeList.AddRange(GetPasswordKeycodeList(ticketEntity, machineEntity, machineModeConfig));

            return keycodeList;
        }

        /// <summary>
        /// Ͷע
        /// </summary>
        /// <param name="code"></param>
        /// <returns></returns>
        protected List<JcCodeEntity> DealPrintCode(string code)
        {
            List<JcCodeEntity> codeList = new List<JcCodeEntity>();
            string[] changCiCodeArr = code.Split(CodeSplitStr.ToCharArray()); //ʾжٳ
            foreach (string changCiCode in changCiCodeArr)
            {
                JcCodeEntity jcCodeEntity = new JcCodeEntity();

                string[] arr = changCiCode.Split(MatchCodeSplitStr.ToCharArray());

                jcCodeEntity.ChangCi = arr[0];
                string s = arr[1].Replace("[", "").Replace("]", "");
                string[] oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                jcCodeEntity.OneCodeList.AddRange(oneMatchCodeArr);
                codeList.Add(jcCodeEntity);
            }
            return codeList;

        }
        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="machineEntity"></param>
        /// <param name="decodePrintData"></param>
        /// <param name="ticketEntity"></param>
        public override void DecodeData(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity, DecodePrintData decodePrintData)
        {
            //M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ץȡķ
            decodePrintData.L_PrintTicketEntity.P_PrnText = TicketTextUtil.CompressAndEncrypt(decodePrintData.InputData.CaptureDataBytes);
            //decodePrintData.L_PrintTicketEntity.P_SucTime = DateTime.Now;

            string input = decodePrintData.InputData.CaptureDataString;
            //input = input.Replace("͸12035ڿ01+04+30+32+35 08+12", "");
            string strTemp;
            //Ʊš롢ںŽ
            bool suc = DecodeHeadJc(ticketEntity, machineEntity, decodePrintData);
            if (!suc)
            {
                decodePrintData.ErrorMessage = string.Format("ͷ{0}", decodePrintData.ErrorMessage);
                decodePrintData.DecodeSuccess = false;
                return;
            }

            Regex regex;
            Match match;

            #region Ͷע뼰
            List<string> dCodeList = new List<string>();
            List<string> dRateList = new List<string>();
            List<string> codeReferenceList = new List<string>(); //οʣˮλ  1301[÷, ÷]  1301[+8.5,+9.5]]/1302[+2.5,+3.5];
            //
            int startposition = input.IndexOf(decodePrintData.L_PrintTicketEntity.P_TicketCode) + 60;
            int endposition = input.IndexOf("Ʊ߿̶ܹ", startposition);
            strTemp = input.Substring(startposition, endposition - startposition);//Ͷעݵַ

            //2020.1.7 ַб ݵб滻֮ǰ
            strTemp = strTemp.Replace("̶Ԥܷ:", "Ԥܷ:");

            string[] tmpArr = strTemp.Split('\n');//Ͷעʱ
            regex = new Regex(@"(һ||||||)\d{3}");
            for (int i = 0; i < tmpArr.Length; i++)
            {
                strTemp = tmpArr[i].Trim();
                match = regex.Match(strTemp);
                if (match.Success)
                {
                    strTemp = match.Value;
                    string strChangCi = DealChangChi(strTemp);//ַ 磺1  002
                    //i++;//εһΪ÷ 磺÷:-8.5 ̶÷:-8.5

                    //ο
                    //strTemp = new Regex(@"Ԥܷ:\d{1,}\.\d{1,}\s{1,}̶Ԥܷ:\d{1,}\.\d{1,}").Match(tmpArr[i]).Value;
                    //strTemp = Regex.Replace(strTemp, @"\s{1,}", ",");
                    //string[] TmpArr_LF = strTemp.Split(',');
                    //if (TmpArr_LF.Length != 2)
                    //{
                    //    decodePrintData.ErrorMessage += string.Concat("Ԥܷд󣬻ȡַ", strTemp);
                    //    decodePrintData.DecodeSuccess = false;
                    //    return;
                    //}
                    //codeReferenceList.Add(string.Format("{0}{1}[{2},{3}]", strChangCi, MatchCodeSplitStr, TmpArr_LF[0].Trim().Replace("Ԥܷ:", ""), TmpArr_LF[1].Trim().Replace("̶Ԥܷ:", "")));
                    //ûиο
                    strTemp = new Regex(@"Ԥܷ:\d{1,}\.\d{1,}").Match(tmpArr[i]).Value;
                    if (string.IsNullOrEmpty(strTemp))
                    {
                        decodePrintData.ErrorMessage += string.Concat("Ԥܷд󣬻ȡַ", strTemp);
                        decodePrintData.DecodeSuccess = false;
                        return;
                    }
                    codeReferenceList.Add(string.Format("{0}{1}[{2},{3}]", strChangCi, MatchCodeSplitStr, " ", strTemp.Trim().Replace("Ԥܷ:", "")));


                    i++;//εһΪ 磺:Ī˹ƻͷ Vs Ͷ:϶Ͷ       
                    i++;//ƵһΪͶע 磺ʤ@2.540Ԫ
                    string tmpCodeStr = "";
                    //while (!new Regex(@"M\0!\0a\0").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))
                    //while (!new Regex(@"\d{1,}").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))   //2017-05-27 ظĳɳ
                    while (!new Regex(@"\d{1,}(|)").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))
                    {
                        //Ͷעݿж
                        if (tmpArr[i].IndexOf("@") > 0 || new Regex(@"\d{0,}.\d{1,}Ԫ").IsMatch(tmpArr[i]))     //е   3.650Ԫ
                        {
                            tmpCodeStr += tmpArr[i].Trim();
                        }
                        i++;

                        if (i >= tmpArr.Length)
                        {
                            break;
                        }
                    }
                    i--;
                    //if (ticketEntity.L_RateType == (int)JcRateType.Fixed)
                    //{
                        dRateList.Add(string.Format("{0}{1}[{2}]", strChangCi, MatchCodeSplitStr, DealRateCode(tmpCodeStr.Trim())));
                    //}
                    //else
                    //{
                    //    dCodeList.Add(string.Format("{0}{1}[{2}]", strChangCi, MatchCodeSplitStr, DealResultCode(tmpCodeStr.Trim())));
                    //}
                }
            }
            decodePrintData.L_PrintTicketEntity.L_CodeReference = string.Join(CodeSplitStr, codeReferenceList.ToArray());//
            //Ϲص
            decodePrintData.L_PrintTicketEntity.L_CodeRate = string.Join(CodeSplitStr, dRateList.ToArray());

            //Ͷע
            decodePrintData.L_PrintTicketEntity.P_Code = SplitRateDetailToCode(decodePrintData.L_PrintTicketEntity.L_CodeRate);
            #endregion

            decodePrintData.DecodeSuccess = true;
        }

        /// <summary>
        /// Ͷע
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealResultCode(string Istr)
        {
            string tmpstr = "";

            for (int i = 0; i < Istr.Length; i++)
            {
                switch (Istr.Substring(i, 1))
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "":
                        tmpstr += "1";
                        break;
                    case "С":
                        tmpstr += "2";
                        break;
                    default:
                        break;
                }
            }
            //ƱϵͶעַ 磺2,1  Ϊ 1,2  ʹûͶעͬ
            tmpstr = SortCodeText(CODE_SORT_DIECTIONRY, tmpstr);
            return tmpstr;

        }
        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCode(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^СԪ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "":
                        tmpstr += "1";
                        break;
                    case "С":
                        tmpstr += "2";
                        break;
                    case "Ԫ":
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }
            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY, tmpstr);
            return tmpstr;
        }
        //ֵ 1 ʾ  2 ʾС
        private const string CODE_SORT_DIECTIONRY = "1,2";
        #endregion
    }
}
