using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Core.Utils;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;

namespace ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacLotPlayMode
{
    /// <summary>
    /// Ϲ
    /// </summary>
    public class MacLotPlayModeJzHhggService : MacLotPlayModeService
    {
        public MacLotPlayModeJzHhggService()
        {
            PlayFullName = "Ϲ";
        }

        #region Overrides of MacLotPlayModeService

        /// <summary>
        /// ͶעģʽϢ
        /// </summary>
        /// <summary>
        /// ͶעҪ͵ļб
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="machineEntity"></param>
        /// <returns></returns>
        public override List<KeycodeInfo> GetSendKeycodeList(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity)
        {
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ʼÿζҪ淨Ͷע
            keycodeList.AddRange(GetInitKeycodeList(machineModeConfig));

            //Ͷע
            List<JcCodeEntity> codeList = DealPrintCode(ticketEntity.L_Code);
            foreach (JcCodeEntity jcCodeEntity in codeList)
            {
                //볡ѡ
                //keycodeList.Add(new KeycodeInfo(WeekInitKey, machineModeConfig.C_SendKeyInterval));
                //ѡ񳡴
                for (int i = 0; i < jcCodeEntity.ChangCi.Length; i++)
                {
                    keycodeList.Add(new KeycodeInfo(jcCodeEntity.ChangCi.Substring(i, 1), machineModeConfig.C_SendKeyInterval));
                }
                //ѡ񳡴ε淨
                switch (jcCodeEntity.PlayId)
                {
                    case 91101:
                        //keycodeList.Add(new KeycodeInfo("5", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("6", machineModeConfig.C_SendKeyInterval));
                        break;
                    case 91102:
                        //keycodeList.Add(new KeycodeInfo("5", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("2", machineModeConfig.C_SendKeyInterval));
                        break;
                    case 91103:
                        //keycodeList.Add(new KeycodeInfo("5", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("3", machineModeConfig.C_SendKeyInterval));
                        break;
                    case 91104:
                        //keycodeList.Add(new KeycodeInfo("5", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("4", machineModeConfig.C_SendKeyInterval));
                        break;
                    case 91106:
                        //keycodeList.Add(new KeycodeInfo("5", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("1", machineModeConfig.C_SendKeyInterval));
                        break;
                }


                //ѡͶע
                foreach (string s in jcCodeEntity.OneCodeList)
                {
                    keycodeList.Add(new KeycodeInfo(s, machineModeConfig.C_SendKeyInterval));
                }
                //Ͷעȷ
                keycodeList.Add(new KeycodeInfo(ResultEnterKey, machineModeConfig.C_SendKeyInterval));
            }

            //Ͷ
            if (ticketEntity.L_Mutiple > 1)
            {
                keycodeList.AddRange(GetMultipleKeycodeList(ticketEntity.L_Mutiple, machineModeConfig));
            }

            //طʽ
            keycodeList.AddRange(GetGuoGuanKeycodeList(ticketEntity.L_CodeType, machineModeConfig));

            //ӡȷ
            keycodeList.Add(new KeycodeInfo(machineModeConfig.C_PrintConfirmKey, machineModeConfig.C_PrintConfirmKeyInterval));

            //Ƿ
            keycodeList.AddRange(GetPasswordKeycodeList(ticketEntity, machineEntity, machineModeConfig));

            return keycodeList;
        }

        /// <summary>
        /// Ͷע
        /// </summary>
        /// <param name="code"></param>
        /// <returns></returns>
        protected List<JcCodeEntity> DealPrintCode(string code)
        {
            List<JcCodeEntity> codeList = new List<JcCodeEntity>();
            string[] changCiCodeArr = code.Split(CodeSplitStr.ToCharArray()); //ʾжٳ
            foreach (string changCiCode in changCiCodeArr)
            {
                JcCodeEntity jcCodeEntity = new JcCodeEntity();

                string[] arr = changCiCode.Split(MatchCodeSplitStr.ToCharArray());

                jcCodeEntity.ChangCi = arr[0];
                string[] arrPlayAndCode = arr[1].Split('[');
                jcCodeEntity.PlayId = int.Parse(arrPlayAndCode[0]);
                string s = arrPlayAndCode[1].Replace("]", "");

                string[] oneMatchCodeArr;
                switch (jcCodeEntity.PlayId)
                {
                    case 91106:
                    case 91101:
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        jcCodeEntity.OneCodeList.AddRange(oneMatchCodeArr);
                        break;
                    case 91102:
                        s = s.Replace("-", SplitStr);
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        foreach (string TmpStr_1 in oneMatchCodeArr)
                        {
                            switch (TmpStr_1)
                            {
                                case "ʤ":
                                    jcCodeEntity.OneCodeList.Add("9");
                                    jcCodeEntity.OneCodeList.Add("0");
                                    break;
                                case "ƽ":
                                    jcCodeEntity.OneCodeList.Add("9");
                                    jcCodeEntity.OneCodeList.Add("9");
                                    break;
                                case "":
                                    jcCodeEntity.OneCodeList.Add("0");
                                    jcCodeEntity.OneCodeList.Add("9");
                                    break;
                                default:
                                    jcCodeEntity.OneCodeList.AddRange(TmpStr_1.Split(':')); //ȥֺ
                                    break;
                            }

                        }
                        break;
                    case 91103:
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        jcCodeEntity.OneCodeList.AddRange(oneMatchCodeArr);
                        break;
                    case 91104:
                        s = s.Replace("-", SplitStr);
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        jcCodeEntity.OneCodeList.AddRange(oneMatchCodeArr);
                        break;
                }

                codeList.Add(jcCodeEntity);
            }
            return codeList;

        }

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="machineEntity"></param>
        /// <param name="decodePrintData"></param>
        /// <param name="ticketEntity"></param>
        public override void DecodeData(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity, DecodePrintData decodePrintData)
        {
            //M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ץȡķ
            decodePrintData.L_PrintTicketEntity.P_PrnText = TicketTextUtil.CompressAndEncrypt(decodePrintData.InputData.CaptureDataBytes);
            //decodePrintData.L_PrintTicketEntity.P_SucTime = DateTime.Now;

            string input = decodePrintData.InputData.CaptureDataString;
            string strTemp;
            //Ʊš롢ںŽ
            bool suc = DecodeHeadJc(ticketEntity, machineEntity, decodePrintData);
            if (!suc)
            {
                decodePrintData.ErrorMessage = string.Format("ͷ{0}", decodePrintData.ErrorMessage);
                decodePrintData.DecodeSuccess = false;
                return;
            }

            Regex regex;
            Match match;

            #region Ͷע뼰
            List<string> dCodeList = new List<string>();
            List<string> dRateList = new List<string>();
            List<string> codeReferenceList = new List<string>(); //ο
            //
            int startposition = input.IndexOf(decodePrintData.L_PrintTicketEntity.P_TicketCode) + 60;
            int endposition = input.IndexOf("Ʊ߿̶ܹ", startposition);
            strTemp = input.Substring(startposition, endposition - startposition);//Ͷעݵַ

            string[] tmpArr = strTemp.Split('\n');//Ͷעʱ
            regex = new Regex(@"(һ||||||)\d{3}\s{1,}(ʤƽ|ʤƽ|ȷ|ܽ|ȫʤƽ)");
            string line;
            Regex regexRq = new Regex(@":[\+-]\d{1,}");
            Match matchRq;
            for (int i = 0; i < tmpArr.Length; i++)
            {
                line = tmpArr[i].Trim();
                match = regex.Match(line);
                if (match.Success)
                {
                    //÷֣浽ολ  3  071 :+1
                    string strRq = "-0";
                    matchRq = regexRq.Match(line);
                    if (matchRq.Success)
                    {
                        strRq = matchRq.Value.Trim().Replace(":", "");
                    }

                    strTemp = match.Value;
                    strTemp = Regex.Replace(strTemp, @"\s{1,}", " ");
                    string[] arrChangCi = strTemp.Split(' ');
                    if (arrChangCi.Length != 2)
                    {
                        decodePrintData.ErrorMessage += string.Concat("ʳʧܣ", match.Value);
                        decodePrintData.DecodeSuccess = false;
                        return;
                    }
                    string strChangCi = DealChangChi(arrChangCi[0]);//ַ 磺1  002
                    int playIdOfRate = 0;
                    switch (arrChangCi[1])
                    {
                        case "ʤƽ":
                            playIdOfRate = 91106;
                            break;
                        case "ʤƽ":
                            playIdOfRate = 91101;
                            break;
                        case "ȷ":
                            playIdOfRate = 91102;
                            break;
                        case "ܽ":
                            playIdOfRate = 91103;
                            break;
                        case "ȫʤƽ":
                            playIdOfRate = 91104;
                            break;
                    }

                    codeReferenceList.Add(string.Format("{0}{1}{2}[{3}]", strChangCi, MatchCodeSplitStr, playIdOfRate, strRq));//ĳһε

                    i++;//εһΪ 磺:Ī˹ƻͷ Vs Ͷ:϶Ͷ

                    i++;//ƵһΪͶע 磺ʤ@2.540Ԫ
                    string tmpCodeStr = "";

                    //while (!new Regex(@"M\0!\0a\0").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))
                    //while (!new Regex(@"\d{1,}").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))   //2017-05-27 ظĳɳ
                    while (!new Regex(@"\d{1,}(|)").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))
                    {
                        //Ͷעݿж
                        if (tmpArr[i].IndexOf("@") > 0 || new Regex(@"\d{0,}.\d{1,}Ԫ").IsMatch(tmpArr[i]))     //е   3.650Ԫ    .50Ԫ
                        {
                            tmpCodeStr += tmpArr[i].Trim();
                        }
                        i++;

                        if (i >= tmpArr.Length)
                        {
                            break;
                        }
                    }
                    i--;
                    //if (ticketEntity.L_RateType == (int)JcRateType.Fixed)
                    //{
                    dRateList.Add(string.Format("{0}{1}{2}[{3}]", strChangCi, MatchCodeSplitStr, playIdOfRate, DealRateCode(playIdOfRate, tmpCodeStr.Trim())));
                    //}
                    //else
                    //{
                    //    dCodeList.Add(string.Format("{0}{1}{2}[{3}]", strChangCi, MatchCodeSplitStr, playIdOfRate, DealResultCode(playIdOfRate,tmpCodeStr.Trim())));
                    //}
                }
            }
            decodePrintData.L_PrintTicketEntity.L_CodeReference = string.Join(CodeSplitStr, codeReferenceList.ToArray());//
            //Ϲص
            decodePrintData.L_PrintTicketEntity.L_CodeRate = string.Join(CodeSplitStr, dRateList.ToArray());

            //Ͷע
            decodePrintData.L_PrintTicketEntity.P_Code = SplitRateDetailToCode(decodePrintData.L_PrintTicketEntity.L_CodeRate);
            #endregion

            decodePrintData.DecodeSuccess = true;
        }

        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCode(int playIdOfRate, string Istr)
        {
            string result = "";
            switch (playIdOfRate)
            {
                case 91106:
                case 91101:
                    result = DealRateCodeSpf(Istr);
                    break;
                case 91102:
                    result = DealRateCodeBf(Istr);
                    break;
                case 91103:
                    result = DealRateCodeZjq(Istr);
                    break;
                case 91104:
                    result = DealRateCodeBqc(Istr);
                    break;
            }
            return result;
        }
        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeSpf(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^ʤƽԪ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "ʤ":
                        tmpstr += "3";
                        break;
                    case "ƽ":
                        tmpstr += "1";
                        break;
                    case "":
                        tmpstr += "0";
                        break;
                    case "Ԫ":
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }
            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_SPF, tmpstr);
            return tmpstr;
        }
        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeBf(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^():ʤƽԪ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "(":
                    case ")":
                    case "Ԫ":
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }
            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_BF, tmpstr);
            return tmpstr;
        }


        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeZjq(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^()Ԫ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            Istr = Istr.Replace("7+", "7");
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "(":
                    case ")":
                    case "Ԫ":
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }
            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_ZJQ, tmpstr);
            return tmpstr;
        }

        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeBqc(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^()ʤƽԪ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            Istr = Istr.Replace("7+", "7");
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "(":
                    case ")":
                    case "Ԫ":
                        break;
                    case "ʤ":
                        tmpstr += "3-";
                        break;
                    case "ƽ":
                        tmpstr += "1-";
                        break;
                    case "":
                        tmpstr += "0-";
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }

            tmpstr = tmpstr.Replace("-#", "#");


            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_BQC, tmpstr);
            return tmpstr;
        }


        //ֵ 3 ʾʤ  1 ʾƽ 0 ʾ
        private const string CODE_SORT_DIECTIONRY_SPF = "3,1,0";
        //ֵ 
        private const string CODE_SORT_DIECTIONRY_BF = "1:0,2:0,2:1,3:0,3:1,3:2,4:0,4:1,4:2,5:0,5:1,5:2,ʤ,0:0,1:1,2:2,3:3,ƽ,0:1,0:2,1:2,0:3,1:3,2:3,0:4,1:4,2:4,0:5,1:5,2:5,";

        //ֵ 1 ʾʤ  2 ʾ
        private const string CODE_SORT_DIECTIONRY_ZJQ = "0,1,2,3,4,5,6,7";

        //ֵ 1 ʾʤ  2 ʾ
        private const string CODE_SORT_DIECTIONRY_BQC = "3-3,3-1,3-0,1-3,1-1,1-0,0-3,0-1,0-0";

        #endregion
    }
}
