using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Threading;
using ChuPiao.AutoPrint.Machine;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.AutoPrint.Services.OpenCode;
using ChuPiao.AutoPrint.Services.TicketFile;
using ChuPiao.Common.Core.Utils;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using ChuPiao.Common.Utils;
//using ChuPiao.AutoPrint.Services.ZcMatch;
using System.Data;
using ChuPiao.Common.Communication.GtdJson.Packs;
using ChuPiao.Common.Communication.GtdJson;
using ChuPiao.Common.Communication.GtdJson.Items;

namespace ChuPiao.AutoPrint.Services.AutoPrint
{
    public class AutoPrintService
    {

        public static bool isCOMOK = true;
        /// <summary>
        /// Ʊ
        /// </summary>
        public event EventHandler<TicketEventArgs> Printing;
        /// <summary>
        /// Ʊ
        /// </summary>
        public event EventHandler<TicketEventArgs> Printed;
        /// <summary>
        /// ״̬仯
        /// </summary>
        public event EventHandler<MachineStatusArgs> StatusChanged;
        /// <summary>
        /// ϼ
        /// </summary>
        public event EventHandler AmountCleared;
        /// <summary>
        /// 
        /// </summary>
        public event EventHandler ErrorCleared;
        public ILotMachine LotMachine;
        private Thread _workThread;
        private bool _isStop = true;
        //private JcMatchSnapService _jcMatchSnapService = null;
        //private ZcMatchSnapService _zcMatchSnapService = null;
        private IOpenCodeSnapService _openCodeSnapService = null;
        //ManualResetEvent _manualResetEvent = new ManualResetEvent(false);
        public void Start()
        {
            try
            {
                if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
                {
                    lock (WaitPrintTickets)
                    {
                        WaitPrintTickets.Clear();
                    }
                    LotMachine.Log.Info("ƱǰȡƱݡ");
                    CaptureDataInfo dataInfo = LotMachine.GetCacheTicket();
                    if (dataInfo != null && dataInfo.CaptureDataBytes.Length > 0)
                    {
                        LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, dataInfo.CaptureDataBytes);
                    }

                    //ƱÿղƱͶעģʽлͶעģʽ
                    LotMachine.MacCurrentMode = null;

                    ////һγƱɹݿʧܵƱ
                    //try
                    //{
                    //    L_LotTicketEntity ticket = new L_LotTicketEntity();
                    //    L_PrintTicketEntity printTicket = new L_PrintTicketEntity();
                    //    bool loadsuc = FileService.LoadPrintInfoFromLocalFile(LotMachine.MachineInfo.M_Number, ticket, printTicket);
                    //    if (loadsuc)
                    //    {
                    //        //L_LotTicketService ticketService = new L_LotTicketService();
                    //        try
                    //        {
                    //            //ticketService.AddPrintTicket(ticket, printTicket);
                    //            //LotMachine.Log.Info(string.Concat("һγƱɹݿʧܵƱɡˮţ", ticket.L_TicketSn, " Ʊţ", printTicket.P_TicketCode, " 룺", printTicket.P_Password, " ", printTicket.P_Money));
                    //        }
                    //        catch (Exception exception)
                    //        {
                    //            MessageService.ShowMessage(string.Concat("һγƱɹݿʧܵƱ쳣Ϣ", exception));
                    //            FileService.SavePrintInfoToLocalFile(ticket, printTicket);
                    //            return;
                    //        }
                    //    }
                    //}
                    //catch (Exception exception)
                    //{
                    //    MessageService.ShowMessage(string.Concat("һγƱɹݿʧܵƱ쳣Ϣ", exception));
                    //    return;
                    //}

                    //if (LotMachine.MachineInfo.M_Type == (int)MachineType.JxJingCaiV1 || LotMachine.MachineInfo.M_Type == (int)MachineType.TjJingCaiV1)
                    //{
                    //    //ʶץȡ
                    //    _jcMatchSnapService = new JcMatchSnapService(LotMachine);
                    //}
                    //else if (LotMachine.MachineInfo.M_Type == (int)MachineType.JxTiCaiMachineV2)
                    //{
                    //    _zcMatchSnapService = new ZcMatchSnapService(LotMachine);
                    //}
                    //else if (LotMachine.MachineInfo.M_Type == (int)MachineType.JxTiCaiMachineV3 || LotMachine.MachineInfo.M_Type == (int)MachineType.HbGaoPinCai)
                    //{
                        _openCodeSnapService = new DlOpenCodeSnapService(LotMachine,(int)Lottype.Hd);
                    //}
                    //else if (LotMachine.MachineInfo.M_Type == (int)MachineType.JsTiCai)
                    //{
                    //    string address = System.Configuration.ConfigurationManager.AppSettings.Get("Address");
                    //    if (address == null) address = "";
                    //    if (address.IndexOf("") > -1)
                    //    {
                    //        _jcMatchSnapService = new JcMatchSnapService(LotMachine);
                    //    }
                    //    else if (address.IndexOf("ֲ") > -1)
                    //    {
                    //        _openCodeSnapService = new JdOpenCodeSnapService(LotMachine);
                    //    }
                    //    else if (address.IndexOf("") > -1)
                    //    {
                    //        _zcMatchSnapService = new ZcMatchSnapService(LotMachine);
                    //    }
                    //}


                    //LotMachine.EnterSaleGui();
                    if (_workThread != null && _workThread.IsAlive)
                    {
                        LoggingService.Error(string.Concat("߳", _workThread.ManagedThreadId, "ǰΪִ״̬"));
                        return;
                    }
                    if (_workThread != null)
                    {
                        _workThread.Abort();
                    }

                    _isStop = false;
                    _workThread = new Thread(new ThreadStart(DoTask));
                    _workThread.Start();
                    UpdateMachineStatus(MachineStatusEnum.Printing);
                    LotMachine.Log.Info("Ʊ");
                    LoggingService.Info(string.Concat(LotMachine.MachineInfo.M_Number, "Ʊ"));
                }
            }
            catch (Exception e1)
            {
                LoggingService.Error(string.Concat("Ʊ쳣Ϣ", e1));
            }

        }

        public void Stop()
        {
            //if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Printing)
            if (!_isStop)
            {
                try
                {
                    UpdateMachineStatus(MachineStatusEnum.Stopping);
                    LotMachine.Log.Info("ֹͣƱ" + LotMachine.MachineInfo.M_Status);
                    LoggingService.Info(string.Concat(LotMachine.MachineInfo.M_Number, "ֹͣƱ"));
                    _isStop = true;
                    Wait4Job.Set();

                    //_manualResetEvent.Set();
                    //WaitPrintTickets.Clear();
                }
                catch (Exception e)
                {
                    LotMachine.Log.Info("ֹͣƱʧܣ");
                }
            }
        }



        private EventWaitHandle _wait4Job = new EventWaitHandle(true, EventResetMode.ManualReset);

        public EventWaitHandle Wait4Job
        {
            get
            {
                return _wait4Job;
            }
        }
        /// <summary>
        /// Ʊ
        /// </summary>
        public event EventHandler<ErrorTicketEventArgs> PrintTicketError;
        /// <summary>
        /// ȴƱ
        /// </summary>
        public Queue<L_LotTicketEntity> WaitPrintTickets = new Queue<L_LotTicketEntity>();
        /// <summary>
        /// ȴƱƱ
        /// </summary>
        public int WaitPrintTicketCount
        {
            get
            {
                lock (WaitPrintTickets)
                {
                    return WaitPrintTickets.Count;
                }
            }
        }

        public List<M_LotTypeEntity> LotTypeList
        {
            get
            {
                if (_lotTypeList == null)
                {
                    //M_LotTypeService lotTypeService = new M_LotTypeService();
                    //_lotTypeList = lotTypeService.GetEnabledLotTypeList();

                    _lotTypeList = new List<M_LotTypeEntity>();

                    M_LotTypeEntity entity = new M_LotTypeEntity();
                    entity.L_LotId = 911;
                    entity.L_LotName = "";
                    entity.L_LotShortName = "jz";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                    entity = new M_LotTypeEntity();
                    entity.L_LotId = 951;
                    entity.L_LotName = "";
                    entity.L_LotShortName = "jl";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                    entity = new M_LotTypeEntity();
                    entity.L_LotId = 701;
                    entity.L_LotName = "͸";
                    entity.L_LotShortName = "lt";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                    entity = new M_LotTypeEntity();
                    entity.L_LotId = 601;
                    entity.L_LotName = "ʤ";
                    entity.L_LotShortName = "sf";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                    entity = new M_LotTypeEntity();
                    entity.L_LotId = 503;
                    entity.L_LotName = "11ѡ5";
                    entity.L_LotShortName = "hd";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                    entity = new M_LotTypeEntity();
                    entity.L_LotId = 702;
                    entity.L_LotName = "3";
                    entity.L_LotShortName = "ps";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                    entity = new M_LotTypeEntity();
                    entity.L_LotId = 703;
                    entity.L_LotName = "5";
                    entity.L_LotShortName = "pw";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                    entity = new M_LotTypeEntity();
                    entity.L_LotId = 704;
                    entity.L_LotName = "7ǲ";
                    entity.L_LotShortName = "qx";
                    entity.L_Enabled = true;
                    _lotTypeList.Add(entity);

                }
                return _lotTypeList;
            }
        }

        private List<M_LotTypeEntity> _lotTypeList = null;

        /// <summary>
        /// Ʊʱȴѯʱ 
        /// </summary>
        public int WaitTime = 3;
        /// <summary>
        /// һƱ
        /// </summary>
        public const int MaxOneLoad = 100;
        //µǰЧֵļʱ 
        private const int UpdateEnabledLotTypeInterval = 60;
        //µǰЧֵĵȴʱ
        private int UpdateEnabledLotTypeWaitTime = 0;
        private void UpdateEnabledLotType()
        {
            try
            {
                //_lotTypeList = new M_LotTypeService().GetEnabledLotTypeList();
            }
            catch (Exception ex)
            {
                LotMachine.Log.Error(ex.ToString());
            }
        }

        private bool _isTopGUI = false;
        private void DoTask()
        {
            Random random = new Random();

            //int i = 0;
            //while (LotMachine.MachineInfo.M_Status==(int)MachineStatusEnum.Printing)
            while (!_isStop || WaitPrintTicketCount > 0)
            {
                LotMachine.Log.Debug(string.Concat("Ʊ ThreadId:", _workThread.ManagedThreadId, " IsAlive:", _workThread.IsAlive));
                //if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopping)
                //{
                //    LotMachine.Log.Info("ֹͣƱС");
                //}
                if (WaitPrintTicketCount == 0)
                {
                    //Ʊ
                    bool isLoadSuc = false;
                    try
                    {

                        //M_MachinePlayCacheService machinePlayCacheService = new M_MachinePlayCacheService();
                        //List<int> lotIdList = machinePlayCacheService.GetMachineLotIdList(LotMachine.MachineInfo.M_Number);
                        //LotMachine.Log.Info(string.Concat("ɳƱָ", lotIdList.Count));

                        //L_ExpectCacheService expectCacheService = new L_ExpectCacheService();
                        //L_ExpectService expectService=new L_ExpectService();
                        //PrintTicketComparer ticketComparer = new PrintTicketComparer();
                        //foreach (M_LotTypeEntity lotTypeEntity in LotTypeList)
                        //{
                        //    //ڿɳƱֱ֣
                        //    if (!LotMachine.MachineInfo.M_LotStr.Contains(lotTypeEntity.L_LotId.ToString() + ","))
                        //        continue;


                        ////if (lotTypeEntity.L_LotId == (int)Lottype.Lt)
                        ////{
                        ////    if ((DateTime.Now.DayOfWeek == DayOfWeek.Monday || DateTime.Now.DayOfWeek == DayOfWeek.Wednesday || DateTime.Now.DayOfWeek == DayOfWeek.Saturday)
                        ////    && DateTime.Now.Hour >= 20 && DateTime.Now.Hour < 22)            //͸ںСʱڲƱûпڲƱ
                        ////    {
                        ////        continue;
                        ////    }

                        ////    if (!((DateTime.Now.DayOfWeek == DayOfWeek.Monday || DateTime.Now.DayOfWeek == DayOfWeek.Wednesday || DateTime.Now.DayOfWeek == DayOfWeek.Saturday)
                        ////    && DateTime.Now.Hour >= 19 && DateTime.Now.Hour < 20))           //ֹǰ1Сʱ ʱ䣬ƽ11ΣΪ͸Ʊ󣬺ܶ඼Ч
                        ////    {

                        ////        int num = random.Next(100);
                        ////        //LotMachine.Log.Info(num.ToString());
                        ////        num = num % 10;
                        ////        if (num != 0 && num != 1)
                        ////        {
                        ////            continue;
                        ////        }
                        ////    }
                        ////}

                        //if (lotTypeEntity.L_LotId == (int)Lottype.Jz || lotTypeEntity.L_LotId == (int)Lottype.Jl || lotTypeEntity.L_LotId == (int)Lottype.Jm)
                        //{
                        //ʲڼؿɳƱб
                        //JcL_LotTicketService jcLotTicketService=new JcL_LotTicketService();
                        List<L_LotTicketEntity> jcTicketList = new List<L_LotTicketEntity>();
                        try
                        {
                            //jcTicketList = jcLotTicketService.LoadPrintTicketList(lotTypeEntity.L_LotId, LotMachine.MachineInfo.M_Number, MaxOneLoad);
                            //jcTicketList.Sort(ticketComparer);

                            A10001GetTicket pack = new A10001GetTicket();
                            pack.AgentId = LotMachine.MachineInfo.M_Number;
                            pack.Salt = LotMachine.MachineInfo.M_Salt;
                            pack.LotId = 0;
                            A10001GetTicketRet packRet = PackManager.Instance.Send(pack) as A10001GetTicketRet;
                            if (packRet.Ticket != null)
                            {
                                //packRet.Ticket.LotId = lotTypeEntity.L_LotId;
                                jcTicketList.Add(packRet.Ticket);
                            }


                        }
                        catch (Exception exception1)
                        {
                            LotMachine.Log.Warn(string.Concat("Ʊ쳣Ϣ", exception1));
                        }

                        LotMachine.Log.Info(string.Concat("Ʊ", jcTicketList.Count, ""));

                        if (jcTicketList.Count > 0)
                        {
                            isLoadSuc = true;
                            lock (WaitPrintTickets)
                            {
                                foreach (L_LotTicketEntity entity in jcTicketList)
                                {
                                    WaitPrintTickets.Enqueue(entity);
                                }
                            }
                        }

                        //}
                        //else if (lotTypeEntity.L_LotId == (int)Lottype.Bd)
                        //{
                        //    //L_BdExpectCacheService bdExpectCacheService = new L_BdExpectCacheService();
                        //    BdL_ExpectService bdExpectService = new BdL_ExpectService();
                        //    //List<L_ExpectEntity> expectList =bdExpectCacheService.GetChuPiaoExpectList(lotTypeEntity.L_LotId);
                        //    List<L_ExpectEntity> expectList = bdExpectService.GetExpectListByStatus(lotTypeEntity.L_LotId, (int)ExpectStatus.ChuPiao);
                        //    BdL_LotTicketService bdLotTicketService=new BdL_LotTicketService();
                        //    foreach (L_ExpectEntity expectEntity in expectList)
                        //    {
                        //        List<L_LotTicketEntity> ticketList = new List<L_LotTicketEntity>();
                        //        try
                        //        {
                        //            ticketList = bdLotTicketService.LoadPrintTicketList(lotTypeEntity.L_LotId, expectEntity.E_Expect, LotMachine.MachineInfo.M_Number, MaxOneLoad);
                        //            ticketList.Sort(ticketComparer);
                        //        }
                        //        catch (Exception exception1)
                        //        {
                        //            LotMachine.Log.Warn(string.Concat("Ʊ쳣Ϣ", exception1, " LoadPrintTicketList()lotId:", lotTypeEntity.L_LotId, " expect:", expectEntity.E_Expect, " macNumber:", LotMachine.MachineInfo.M_Number, " num:", MaxOneLoad));
                        //        }
                        //        if (ticketList != null)
                        //        {
                        //            LotMachine.Log.Info(string.Concat("֣", lotTypeEntity.L_LotName, "ɳƱںţ", expectEntity.E_Expect, "Ʊ", ticketList.Count, ""));

                        //            //#region ԶýֹƱĳЩضĶbd_cancelorderЧĶţ
                        //            //if(ticketList.Count>0)
                        //            //{
                        //            //    try
                        //            //    {
                        //            //        List<string> cancelOrderSnList =
                        //            //            new L_CancelOrderService().GetEnabledCancelOrderSnList(
                        //            //                (int)Lottype.Bd, expectEntity.E_Expect);
                        //            //        if (cancelOrderSnList.Count > 0)
                        //            //        {
                        //            //            LotMachine.Log.Info(string.Concat("رԶýֹƱ", cancelOrderSnList.Count, ""));
                        //            //            List<L_LotTicketEntity> bdCancelTicketList = new List<L_LotTicketEntity>();
                        //            //            for (int i = ticketList.Count - 1; i >= 0; i--)
                        //            //            {
                        //            //                L_LotTicketEntity ticketEntity = ticketList[i];
                        //            //                if (cancelOrderSnList.Contains(ticketEntity.L_OrderSn))
                        //            //                {
                        //            //                    bdCancelTicketList.Add(ticketEntity);
                        //            //                    ticketList.RemoveAt(i);
                        //            //                }
                        //            //            }
                        //            //            if (bdCancelTicketList.Count > 0)
                        //            //            {
                        //            //                bdLotTicketService.SetStopPrint((int)Lottype.Bd, bdCancelTicketList, (int)TicketStatus.Cancel);
                        //            //            }
                        //            //        }
                        //            //    }
                        //            //    catch (Exception exception)
                        //            //    {
                        //            //        LotMachine.Log.Warn(string.Concat("ԶýֹƱ쳣Ϣ", exception));
                        //            //    }
                        //            //}

                        //            //#endregion

                        //            if (ticketList.Count > 0)
                        //            {
                        //                isLoadSuc = true;
                        //                lock (WaitPrintTickets)
                        //                {
                        //                    foreach (L_LotTicketEntity entity in ticketList)
                        //                    {
                        //                        if(!WaitPrintTickets.Contains(entity))
                        //                        {
                        //                            WaitPrintTickets.Enqueue(entity);
                        //                        }
                        //                    }
                        //                }
                        //            }
                        //        }
                        //    }
                        //}
                        //else
                        //{
                        //    //֣ڼؿɳƱб
                        //    int TmpHour = DateTime.Now.Hour;
                        //    int TmpMinute = DateTime.Now.Minute;
                        //    int TmpSecond = DateTime.Now.Second;
                        //    if (lotTypeEntity.L_LotId == (int)Lottype.Dl)
                        //    {
                        //        //Ʊض
                        //        //if (TmpHour >= 8 && (TmpMinute == 9 || TmpMinute == 19 || TmpMinute == 29 || TmpMinute == 39 || TmpMinute == 49 || TmpMinute == 59))
                        //        if (TmpHour >= 8 && TmpHour <= 22 && TmpMinute % 10 == 9)
                        //        {
                        //            if(!_isTopGUI)
                        //            {
                        //                if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Printing)
                        //                {
                        //                    LotMachine.MachineInfo.M_Status = (int)MachineStatusEnum.Stopped;
                        //                    //UpdateMachineMoney();//»
                        //                    LotMachine.MachineInfo.M_Status = (int)MachineStatusEnum.Printing;
                        //                }
                        //                //LotMachine.ReturnTopGui();
                        //                LotMachine.ReturnTopGui();//ִ2ηض
                        //                _isTopGUI = true;
                        //            }
                        //        }
                        //        else
                        //        {
                        //            _isTopGUI = false;
                        //        }
                        //    }
                        //    if (lotTypeEntity.L_LotId == (int)Lottype.Jd)
                        //    {
                        //        //Ʊض
                        //        if (TmpHour >= 8 && TmpHour <= 22 && (TmpMinute % 10 == 5 && TmpSecond > 20 && TmpSecond < 30))
                        //        {
                        //            if (!_isTopGUI)
                        //            {
                        //                if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Printing)
                        //                {
                        //                    LotMachine.MachineInfo.M_Status = (int)MachineStatusEnum.Stopped;
                        //                    //UpdateMachineMoney();//»
                        //                    LotMachine.MachineInfo.M_Status = (int)MachineStatusEnum.Printing;
                        //                }
                        //                LotMachine.ReturnTopGui();//ִ2ηض
                        //                _isTopGUI = true;
                        //            }
                        //        }
                        //        else
                        //        {
                        //            _isTopGUI = false;
                        //        }
                        //    }
                        //    if (lotTypeEntity.L_LotId == (int)Lottype.Xs)
                        //    {
                        //        //Ʊض
                        //        //if (TmpHour >= 9 && (TmpMinute == 6 || TmpMinute == 16 || TmpMinute == 26 || TmpMinute == 36 || TmpMinute == 46 || TmpMinute == 56) && (TmpSecond>50))
                        //        //if (TmpHour >= 9 && TmpHour <= 22 && ((TmpMinute % 10 == 6 && TmpSecond > 50) || (TmpMinute % 10 == 7) || (TmpMinute % 10 == 8 && TmpSecond < 20)))
                        //        if (TmpHour >= 9 && TmpHour <= 22 && TmpMinute % 10 == 7)
                        //        {
                        //            if (!_isTopGUI)
                        //            {
                        //                if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Printing)
                        //                {
                        //                    LotMachine.MachineInfo.M_Status = (int)MachineStatusEnum.Stopped;
                        //                    //UpdateMachineMoney();//»
                        //                    LotMachine.MachineInfo.M_Status = (int)MachineStatusEnum.Printing;
                        //                }
                        //                LotMachine.ReturnTopGui();//ִзض
                        //                _isTopGUI = true;
                        //            }
                        //        }
                        //        else
                        //        {
                        //            _isTopGUI = false;
                        //        }
                        //    }

                        //List<L_ExpectEntity> expectList =
                        //    expectService.GetExpectListByStatus(lotTypeEntity.L_LotId,
                        //                                        (int) ExpectStatus.ChuPiao);
                        //if(expectList.Count>1)
                        //{
                        //    expectList.Sort(new ExpectComparer());
                        //}
                        //Dictionary<string,string> expectSnDictionary=new Dictionary<string, string>();
                        //int expectindex = 1;
                        //foreach (L_ExpectEntity entity in expectList)
                        //{
                        //    expectSnDictionary.Add(entity.E_Expect,expectindex.ToString());
                        //    entity.ExpectSn = expectindex.ToString();
                        //    expectindex++;
                        //}
                        ////L_LotTicketService lotTicketService = new L_LotTicketService();
                        //foreach (L_ExpectEntity expectEntity in expectList)
                        //{
                        //    List<L_LotTicketEntity> ticketList = new List<L_LotTicketEntity>();
                        //    //try
                        //    //{
                        //    //    ticketList = lotTicketService.LoadPrintTicketList(lotTypeEntity.L_LotId, expectEntity.E_Expect, LotMachine.MachineInfo.M_Number, MaxOneLoad);
                        //    //    ticketList.Sort(ticketComparer);
                        //    //}
                        //    //catch (Exception exception1)
                        //    //{
                        //    //    LotMachine.Log.Warn(string.Concat("Ʊ쳣Ϣ", exception1, " LoadPrintTicketList()lotId:", lotTypeEntity.L_LotId, " expect:", expectEntity.E_Expect, " macNumber:", LotMachine.MachineInfo.M_Number, " num:", MaxOneLoad));
                        //    //}
                        //    //LotMachine.Log.Info(string.Concat("֣", lotTypeEntity.L_LotName, "ɳƱںţ", expectEntity.E_Expect, "Ʊ", ticketList.Count, ""));
                        //    if (ticketList != null && ticketList.Count > 0)
                        //    {
                        //        //#region ֲ/Զ޺
                        //        //if (lotTypeEntity.L_LotId == (int)Lottype.Dl || lotTypeEntity.L_LotId == (int)Lottype.Jd || lotTypeEntity.L_LotId == (int)Lottype.Xs || lotTypeEntity.L_LotId == (int)Lottype.Hd)
                        //        //{
                        //        //    List<M_LimitCodeEntity> limitCodeList = new List<M_LimitCodeEntity>();
                        //        //    M_LimitCodeService limitCodeService = new M_LimitCodeService();
                        //        //    try
                        //        //    {
                        //        //        limitCodeList = limitCodeService.GetLimitCodeList(expectEntity.LotId, expectEntity.E_Expect);
                        //        //        if (limitCodeList.Count > 0)
                        //        //        {
                        //        //            LotMachine.Log.Info(string.Concat("ȡԶ޺б",
                        //        //                                              limitCodeList.Count, ""));
                        //        //        }
                        //        //    }
                        //        //    catch (Exception exception)
                        //        //    {
                        //        //        LotMachine.Log.Info(string.Concat("ȡԶ޺б쳣Ϣ", exception.Message));
                        //        //    }
                        //        //    if (limitCodeList.Count > 0)
                        //        //    {
                        //        //        for (int i = ticketList.Count - 1; i >= 0; i--)
                        //        //        {
                        //        //            bool isautolimit = false;
                        //        //            L_LotTicketEntity ticketEntity = ticketList[i];
                        //        //            foreach (M_LimitCodeEntity limitCodeEntity in limitCodeList)
                        //        //            {
                        //        //                if (limitCodeEntity.C_Lotid == ticketEntity.LotId && limitCodeEntity.C_Playid == ticketEntity.L_PlayId && limitCodeEntity.C_Expect == ticketEntity.L_Expect)
                        //        //                {
                        //        //                    if (limitCodeEntity.C_ModeType == 0)
                        //        //                    {
                        //        //                        //ʽд޺Զ޺ŵǰƱ
                        //        //                        if (ticketEntity.L_Code.IndexOf(limitCodeEntity.C_Code) > -1)
                        //        //                        {
                        //        //                            isautolimit = true;
                        //        //                            break;
                        //        //                        }
                        //        //                    }
                        //        //                    else
                        //        //                    {
                        //        //                        //ʽϡλʽȫƥԶ޺ŵǰƱ
                        //        //                        if (limitCodeEntity.C_Code == ticketEntity.L_Code)
                        //        //                        {
                        //        //                            isautolimit = true;
                        //        //                            break;
                        //        //                        }
                        //        //                    }
                        //        //                }
                        //        //            }
                        //        //            if (isautolimit)
                        //        //            {
                        //        //                //Dl_LotTicketDao psDao = new Dl_LotTicketDao();
                        //        //                //psDao.SetLimitNumber(ticketEntity);
                        //        //                ticketEntity.L_AllowPrint = (int)AllowPrintStatus.NotAllowPrint;
                        //        //                ticketEntity.L_NotifyStatus = (int) NotifyStatus.NotifyAble;
                        //        //                ticketEntity.L_Status = (int) TicketStatus.Limit;
                        //        //                lotTicketService.SetStopPrint(ticketEntity);
                        //        //                ticketList.RemoveAt(i);
                        //        //                LotMachine.Log.Info(string.Concat("֣", ticketEntity.L_LotName, " 淨", ticketEntity.L_PlayName, " ˮţ", ticketEntity.L_TicketSn, " Ͷע룺", ticketEntity.L_Code, " ԶΪ޺"));
                        //        //            }
                        //        //        }
                        //        //    }
                        //        //}
                        //        ////TODO ѵģʽ޷淨
                        //        ///*if (lotTypeEntity.L_LotId == (int)Lottype.Xs)
                        //        //{
                        //        //    for (int i = ticketList.Count - 1; i >= 0; i--)
                        //        //    {
                        //        //        L_LotTicketEntity ticketEntity = ticketList[i];
                        //        //        if (ticketEntity.L_PlayId >= 50637 && ticketEntity.L_PlayId<=50639)
                        //        //        {
                        //        //            //ticketEntity.L_AllowPrint = (int)AllowPrintStatus.NotAllowPrint;
                        //        //            //ticketEntity.L_NotifyStatus = (int)NotifyStatus.NotifyAble;
                        //        //            //ticketEntity.L_Status = (int)TicketStatus.Limit;
                        //        //            //lotTicketService.SetStopPrint(ticketEntity);

                        //        //            //Ʊš롢
                        //        //            TicketSimulator.Build(ticketEntity, null);
                        //        //            L_PrintTicketEntity printTicketEntity = new L_PrintTicketEntity();
                        //        //            printTicketEntity.P_Money = ticketEntity.L_Money;
                        //        //            printTicketEntity.P_TicketCode = ticketEntity.L_TicketCode;
                        //        //            printTicketEntity.P_Password = ticketEntity.L_Password;
                        //        //            printTicketEntity.P_RandomCode = ticketEntity.L_RandomCode;
                        //        //            printTicketEntity.P_SaleAddress = "";
                        //        //            printTicketEntity.P_PrnText = "";
                        //        //            printTicketEntity.P_SucTime = ticketEntity.L_SucTime;
                        //        //            lotTicketService.AddPrintTicket(ticketEntity, printTicketEntity);

                        //        //            ticketList.RemoveAt(i);
                        //        //        }
                        //        //    }
                        //        //}*/
                        //        //#endregion

                        //        if (ticketList.Count > 0)
                        //        {
                        //            LotMachine.Log.Info(string.Concat("֣", lotTypeEntity.L_LotName, "ɳƱںţ", expectEntity.E_Expect, "Ʊ", ticketList.Count, ""));
                        //            isLoadSuc = true;
                        //            /*ļ*/
                        //            //foreach (L_LotTicketEntity entity in ticketList)
                        //            //{
                        //            //    M_LotPlayModeMapEntity lotPlayMap = LotPlayMapService.GetLotPlayMapByPlayId(entity.L_PlayId);
                        //            //    entity.MacLotId = lotPlayMap.M_MacLotId;
                        //            //    entity.MacPlayId = lotPlayMap.M_MacPlayId;
                        //            //    entity.MacModeId = lotPlayMap.M_MacModeId;
                        //            //}
                        //            /*ļ*/
                        //            lock (WaitPrintTickets)
                        //            {
                        //                foreach (L_LotTicketEntity entity in ticketList)
                        //                {
                        //                    entity.ExpectSn = expectSnDictionary[entity.L_Expect];//ںк
                        //                    WaitPrintTickets.Enqueue(entity);
                        //                }
                        //            }
                        //        }
                        //    }
                        //    if (ticketList != null && ticketList.Count == 0)
                        //    {
                        //        LotMachine.Log.Debug(string.Concat("֣", lotTypeEntity.L_LotName, "ɳƱںţ", expectEntity.E_Expect, "Ʊ0"));
                        //    }
                        //}
                        //}


                        // }
                    }
                    catch (Exception exception2)
                    {
                        LotMachine.Log.Warn(string.Concat("Ʊ쳣Ϣ", exception2));
                    }
                    if (!isLoadSuc)
                    {
                        //ûмص
                        LotMachine.Log.Info(string.Concat("ǰûпɳƱݣȴ", WaitTime, ""));
                        Thread.Sleep(WaitTime * 1000);

                        try
                        {
                            //    if (LotMachine.MachineInfo.AllowSnapJcMatch)
                            //    {
                            //        //ץȡʶ
                            //        if (_jcMatchSnapService != null && _jcMatchSnapService.AllowSnap())
                            //        {
                            //            if (LastSucTicket != null && DateTime.Now.Subtract(LastSucTicket.L_SucTime).TotalSeconds < 5)
                            //            {
                            //                Wait4Job.Reset();
                            //                Wait4Job.WaitOne(TimeSpan.FromSeconds(5));
                            //            }
                            //            bool snapJzMatch = _jcMatchSnapService.SnapJzMatch();
                            //            if (!snapJzMatch)
                            //            {
                            //                Wait4Job.Reset();
                            //                Wait4Job.WaitOne(TimeSpan.FromSeconds(10));
                            //            }
                            //            else
                            //            {
                            //                if (!_isStop)
                            //                {
                            //                    Wait4Job.Reset();
                            //                    Wait4Job.WaitOne(TimeSpan.FromSeconds(3));
                            //                    bool snapJlMatch = _jcMatchSnapService.SnapJlMatch();
                            //                    if (!snapJlMatch)
                            //                    {
                            //                        Wait4Job.Reset();
                            //                        Wait4Job.WaitOne(TimeSpan.FromSeconds(10));
                            //                    }
                            //                }
                            //            }
                            //        }
                            //        else
                            //        {
                            //            Wait4Job.Reset();
                            //            Wait4Job.WaitOne(TimeSpan.FromSeconds(10));
                            //        }
                            //    }
                            //    else if (LotMachine.MachineInfo.AllowSnapZcPs)//ץȡʺ޺б
                            //    {
                            //        if (_zcMatchSnapService != null && _zcMatchSnapService.AllowSnap())
                            //        {
                            //            if (LastSucTicket != null && DateTime.Now.Subtract(LastSucTicket.L_SucTime).TotalSeconds < 5)
                            //            {
                            //                Wait4Job.Reset();
                            //                Wait4Job.WaitOne(TimeSpan.FromSeconds(5));
                            //            }

                            //            if (!_isStop)
                            //            {
                            //                //20:00-20:10ץȡ
                            //                if (DateTime.Now.Hour != 20 || DateTime.Now.Minute > 9)
                            //                {
                            //                    string address = System.Configuration.ConfigurationManager.AppSettings.Get("Address");
                            //                    if (address == null) address = "";
                            //                    if (address.IndexOf("") > -1)
                            //                    {
                            //                        //ֻץ޺
                            //                        _zcMatchSnapService.SnapLimitOfPs();
                            //                    }
                            //                }

                            //            }

                            //            //_zcMatchSnapService.Snap();
                            //            for (int i = 1; i <= 4; i++)
                            //            {
                            //                if (_isStop)
                            //                    break;
                            //                _zcMatchSnapService.SnapMatchOfSf(i);
                            //                Thread.Sleep(2000);
                            //            }
                            //            for (int i = 1; i <= 4; i++)
                            //            {
                            //                if (_isStop)
                            //                    break;
                            //                _zcMatchSnapService.SnapMatchOfBq(i);
                            //                Thread.Sleep(2000);
                            //            }
                            //            for (int i = 1; i <= 4; i++)
                            //            {
                            //                if (_isStop)
                            //                    break;
                            //                _zcMatchSnapService.SnapMatchOfJq(i);
                            //                Thread.Sleep(2000);
                            //            }
                            //        }
                            //        else
                            //        {
                            //            Wait4Job.Reset();
                            //            Wait4Job.WaitOne(TimeSpan.FromSeconds(10));
                            //        }
                            //    }
                            //    else 
                            if (LotMachine.MachineInfo.AllowSnapOpenCode)//ץȡֲʿ
                            {
                                if (_openCodeSnapService != null && _openCodeSnapService.AllowSnap())
                                {
                                    _openCodeSnapService.SnapOpenCode();
                                }
                                Wait4Job.Reset();
                                Wait4Job.WaitOne(TimeSpan.FromSeconds(5));
                            }
                            //else
                            //{
                            //    Wait4Job.Reset();
                            //    Wait4Job.WaitOne(TimeSpan.FromSeconds(10));
                            //}
                        }
                        catch (Exception exSnap)
                        {
                            LotMachine.Log.Warn(string.Concat("ץȡ쳣10롣Ϣ", exSnap));
                            Thread.Sleep(10000);
                        }

                        UpdateEnabledLotTypeWaitTime += WaitTime;
                        if (UpdateEnabledLotTypeWaitTime >= UpdateEnabledLotTypeInterval)
                        {
                            UpdateEnabledLotType();
                            UpdateEnabledLotTypeWaitTime = 0;
                        }
                        continue;
                        //Application.DoEvents();
                    }
                }
                else
                {
                    //bool isCP = true;
                    //int r1 = new Random().Next(1, 600001);

                    //if (DateTime.Now.Hour >= 10 && DateTime.Now.Hour < 11) 
                    //{   
                    //    if (r1 > 200000)      //6020Чʱ䣬2-4Ʊ60ӳ60Ʊƽ1Ʊ/
                    //    {
                    //        isCP = false;
                    //    }
                    //}
                    //else if (DateTime.Now.Hour >= 11 && DateTime.Now.Hour < 14)
                    //{
                    //    if (r1 > 250000)      //6025Чʱ䣬2-4Ʊ60ӳ75Ʊƽ1.5Ʊ/֣3Сʱ225Ʊ
                    //    {
                    //        isCP = false;
                    //    }
                    //}
                    //else if (DateTime.Now.Hour >= 14 && DateTime.Now.Hour < 17)
                    //{
                    //    if (r1 > 100000)      //6010Чʱ䣬2-4Ʊ60ӳ30Ʊƽ0.5Ʊ/֣3Сʱ90Ʊ
                    //    {
                    //        isCP = false;
                    //    }
                    //}
                    //else if (DateTime.Now.Hour >= 17 && DateTime.Now.Hour < 21)
                    //{
                    //    if (r1 > 300000)      //6030Чʱ䣬2-4Ʊ60ӳ90Ʊƽ2Ʊ/֣4Сʱ360Ʊ
                    //    {
                    //        isCP = false;
                    //    }
                    //}
                    //else
                    //{
                    //    if (r1 > 150000)      //6015Чʱ䣬2-4Ʊ60ӳ45Ʊƽ0.8Ʊ/
                    //    {
                    //        isCP = false;
                    //    }
                    //}

                    //if (isCP)
                    //{
                    L_LotTicketEntity ticket;
                    DecodePrintData decodePrintData = new DecodePrintData();
                    lock (WaitPrintTickets)
                    {
                        ticket = WaitPrintTickets.Dequeue();
                    }
                    if (ticket == null)
                    {
                        continue;
                    }

                    //Ʊǰָִֹʷָ
                    try
                    {
                        //ȡָ
                        A10009GetCommand pack = new A10009GetCommand();
                        pack.AgentId = LotMachine.MachineInfo.M_Number;
                        pack.Salt = LotMachine.MachineInfo.M_Salt;
                        A10009GetCommandRet packRet = PackManager.Instance.Send(pack) as A10009GetCommandRet;
                        if (packRet.Code > 0)
                        {
                            LotMachine.Log.Info("Ʊǰָ:" + packRet.Command);
                        }
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info("Ʊǰָʧܣ" + ex.ToString());
                    }

                    //ticket.L_Codeж
                    if (ticket.L_Code == "recharge")   //ֵ--------------------------------------------------------------------
                    {
                        try
                        {
                            OnPrinting(ticket);

                            LotMachine.Log.Info("ʼֵ:" + ticket.L_TicketSn);

                            LotMachine.Recharge(Convert.ToInt32(ticket.L_Money));
                        }
                        catch (Exception ex)
                        {
                            LotMachine.Log.Warn(string.Concat("ֵ쳣", ex.Message));
                        }
                        finally
                        {
                            LotMachine.Log.Info("ֵ");
                            OnPrinted(ticket);
                        }
                    }
                    else if (ticket.L_Code == "getbouns")   //ҽ--------------------------------------------------------------------
                    {
                        try
                        {
                            OnPrinting(ticket);

                            LotMachine.Log.Info("ʼҽ:" + ticket.L_TicketSn);

                            LotMachine.Encash(ticket);
                        }
                        catch (Exception ex)
                        {
                            LotMachine.Log.Warn(string.Concat("ҽ쳣", ex.Message));
                        }
                        finally
                        {
                            //д
                            try
                            {
                                A10010NotifyBonus pack = new A10010NotifyBonus();
                                pack.AgentId = LotMachine.MachineInfo.M_Number;
                                pack.Salt = LotMachine.MachineInfo.M_Salt;
                                pack.Ticket = ticket;
                                A10010NotifyBonusRet packRet = PackManager.Instance.Send(pack) as A10010NotifyBonusRet;
                                if (packRet.Code > 0)
                                {
                                    LotMachine.Log.Info("ҽдɹ");
                                }
                            }
                            catch (Exception ex)
                            {
                                LotMachine.Log.Info("ҽдʧܣ" + ex.ToString());
                            }

                            OnPrinted(ticket);
                        }
                    }
                    else   //Ʊ------------------------------------------------------------------------------------------------------
                    {
                        try
                        {
                            OnPrinting(ticket);

                            PrintOneTicket(ticket, decodePrintData);
                            //LotMachine.MachineInfo.M_LastPrintCounter = LotMachine.VirtualPrinter.LastPrintCounter;

                            //ֻеʱץΪܸպõץʱƱ
                            try
                            {
                                if (LotMachine.MachineInfo.AllowSnapOpenCode)//ץȡֲʿ
                                {
                                    if (_openCodeSnapService != null && _openCodeSnapService.AllowSnap())
                                    {
                                        _openCodeSnapService.SnapOpenCode();
                                    }
                                }
                            }
                            catch (Exception exSnap)
                            {
                                LotMachine.Log.Warn(string.Concat("ץȡ쳣10롣Ϣ", exSnap));

                            }
                        }
                        catch (Exception ex)
                        {
                            LoggingService.Info(string.Concat("Ʊ쳣ˮţ", ticket.L_TicketSn, " Ϣ", ex));
                            LotMachine.Log.Warn(string.Concat("Ʊ쳣ˮţ", ticket.L_TicketSn, " Ϣ", ex.Message));
                            ReportError(ticket, decodePrintData, ex.Message, ex.ToString());
                        }
                        //}
                        //else
                        //{
                        //    int sleeptime = new Random().Next(5000, 35000); //ƽ20
                        //    LotMachine.Log.Info("óƱҺҪ侲"+sleeptime.ToString()+"");
                        //    Thread.Sleep(sleeptime);
                        //}


                    }


                    //StatusBarService.SetMessage("ɴӡ" + ticket.L_TicketSn);
                    //StatusBarService.ShowErrorMessage("ɴӡ" + ticket.L_TicketSn);
                    //StatusBarService.SetInsertMode(true);
                    //StatusBarService.SetCaretPosition(1,2,3);
                    //i++;
                }
            }

            LotMachine.Log.Debug("»״̬Ϊֹͣ״̬");
            try
            {
                UpdateMachineStatus(MachineStatusEnum.Stopped);
            }
            catch
            {
                LotMachine.Log.Warn("»״̬ʧܣ");
            }
            LoggingService.Info(string.Concat(LotMachine.MachineInfo.M_Number, "ֹͣƱ"));
        }

        /// <summary>
        /// ״̬
        /// </summary>
        public void Wakeup()
        {
            try
            {
                LotMachine.Log.Info("״̬");
                if (!_isStop && LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Printing)
                {
                    Wait4Job.Set();
                }
                //_manualResetEvent.Set();
            }
            catch (Exception ex)
            {
                LotMachine.Log.Warn(ex);
            }
        }
        //һųɹƱ
        private L_LotTicketEntity LastSucTicket = null;
        //һѸʱ
        private DateTime LastClearExpectTime = new DateTime(1900, 1, 1);
        //ǰڴӡƱ
        public L_LotTicketEntity CurrentTicket = null;
        private int _clearMoneyWaitTicketNum = 0;
        //ǷдƱ
        public bool HasErrorTicket = false;
        private int lastRandomWaitTime = 0;
        private int _jcScanTicketInterval = -1;
        private int _jcTicketInterval = -1;
        private int _jcBTicketInterval = -1;
        private int _jcClearExpectInterval = -1;
        private int _fuShiTicketInterval = -1;
        private int _playChangeInterval = -1;
        private int _TicketInterval = -1;
        private int _BTicketInterval = -1;
        /// <summary>
        /// ɨƱ
        /// </summary>
        public int JcScanTicketInterval
        {
            get
            {
                if (_jcScanTicketInterval < 0)
                {
                    try
                    {
                        _jcScanTicketInterval = int.Parse(ConfigurationManager.AppSettings["JcScanTicketInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡJcScanTicketInterval쳣", ex.Message));
                        _jcScanTicketInterval = 500;
                    }
                }
                return _jcScanTicketInterval;
            }
        }
        /// <summary>
        /// Ʊ
        /// </summary>
        public int JcTicketInterval
        {
            get
            {
                if (_jcTicketInterval < 0)
                {
                    try
                    {
                        _jcTicketInterval = int.Parse(ConfigurationManager.AppSettings["JcTicketInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡJcTicketInterval쳣", ex.Message));
                        _jcTicketInterval = 2500;
                    }
                }
                return _jcTicketInterval;
            }
        }
        /// <summary>
        /// ʴƱ
        /// </summary>
        public int JcBTicketInterval
        {
            get
            {
                if (_jcBTicketInterval < 0)
                {
                    try
                    {
                        _jcBTicketInterval = int.Parse(ConfigurationManager.AppSettings["JcBTicketInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡJcBTicketInterval쳣", ex.Message));
                        _jcBTicketInterval = 3000;
                    }
                }
                return _jcBTicketInterval;
            }
        }
        /// <summary>
        /// ԶѸ¼
        /// </summary>
        public int JcClearExpectInterval
        {
            get
            {
                if (_jcClearExpectInterval < 0)
                {
                    try
                    {
                        _jcClearExpectInterval = int.Parse(ConfigurationManager.AppSettings["JcClearExpectInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡJcClearExpectInterval쳣", ex.Message));
                        _jcClearExpectInterval = 30;
                    }
                }
                return _jcClearExpectInterval;
            }
        }
        /// <summary>
        /// ʽƱ
        /// </summary>
        public int FuShiTicketInterval
        {
            get
            {
                if (_fuShiTicketInterval < 0)
                {
                    try
                    {
                        _fuShiTicketInterval = int.Parse(ConfigurationManager.AppSettings["FuShiTicketInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡFuShiTicketInterval쳣", ex.Message));
                        _fuShiTicketInterval = 800;
                    }
                }
                return _fuShiTicketInterval;
            }
        }
        /// <summary>
        /// 淨л
        /// </summary>
        public int PlayChangeInterval
        {
            get
            {
                if (_playChangeInterval < 0)
                {
                    try
                    {
                        _playChangeInterval = int.Parse(ConfigurationManager.AppSettings["PlayChangeInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡPlayChangeInterval쳣", ex.Message));
                        _playChangeInterval = 2000;
                    }
                }
                return _playChangeInterval;
            }
        }

        /// <summary>
        /// Ʊ
        /// </summary>
        public int TicketInterval
        {
            get
            {
                if (_TicketInterval < 0)
                {
                    try
                    {
                        _TicketInterval = int.Parse(ConfigurationManager.AppSettings["TicketInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡTicketInterval쳣", ex.Message));
                        _TicketInterval = 2500;
                    }
                }
                return _TicketInterval;
            }
        }
        /// <summary>
        /// Ʊ
        /// </summary>
        public int BTicketInterval
        {
            get
            {
                if (_BTicketInterval < 0)
                {
                    try
                    {
                        _BTicketInterval = int.Parse(ConfigurationManager.AppSettings["BTicketInterval"]);
                    }
                    catch (Exception ex)
                    {
                        LotMachine.Log.Info(string.Concat("ȡBTicketInterval쳣", ex.Message));
                        _BTicketInterval = 3000;
                    }
                }
                return _BTicketInterval;
            }
        }
        private const string Fushiplays = "70502,70402,70302,70202,70203,70212,70222,70232,70206,70204,70214,70224,70205,70215,70225,70102,70103,70112,70113,70122,60302,60202,60102,60112";
        private void PrintOneTicket(L_LotTicketEntity ticket, DecodePrintData decodePrintData)
        {
            CurrentTicket = ticket;
            HasErrorTicket = false;
            Random random = new Random();

            //SetIsScan(ticket, LotMachine.MachineInfo);//ǷɨƱ

            SetIsClearExpect(ticket);//ǷƱǰѸ¶Ի


            if (LotMachine.MachineInfo.M_IsAutoClearTotal)
            {
                //ļ쳣նˣʱֹͣϼ
                //ϼƣжһγƱʱ䣬趨ֵһκϼƣ1-5Ʊһ
                if (LastSucTicket == null || DateTime.Now.Subtract(LastSucTicket.L_SucTime).TotalSeconds > 2 * 60)
                {

                    LotMachine.ClearMahineMoney();
                    _clearMoneyWaitTicketNum = random.Next(1, 6);
                    LotMachine.Log.Info("Ʊ2ӣϼơ" + _clearMoneyWaitTicketNum.ToString() + "Ʊ");
                }
                else
                {
                    _clearMoneyWaitTicketNum--;
                    if (_clearMoneyWaitTicketNum == 0)
                    {
                        LotMachine.ClearMahineMoney();
                        _clearMoneyWaitTicketNum = random.Next(1, 6);
                        LotMachine.Log.Info("ϼơ" + _clearMoneyWaitTicketNum.ToString() + "Ʊ");
                    }
                }
            }
            


            if (ticket.LotId == (int)Lottype.Xs || ticket.LotId == (int)Lottype.Dl || ticket.LotId == (int)Lottype.Jd || ticket.LotId == (int)Lottype.Hd)
            {
                if (LastSucTicket == null)
                {
                    LotMachine.ReturnTopGui();//ִзض
                    //if (ticket.LotId == (int)Lottype.Xs)
                    //{
                    //    LotMachine.ReturnTopGui();
                    //}
                }
                else
                {
                    if (LastSucTicket.L_Expect != ticket.L_Expect)
                    {
                        LotMachine.ReturnTopGui();//ִзض
                        //if(ticket.LotId == (int)Lottype.Xs)
                        //{
                        //    LotMachine.ReturnTopGui();
                        //}
                    }
                }
            }
            if (ticket.LotId >= 601 && ticket.LotId <= 705)
            {
                if (LastSucTicket == null)
                {
                    LotMachine.ReturnTopGui();//ִзض
                }
            }


            if (LastSucTicket != null)
            {
                

                //if(LastSucTicket.LotId==911 ||LastSucTicket.LotId==951||LastSucTicket.LotId==971)
                //{
                //    string address = ConfigurationManager.AppSettings["Address"];
                //    if (address.IndexOf("") >= 0 || address.IndexOf("") >= 0)
                //    {
                //        //Ʊ
                //        if (DateTime.Now.Subtract(LastSucTicket.L_SucTime).TotalSeconds <= 6)
                //        {
                //            int r2 = 0;
                //            if (LastSucTicket.L_SpendTime < 5000)   //»ƱʱС5
                //            {
                //                //r2 = random.Next(5000, 9000);   //5Ʊ/   12һƱ  ƽ7룬Ʊʱ5 
                //                r2 = random.Next(8000, 12000);   //4Ʊ/
                //                //r2 = random.Next(6500, 10500);   //4-5Ʊ/
                //            }
                //            else
                //            {
                //                int r1 = random.Next(0, 100000);
                //                int i = 0;
                //                if (r1 < 80000)   //80%ĸ֧
                //                {
                //                    //r2 = random.Next(2000, 6000);//5Ʊ/
                //                    r2 = random.Next(5000, 9000);//4Ʊ/
                //                    //r2 = random.Next(3500, 7500);//4-5Ʊ/
                //                    if (lastRandomWaitTime > 0)
                //                    {
                //                        while (i < 100 && Math.Abs(r2 - lastRandomWaitTime) < 1000)    //100Σʱϴεʱ1
                //                        {
                //                            //r2 = random.Next(2000, 6000);  //5Ʊ/
                //                            r2 = random.Next(5000, 9000);  //4Ʊ/
                //                            //r2 = random.Next(3500, 7500);//4-5Ʊ/
                //                            i++;
                //                        }
                //                    }
                //                }
                //                else
                //                {
                //                    //r2 = random.Next(14000, 28000);//16-30/Ʊ
                //                    //r2 = random.Next(10000, 18000);//12-20/Ʊ
                //                    //r2 = random.Next(8000, 14000);//10-16/Ʊ
                //                    //r2 = random.Next(2000, 6000);//5Ʊ/
                //                    r2 = random.Next(5000, 9000);//4Ʊ/
                //                    //r2 = random.Next(3500, 7500);//4-5Ʊ/
                //                    if (lastRandomWaitTime > 0)
                //                    {
                //                        while (i < 100 && Math.Abs(r2 - lastRandomWaitTime) < 1000)
                //                        {
                //                            //r2 = random.Next(2000, 6000);//5Ʊ/
                //                            r2 = random.Next(5000, 9000);//4Ʊ/
                //                            //r2 = random.Next(3500, 7500);//4-5Ʊ/
                //                            i++;
                //                        }
                //                    }
                //                }
                //            }

                //            //жǲǽֹǰֹǰ
                //            DateTime earlistEndTime = GetEarliestEndTime();
                //            TimeSpan timeSpan = earlistEndTime.Subtract(DateTime.Now);
                //            //ֹǰ1Сʱ
                //            if (timeSpan.TotalMinutes <= 90)
                //            {
                //                r2 -= random.Next(3000,7000); //6Ʊ   
                //            }

                //            lastRandomWaitTime = r2;
                //            LotMachine.Log.Info("" + r2 + "");
                //            Wait(r2);
                //            //Wait(2000);   //Ҫ1
                //        }


                //        /*int waitinterval = 500;
                //        LotMachine.Log.Info("Ʊȴ" + waitinterval + "ٳǰƱ");
                //        Wait(waitinterval);*/
                //    }
                //    else 
                //    {
                //        //Ʊ
                //        if (DateTime.Now.Subtract(LastSucTicket.L_SucTime).TotalSeconds <= 3)
                //        {
                //            /*Random random = new Random();
                //            int r1 = random.Next(1000, 11000);
                //            if (lastRandomWaitTime > 0)
                //            {
                //                int i = 0;
                //                while (i < 100 && Math.Abs(r1 - lastRandomWaitTime) < 2000)
                //                {
                //                    r1 = random.Next(1000, 11000);
                //                    i++;
                //                }
                //            }
                //            lastRandomWaitTime = r1;
                //            Wait(r1);*/


                //            //int waitinterval = 500;
                //            //LotMachine.Log.Info("Ʊȴ" + waitinterval + "ٳǰƱ");
                //            //Wait(waitinterval);
                //            if(ticket.IsUseScanner)
                //            {
                //                LotMachine.Log.Info("ɨƱȴ" + JcScanTicketInterval + "ٳǰƱ");
                //                Wait(JcScanTicketInterval);
                //            }
                //            else
                //            {
                //                if ((LastSucTicket.L_Mutiple > 1 || LastSucTicket.L_Money > 500))
                //                {
                //                    LotMachine.Log.Info("ƱǰһǱͶƱƱȴ" + JcBTicketInterval + "ٳǰƱ");
                //                    Wait(JcBTicketInterval);//ǰһǱͶƱȴ1ٳһ
                //                }
                //                else
                //                {
                //                    //int waitinterval = 2500;
                //                    LotMachine.Log.Info("Ʊȴ" + JcTicketInterval + "ٳǰƱ");
                //                    Wait(JcTicketInterval);
                //                }
                //            }
                //        }
                //    }
                //}
                //else
                //{
                //    //if (DateTime.Now.Subtract(LastSucTicket.L_SucTime).TotalSeconds <= 3)
                //    //{
                //    //    if ((LastSucTicket.L_Mutiple > 1 || LastSucTicket.L_Money > 500))
                //    //    {
                //    //        LotMachine.Log.Info("ƱǰһǱͶƱƱȴ" + BTicketInterval + "ٳǰƱ");
                //    //        Wait(BTicketInterval);//ǰһǱͶƱȴ1ٳһ
                //    //    }
                //    //    else
                //    //    {
                //    //        int waitinterval = TicketInterval;
                //    //        if (Fushiplays.IndexOf(ticket.L_PlayId.ToString()) > -1 && waitinterval<800)
                //    //        {
                //    //            waitinterval = FuShiTicketInterval;//800;
                //    //        }
                //    //        if(LastSucTicket.L_PlayId!=ticket.L_PlayId)
                //    //        {
                //    //            waitinterval = PlayChangeInterval;//2000;
                //    //        }

                //    //        LotMachine.Log.Info("Ʊȴ" + waitinterval + "ٳǰƱ");
                //    //        Wait(waitinterval);
                //    //    }
                //    //}

                int min = LocalConfigUtil.TicketInterval - 500;
                int max = LocalConfigUtil.TicketInterval + 500;
                int r = random.Next(min, max); 
                LotMachine.Log.Info("" + r + "--------------------------");
                Wait(r);
                //}


            }

            //ƱǰжǷѽֹֹΪʱδƱʱֻԶֲ/
            if (DateTime.Now > ticket.L_EndTime)
            {
                //ticket.L_Status = (int)TicketStatus.Default;
                //ticket.L_NotifyStatus = (int)NotifyStatus.Default;
                //ticket.L_AllowPrint = (int)AllowPrintStatus.NotAllowPrint;

                //if (ticket.LotId == (int)Lottype.Bd)
                //{
                //    new BdL_LotTicketService().SetStopPrint(ticket);
                //}
                //else if (ticket.LotId == (int)Lottype.Jz || ticket.LotId == (int)Lottype.Jl || ticket.LotId == (int)Lottype.Jm)
                //{
                //    new JcL_LotTicketService().SetStopPrint(ticket);
                //}
                //else
                //{
                //    new L_LotTicketService().SetStopPrint(ticket);
                //}

                LotMachine.Log.Info(string.Concat("ںţ", ticket.L_Expect, " ˮţ", ticket.L_TicketSn, " ", ticket.L_Money, " ֹʱ䣺", ticket.L_EndTime, " ѽֹδƱ"));
                OnPrinted(ticket);
                return;
            }

            DateTime beginTime = DateTime.Now;

            if (!LotMachine.MachineInfo.M_IsSimulate)
            {
                LotMachine.Print(ticket, decodePrintData);
            }
            else
            {
                //ڲԣƱɹ
                decodePrintData.DecodeSuccess = true;
                ticket.L_TicketCode = DateTime.Now.ToString("yyyyMMddHHmmss");
                TicketSimulator.Build(ticket, decodePrintData);
                decodePrintData.L_PrintTicketEntity.P_PrnText = "test";
                decodePrintData.L_PrintTicketEntity.P_TicketCode = ticket.L_TicketCode;
                decodePrintData.L_PrintTicketEntity.L_CodeReference = ticket.L_CodeReference;
                decodePrintData.L_PrintTicketEntity.L_CodeRate = ticket.L_CodeRate;
                decodePrintData.L_PrintTicketEntity.P_SucTime = DateTime.Now;
                if (ticket.L_PlayId == 70111 || ticket.L_PlayId == 70112 || ticket.L_PlayId == 70113)
                {
                    ticket.L_AddType = random.Next(0, 5);
                }
            }

            DateTime endTime = DateTime.Now;
            int totalTime = (int)((endTime.Subtract(beginTime)).TotalMilliseconds);
            ticket.L_SpendTime = totalTime;

            if (decodePrintData.DecodeSuccess)
            {
                ////Ʊļ
                //string ticketFilePath = FileService.GetTicketFilePath(LotMachine.MachineInfo.M_Number, ticket.L_TicketCode);
                //File.WriteAllText(ticketFilePath, decodePrintData.L_PrintTicketEntity.P_PrnText);
                //LotMachine.Log.Debug(string.Concat("Ʊļ", ticketFilePath));
                //if (LotMachine.MachineInfo.M_AllowPaperout)
                //{
                //    LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, decodePrintData.InputData.CaptureDataBytes);
                //}
                try
                {
                    ////Ʊ
                    //L_LotTicketService lotTicketService = new L_LotTicketService();
                    ////throw new Exception("System.Data.SqlClient.SqlException: A transport-level error has occurred when receiving results from the server");
                    //lotTicketService.AddPrintTicket(ticket, decodePrintData.L_PrintTicketEntity);
                    //LotMachine.Log.Debug(string.Concat("ƱŸµݿɹˮţ", ticket.L_TicketSn, " Ʊţ", ticket.L_TicketCode, " 룺", ticket.L_Password, " Ʊʱ䣺", ticket.L_SucTime));


                    //֪ͨƱ
                    A10002NotifyTicket pack = new A10002NotifyTicket();
                    pack.AgentId = LotMachine.MachineInfo.M_Number;
                    pack.Salt = LotMachine.MachineInfo.M_Salt;
                    ticket.L_TicketCode = decodePrintData.L_PrintTicketEntity.P_TicketCode;
                    ticket.L_CodeRate = decodePrintData.L_PrintTicketEntity.L_CodeRate;
                    ticket.L_CodeReference = decodePrintData.L_PrintTicketEntity.L_CodeReference;   //
                    ticket.L_SucTime = decodePrintData.L_PrintTicketEntity.P_SucTime;
                    ticket.L_PrnText = decodePrintData.L_PrintTicketEntity.P_PrnText;
                    ticket.L_Status = (int)TicketStatus.Suc;
                    ticket.L_LimitType = 0;
                    pack.Ticket = ticket;

                    int retry = 0;
                    while (retry <3)
                    {
                        A10002NotifyTicketRet packRet = PackManager.Instance.Send(pack) as A10002NotifyTicketRet;
                        if (packRet.Code > 0)
                        {
                            break;
                        }

                        retry++;
                        if (retry==3)
                        {
                            LotMachine.Log.Warn("ʾ볢Ե֪ͨ");
                            throw new Exception("Ʊ֪ͨʧܣԶ3Σ" + packRet.Code.ToString() + " " + packRet.Message);
                        }

                        Thread.Sleep(retry * 1000);
                    }

                    //ɾlastĿ¼һļ
                    LotMachine.VirtualPrinter.DeleteLastFile();

                    TotalMoney += ticket.L_Money;
                    TotalTicket += 1;
                    //LotMachine.Log.Info("Ʊ");

                    LotMachine.Log.Info(string.Concat("Ʊ֪ͨɹ", ticket.L_TicketSn, " ֣", ticket.L_LotName, ticket.LotId, "淨", ticket.L_PlayName, ticket.L_PlayId, "", ticket.L_Mutiple, "", ticket.L_Money, " ƱʱΪ", totalTime.ToString("0"), " ", ticket.IsUseScanner ? "ɨƱ" : "Ʊ"));

                    ticket.L_SucTime = DateTime.Now;//ʹõʱжƱļ
                    LastSucTicket = ticket;
                    //OnPrinted(ticket);
                }
                catch (Exception exception)
                {
                    //FileService.SavePrintInfoToLocalFile(ticket, decodePrintData.L_PrintTicketEntity);
                    LotMachine.Log.Warn(string.Concat("Ʊ֪ͨʧܡˮţ", ticket.L_TicketSn, " Ʊţ", ticket.L_TicketCode, " 룺", ticket.L_Password));
                    ReportError(ticket, decodePrintData, string.Concat("֪ͨƱʧܣ", exception.Message), exception.ToString());

                }
                OnPrinted(ticket);
            }
            else
            {
                LotMachine.Log.Warn(string.Concat("Ʊʧܡˮţ", ticket.L_TicketSn, " Ϣ", decodePrintData.ErrorMessage));
                ReportError(ticket, decodePrintData, decodePrintData.ErrorMessage, decodePrintData.ErrorMessage);

                //string screenPicStr = "";
                //try
                //{
                //    DateTime startScreenCapture = DateTime.Now;
                //    screenPicStr = ScreenCaptureUtil.MachineScreenCaptureBase64(LotMachine.MachineInfo.M_SocketIp,
                //                                                                 LotMachine.MachineInfo.M_Number);
                //    DateTime endScreenCapture = DateTime.Now;
                //    LotMachine.Log.Info(string.Concat("Ʊɡʱ", endScreenCapture.Subtract(startScreenCapture).TotalMilliseconds,""));
                //}
                //catch (Exception ex)
                //{
                //    LotMachine.Log.Info(string.Concat("Ʊ",ex));
                //}
                //ReportError(ticket, decodePrintData, decodePrintData.ErrorMessage, screenPicStr);
            }
        }

        public void ReGetdata(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData)
        {
            if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Printing)
            {
                LotMachine.Log.Info("Ʊвִжλȡ");
                return;
            }
            LotMachine.Log.Info("ִжλȡݡ");
            LotMachine.ReGetdata(ticketEntity, decodePrintData);
            //if (!decodePrintData.DecodeSuccess)
            //{
            //    LotMachine.Log.Info(string.Concat("λȡݽʧܣ˶ԴƱ"));
            //    if (decodePrintData.InputData.CaptureDataBytes.Length > 0)
            //    {
            //        //ƱƱļ
            //        string errorticketFilePath = FileService.GetErrorTicketFilePath(LotMachine.MachineInfo.M_Number, ticketEntity.L_TicketSn + "_" + DateTime.Now.ToString("yyyyMMddHHmmss"));
            //        //decodePrintData.L_PrintTicketEntity.P_PrnText =
            //        //    TicketTextUtil.CompressAndEncrypt(decodePrintData.InputData.CaptureDataBytes);
            //        File.WriteAllText(errorticketFilePath, decodePrintData.L_PrintTicketEntity.P_PrnText);
            //        LotMachine.Log.Info(string.Concat("Ʊļ", errorticketFilePath));
            //        //LotMachineService.PrinterClient.AddFile(errorticketFilePath);
            //        LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, errorticketFilePath, true);
            //        //ƱϢƱ
            //        //L_ErrorTicketService errorTicketService = new L_ErrorTicketService();
            //        //errorTicketService.AddErrorTicket(ticketEntity, decodePrintData.L_PrintTicketEntity);
            //        //LotMachine.Log.Info(string.Concat("ƱϢ⣬ӡƱļ", errorticketFilePath));
            //    }
            //    Stop();
            //}
            //else
            //{
            //    LotMachine.Log.Info(string.Concat("λȡݽɹ"));
            //    //ticketEntity.L_TicketCode = decodePrintData.L_PrintTicketEntity.P_TicketCode;
            //    //ticketEntity.L_RandomCode = decodePrintData.L_PrintTicketEntity.P_RandomCode;
            //    //ticketEntity.L_Password = decodePrintData.L_PrintTicketEntity.P_Password;
            //    //ticketEntity.L_SucTime = decodePrintData.L_PrintTicketEntity.P_SucTime;
            //    //ticketEntity.L_Status = (int)TicketStatus.Suc;
            //    //ticketEntity.L_NotifyStatus = (int)NotifyStatus.NotifyAble;
            //    //Ʊļ
            //    string ticketFilePath = FileService.GetTicketFilePath(LotMachine.MachineInfo.M_Number, ticketEntity.L_TicketCode); ;
            //    File.WriteAllText(ticketFilePath, decodePrintData.L_PrintTicketEntity.P_PrnText);
            //    LotMachine.Log.Debug(string.Concat("Ʊļ", ticketFilePath));
            //    if (LotMachine.MachineInfo.M_AllowPaperout)
            //    {
            //        //LotMachineService.PrinterClient.AddFile(ticketFilePath);
            //        LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, ticketFilePath, true);
            //    }



            //        //֪ͨƱ
            //        A10002NotifyTicket pack = new A10002NotifyTicket();
            //        pack.AgentId = LotMachine.MachineInfo.M_Number;
            //        pack.Salt = LotMachine.MachineInfo.M_Salt;
            //        ticketEntity.L_TicketCode = decodePrintData.L_PrintTicketEntity.P_TicketCode;
            //        ticketEntity.L_CodeRate = decodePrintData.L_PrintTicketEntity.L_CodeRate;
            //        ticketEntity.L_SucTime = decodePrintData.L_PrintTicketEntity.P_SucTime;
            //        ticketEntity.L_PrnText = decodePrintData.L_PrintTicketEntity.P_PrnText;
            //        ticketEntity.L_Status = 1;
            //        pack.Ticket = ticketEntity;
            //        A10002NotifyTicketRet packRet = PackManager.Instance.Send(pack) as A10002NotifyTicketRet;
            //        if (packRet.Code != 0)
            //        {
            //            throw new Exception("Ʊ֪ͨʧܣ" + packRet.Message);
            //        }

            //        LotMachine.Log.Info(string.Concat("Ʊ֪ͨɹ", ticket.L_TicketSn, " ֣", ticket.L_LotName, ticket.LotId, "淨", ticket.L_PlayName, ticket.L_PlayId, "", ticket.L_Mutiple, "", ticket.L_Money, " ƱʱΪ", totalTime.ToString("0"), " ", ticket.IsUseScanner ? "ɨƱ" : "Ʊ"));


            //        TotalMoney += ticketEntity.L_Money;
            //        TotalTicket += 1;

            //        ticketEntity.L_SucTime = DateTime.Now;//ʹõʱжƱļ
            //        LastSucTicket = ticketEntity;


            //    OnPrinted(ticketEntity);

            //    if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Error)
            //    {
            //        UpdateMachineStatus(MachineStatusEnum.Printing);
            //    }
            //    else if (LotMachine.MachineInfo.M_Status == (int)MachineStatusEnum.Stopped)
            //    {
            //        Start();
            //    }
            //}
        }

        ///// <summary>
        ///// ȡֹʱ
        ///// </summary>
        ///// <returns></returns>
        //private DateTime GetEarliestEndTime()
        //{
        //    DateTime endtime = DateTime.MaxValue;
        //    DateTime jzendtime = DateTime.MaxValue;
        //    DateTime jlendtime = DateTime.MaxValue;
        //    Database database = DBSetting.Instance.GetDataBase("lotdb");
        //    SqlConnection conn = null;
        //    try
        //    {
        //        conn = new SqlConnection(database.ConnectionString);
        //        conn.Open();
        //        string sql = "select min(e_apiendtime) from jz_expect with(nolock) where e_apiendtime>getdate()";
        //        object obj = SqlHelper.ExecuteScalar(conn, CommandType.Text, sql);
        //        if (obj != DBNull.Value)
        //        {
        //            jzendtime = Convert.ToDateTime(obj);
        //        }
        //        sql = "select min(e_apiendtime) from jl_expect with(nolock) where e_apiendtime>getdate()";
        //        obj = SqlHelper.ExecuteScalar(conn, CommandType.Text, sql);
        //        if (obj != DBNull.Value)
        //        {
        //            jlendtime = Convert.ToDateTime(obj);
        //        }
        //        endtime = jzendtime < jlendtime ? jzendtime : jlendtime;
        //    }
        //    finally
        //    {
        //        if (conn != null)
        //        {
        //            conn.Close();
        //        }
        //    }
        //    return endtime;
        //}

        ///// <summary>
        ///// ǷɨƱ
        ///// </summary>
        //public void SetIsScan(L_LotTicketEntity ticketEntity, M_MachineEntity MachineInfo)
        //{
        //    bool isusescanner = false;
        //    MachineType machineType = (MachineType)MachineInfo.M_Type;
        //    if(ticketEntity.LotId==911 ||ticketEntity.LotId==951||ticketEntity.LotId==971)
        //    {
        //        isusescanner = true;
        //        if (MachineInfo.M_InputDeviceType == (int)InputDeviceType.Scanner)
        //        {
        //            if (ticketEntity.LotId == (int)Lottype.Jz || ticketEntity.LotId == (int)Lottype.Jl)
        //            {
        //                //Ͷעĳθ
        //                int changcinum = ticketEntity.L_Code.Split('/').Length;
        //                Playtype playtype = (Playtype)ticketEntity.L_PlayId;

        //                if (machineType == MachineType.JsTiCai || machineType == MachineType.HnTiCai || machineType == MachineType.JxJingCaiV1)
        //                {
        //                    //ſ8Ͷע
        //                    switch (playtype)
        //                    {
        //                        case Playtype.JzSPF:
        //                            //ʤƽ3ء6ء8Ͷע(ɰͶע)
        //                            break;
        //                        case Playtype.JzRQSPF:
        //                            //ʤƽ3ء6ء8Ͷע(8Ч)
        //                            break;
        //                        case Playtype.JzBF:
        //                            //ȷֽ3Ͷע
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JzJQS:
        //                            //ܽ3ء6Ͷע
        //                            if (changcinum > 6)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JzBQC:
        //                            //ȫ3Ͷע
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JlRFSF:
        //                            //÷ʤƽ3ء6ء8Ͷע
        //                            break;
        //                        case Playtype.JlSF:
        //                            //ʤƽ3ء6ء8Ͷע
        //                            break;
        //                        case Playtype.JlSFC:
        //                            //ʤֲ3Ͷע
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JlDXF:
        //                            //С3ء6ء8Ͷע
        //                            break;
        //                        case Playtype.JzHHGG:
        //                            //Ϲذȷ֡ȫû3Ͷעȷ֡ȫû6Ͷע
        //                            if (changcinum > 6)
        //                            {
        //                                if (ticketEntity.L_Code.IndexOf("91102") > -1 || ticketEntity.L_Code.IndexOf("91103") > -1 || ticketEntity.L_Code.IndexOf("91104") > -1)
        //                                {
        //                                    isusescanner = false;
        //                                }
        //                            }
        //                            else
        //                            {
        //                                //°촮ͶעѾֱ֧ȷ
        //                                /*if (ticketEntity.L_Code.IndexOf("91102") > -1)
        //                                {
        //                                    //бȷֻ֣õһϹͶע 3 8ϵʱòˣ
        //                                    if (ticketEntity.L_Code.IndexOf("91101") > -1)
        //                                    {
        //                                        isusescanner = false;
        //                                    }
        //                                }*/
        //                                //ȷ֡ȫû3Ͷע
        //                                if (ticketEntity.L_Code.IndexOf("91102") > -1 || ticketEntity.L_Code.IndexOf("91104") > -1)
        //                                {
        //                                    if (changcinum > 3)
        //                                    {
        //                                        isusescanner = false;
        //                                    }
        //                                }
        //                            }

        //                            break;
        //                        case Playtype.JlHHGG:
        //                            //Ϲذʤֲû3Ͷע
        //                            if (ticketEntity.L_Code.IndexOf("95103") > -1)
        //                            {
        //                                if (changcinum > 3)
        //                                {
        //                                    isusescanner = false;
        //                                }
        //                            }
        //                            break;
        //                    }
        //                }
        //                else
        //                {
        //                    //ɰͶע°--촮°Ͷעȫþɰ
        //                    switch (playtype)
        //                    {
        //                        case Playtype.JzSPF:
        //                            //ʤƽ3ء6ء8Ͷע(ɰͶע)
        //                            break;
        //                        case Playtype.JzRQSPF:
        //                            //ʤƽ3ء6ء8Ͷע(8Ч)
        //                            if (changcinum > 6)
        //                            {
        //                                isusescanner = false;
        //                            }

        //                            break;
        //                        case Playtype.JzBF:
        //                            //ȷֽ3Ͷע
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JzJQS:
        //                            //ܽ3ء6Ͷע
        //                            if (changcinum > 6)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JzBQC:
        //                            //ȫ3Ͷע
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JlRFSF:
        //                            //÷ʤƽ3ء6ء8Ͷע
        //                            break;
        //                        case Playtype.JlSF:
        //                            //ʤƽ3ء6ء8Ͷע
        //                            break;
        //                        case Playtype.JlSFC:
        //                            //ʤֲ3Ͷע
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                        case Playtype.JlDXF:
        //                            //С3ء6ء8Ͷע
        //                            break;
        //                        case Playtype.JzHHGG:
        //                            //Ϲذȷ֡ȫû3Ͷע
        //                            /*if (ticketEntity.L_Code.IndexOf("91102") > -1 || ticketEntity.L_Code.IndexOf("91104") > -1)
        //                            {
        //                                if (changcinum > 3)
        //                                {
        //                                    isusescanner = false;
        //                                }
        //                            }
        //                            if (changcinum > 6)
        //                            {
        //                                //8Ͷע
        //                                isusescanner = false;
        //                            }*/
        //                            /*isusescanner = false;*/

        //                            if (changcinum > 6)
        //                            {
        //                                //8Ͷע
        //                                isusescanner = false;

        //                            }
        //                            else
        //                            {
        //                                if (ticketEntity.L_Code.IndexOf("91102") > -1)
        //                                {
        //                                    //бȷֻ֣õһϹͶע 3 8ϵʱòˣ
        //                                    //if (ticketEntity.L_Mutiple > 8 && changcinum <= 3)
        //                                    //{
        //                                    //    isusescanner = false;
        //                                    //}
        //                                    if (ticketEntity.L_Code.IndexOf("91101") > -1)
        //                                    {
        //                                        isusescanner = false;
        //                                    }
        //                                }
        //                                //ȷ֡ȫû3Ͷע
        //                                if (ticketEntity.L_Code.IndexOf("91102") > -1 || ticketEntity.L_Code.IndexOf("91104") > -1)
        //                                {
        //                                    if (changcinum > 3)
        //                                    {
        //                                        isusescanner = false;
        //                                    }
        //                                }
        //                            }

        //                            break;
        //                        case Playtype.JlHHGG:
        //                            //Ϲذʤֲû3Ͷע
        //                            if (ticketEntity.L_Code.IndexOf("95103") > -1)
        //                            {
        //                                if (changcinum > 3)
        //                                {
        //                                    isusescanner = false;
        //                                }
        //                            }
        //                            if (changcinum > 6)
        //                            {
        //                                //8ͶעʱЧԭ
        //                                isusescanner = false;
        //                            }
        //                            break;
        //                    }
        //                }


        //                //°Ͷע
        //                /*switch (playtype)
        //                {
        //                    case Playtype.JzSPF:
        //                        //ʤƽ3ء6ء8Ͷע
        //                        if (changcinum > 6)
        //                        {
        //                            //8ͶעʱЧԭ
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JzBF:
        //                        //ȷֽ3Ͷע
        //                        if (changcinum > 3)
        //                        {
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JzJQS:
        //                        //ܽ3ء6Ͷע
        //                        if (changcinum > 6)
        //                        {
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JzBQC:
        //                        //ȫ3Ͷע
        //                        if (changcinum > 3)
        //                        {
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JlRFSF:
        //                        //÷ʤƽ3ء6ء8Ͷע
        //                        if (changcinum > 6)
        //                        {
        //                            //8ͶעʱЧԭ
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JlSF:
        //                        //ʤƽ3ء6ء8Ͷע
        //                        if (changcinum > 6)
        //                        {
        //                            //8ͶעʱЧԭ
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JlSFC:
        //                        //ʤֲ3Ͷע
        //                        if (changcinum > 3)
        //                        {
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JlDXF:
        //                        //С3ء6ء8Ͷע
        //                        if (changcinum > 6)
        //                        {
        //                            //8ͶעʱЧԭ
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JzHHGG:
        //                        //Ϲذȷ֡ȫû3Ͷע
        //                        if (ticketEntity.L_Code.IndexOf("91102") > -1 || ticketEntity.L_Code.IndexOf("91104") > -1)
        //                        {
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                        }
        //                        if (changcinum > 6)
        //                        {
        //                            //8Ͷע
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                    case Playtype.JlHHGG:
        //                        //Ϲذʤֲû3Ͷע
        //                        if (ticketEntity.L_Code.IndexOf("95103") > -1)
        //                        {
        //                            if (changcinum > 3)
        //                            {
        //                                isusescanner = false;
        //                            }
        //                        }
        //                        if (changcinum > 6)
        //                        {
        //                            //8ͶעʱЧԭ
        //                            isusescanner = false;
        //                        }
        //                        break;
        //                }*/
        //            }
        //            else if (ticketEntity.LotId == (int)Lottype.Jm)
        //            {
        //                isusescanner = false;
        //            }
        //            else
        //            {
        //                isusescanner = false;
        //            }
        //        }
        //        else
        //        {
        //            isusescanner = false;
        //        }

        //        //ʴƱʱɨƱ
        //        //if(ticketEntity.L_Money>=500)
        //        //{
        //        //    isusescanner = false;
        //        //}
        //    }
        //    //else if(ticketEntity.LotId==(int)Lottype.Lt)
        //    //{
        //    //    if (MachineInfo.M_InputDeviceType == (int)InputDeviceType.Scanner)
        //    //    {
        //    //        if(machineType == MachineType.HnTiCai || machineType == MachineType.JxTiCaiMachineV2)
        //    //        {
        //    //            isusescanner = true;
        //    //            if(ticketEntity.L_PlayId==(int)Playtype.LtDt || ticketEntity.L_PlayId==(int)Playtype.LtZhuiJiaDt)
        //    //            {
        //    //                isusescanner = false;
        //    //            }
        //    //        }
        //    //    }
        //    //    else
        //    //    {
        //    //        isusescanner = false;
        //    //    }
        //    //}

        //    ticketEntity.IsUseScanner = isusescanner;
        //}
        private void SetIsClearExpect(L_LotTicketEntity ticketEntity)
        {
            bool isclearexpect = false;
            if (ticketEntity.LotId == 911 || ticketEntity.LotId == 951 || ticketEntity.LotId == 971)
            {
                if (ticketEntity.IsUseScanner)
                {
                    if (DateTime.Now.Subtract(LastClearExpectTime).TotalSeconds > JcClearExpectInterval)
                    {
                        isclearexpect = true;
                        LastClearExpectTime = DateTime.Now;
                    }
                }
                else
                {
                    //̳Ʊÿڸ
                    isclearexpect = true;
                    LastClearExpectTime = DateTime.Now;
                }

            }
            ticketEntity.IsClearExpect = isclearexpect;
        }
        public void RePrint(L_LotTicketEntity ticketEntity)
        {
            lock (WaitPrintTickets)
            {
                L_LotTicketEntity[] tickets = WaitPrintTickets.ToArray();
                WaitPrintTickets.Clear();
                WaitPrintTickets.Enqueue(ticketEntity);
                foreach (L_LotTicketEntity entity in tickets)
                {
                    WaitPrintTickets.Enqueue(entity);
                }
            }
        }

        public bool ReGetdataForBatch()
        {
            try
            {
                if (CurrentTicket != null)
                {
                    DecodePrintData decodePrintData = new DecodePrintData();
                    ReGetdata(CurrentTicket, decodePrintData);
                    if (decodePrintData.DecodeSuccess)
                    {
                        Wait4Job.Set();
                        OnErrorCleared();
                    }
                    return decodePrintData.DecodeSuccess;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception exception)
            {
                LotMachine.Log.Info(string.Concat("»ȡʧܡϢ", exception));
                return false;
            }
        }



        private void Wait(int wait)
        {
            LotMachine.Log.Debug(string.Concat("ȴ", wait, ""));
            while (wait > 0)
            {
                wait -= 100;
                Thread.Sleep(100);
                if (LotMachine.MachineInfo.M_Status != (int)MachineStatusEnum.Printing)
                {
                    break;
                }
            }
        }
        public void OnPrinting(L_LotTicketEntity ticket)
        {
            if (Printing != null)
            {
                Printing(this, new TicketEventArgs(ticket));
            }
        }
        public void OnPrinted(L_LotTicketEntity ticket)
        {
            if (Printed != null)
            {
                Printed(this, new TicketEventArgs(ticket));
            }
        }
        public void OnAmountCleared()
        {
            if (AmountCleared != null)
            {
                AmountCleared(this, new EventArgs());
            }
        }
        public void OnErrorCleared()
        {
            if (ErrorCleared != null)
            {
                ErrorCleared(this, new EventArgs());
            }
        }

        //private List<L_LotTicketEntity> CreateTestTicketList()
        //{
        //    List<L_LotTicketEntity> list = new List<L_LotTicketEntity>();
        //    for (int i = 0; i < MaxOneLoad; i++)
        //    {
        //        Random random = new Random();
        //        L_LotTicketEntity ticket = new L_LotTicketEntity();
        //        ticket.L_TicketSn = random.Next(10000000, 999999999).ToString();
        //        ticket.L_TicketCode = random.Next(90000000, 999999999).ToString();
        //        ticket.L_Code = string.Concat(random.Next(1, 220000) % 22, ",", random.Next(1, 220000) % 22, ",", random.Next(1, 220000) % 22, ",", random.Next(1, 220000) % 22, ",", random.Next(1, 220000) % 22);
        //        ticket.L_OrderSn = string.Concat(random.Next(11000, 99999), "XW", random.Next(1000000, 9999999));
        //        ticket.L_Mutiple = random.Next(1, 99);
        //        ticket.L_Money = ticket.L_Mutiple * 10;
        //        ticket.LotId = 705;
        //        ticket.L_PlayId = 70501;
        //        ticket.MacLotId = 705;
        //        ticket.MacPlayId = 70501;
        //        ticket.MacModeId = 7050101;
        //        list.Add(ticket);
        //    }
        //    return list;
        //}

        //private void CreateTestPrintTicket(L_LotTicketEntity ticket, DecodePrintData decodePrintData)
        //{
        //    Random random = new Random();
        //    decodePrintData.L_PrintTicketEntity.P_AddTime = DateTime.Now;
        //    decodePrintData.L_PrintTicketEntity.P_Code = ticket.L_Code;
        //    decodePrintData.L_PrintTicketEntity.P_Expect = ticket.L_Expect;
        //    decodePrintData.L_PrintTicketEntity.P_Lid = ticket.L_Id;
        //    decodePrintData.L_PrintTicketEntity.P_Money = ticket.L_Money;
        //    decodePrintData.L_PrintTicketEntity.P_Mutiple = ticket.L_Mutiple;
        //    decodePrintData.L_PrintTicketEntity.P_Password = random.Next(111111, 999999).ToString();
        //    decodePrintData.L_PrintTicketEntity.P_RandomCode = random.Next(111111, 999999).ToString();
        //    decodePrintData.L_PrintTicketEntity.P_TicketCode = random.Next(90000000, 999999999).ToString();
        //    decodePrintData.L_PrintTicketEntity.P_SingleZhuShu = ticket.L_SingleZhuShu;
        //    decodePrintData.L_PrintTicketEntity.P_SucTime = DateTime.Now;
        //    decodePrintData.DecodeSuccess = true;
        //}

        ///// <summary>
        ///// ֲʽֹǰ4ԶתƳƱ
        ///// </summary>
        //private bool AutoTransferTaskOfDlc(int lotId,out int waitTransferTicketNum,out int transferedTicketNum)
        //{
        //    waitTransferTicketNum = 0;
        //    transferedTicketNum = 0;
        //    try
        //    {
        //        //int lotId = (int) Lottype.Dl;
        //        L_ExpectService expectService=new L_ExpectService();
        //        L_ExpectEntity expect = expectService.GetActiveExpect(lotId);
        //        if (DateTime.Now > expect.E_ApiEndTime.AddMinutes(-4))
        //        {
        //            //ǰڽֹǰ4

        //            //1.ûƱټ
        //            //Forbid();

        //            //2.ѷƱתڳƱٵĻ
        //            L_LotTicketService lotTicketService = new L_LotTicketService();
        //            List<L_LotTicketEntity> waitTranferTickets = lotTicketService.GetWaitTransferTicketList(lotId, LotMachine.MachineInfo.M_Number, 0);
        //            if (waitTranferTickets == null || waitTranferTickets.Count == 0)
        //            {
        //                LotMachine.Log.Info(string.Concat("ûҪתƵƱ"));
        //                return false;
        //            }
        //            waitTransferTicketNum = waitTranferTickets.Count;
        //            LotMachine.Log.Info(string.Concat("пתƵƱ ", waitTranferTickets.Count, " "));

        //            List<M_MachineEntity> desMachineList = new List<M_MachineEntity>();
        //            M_MachineService machineService = new M_MachineService();
        //            List<M_MachineEntity> machineList = machineService.GetMachineList();
        //            machineList.Sort(delegate(M_MachineEntity mac1, M_MachineEntity mac2)
        //            { return mac1.M_TicketNum.CompareTo(mac2.M_TicketNum); });
        //            foreach (M_MachineEntity entity in machineList)
        //            {
        //                if(entity.M_Number==LotMachine.MachineInfo.M_Number)
        //                {
        //                    continue;
        //                }

        //                if (entity.M_Status == (int)MachineStatusEnum.Printing && entity.M_IsUse)
        //                {
        //                    if (desMachineList.Contains(entity))
        //                    {
        //                        continue;
        //                    }
        //                    desMachineList.Add(entity);
        //                }
        //            }
        //            if (desMachineList.Count < 1)
        //            {
        //                LotMachine.Log.Error("ǰûпõĻţ");
        //                return true;
        //            }

        //            foreach (L_LotTicketEntity ticket in waitTranferTickets)
        //            {
        //                if(ticket.L_PrintNum>1)
        //                {
        //                    LotMachine.Log.Warn(string.Concat("ˮţ",ticket.L_TicketSn," תƴ2ΣԶת"));
        //                    continue;
        //                }
        //                if (ticket.L_Money > 500)
        //                {
        //                    LotMachine.Log.Warn(string.Concat("ˮţ", ticket.L_TicketSn, " 500ԪԶת"));
        //                    continue;
        //                }

        //                bool isTransfered = false;
        //                while (desMachineList.Count >= 1)
        //                {
        //                    M_MachineEntity targetMachine = desMachineList[0];
        //                    if (targetMachine.M_Money < ticket.L_Money)
        //                    {
        //                        desMachineList.RemoveAt(0);
        //                        LotMachine.Log.Warn(string.Concat("תƱ[", ticket.L_TicketSn, "]ɹƱ[", targetMachine.M_Number, "]㡣򽫳Ʊתơ"));
        //                        continue;
        //                    }
        //                    string macNumber = ticket.L_MacNumber;
        //                    ticket.L_MacNumber = targetMachine.M_Number;

        //                    try
        //                    {
        //                        lotTicketService.TransferTaskLottickets(ticket.LotId, ticket.L_Id, macNumber, targetMachine.M_Number);
        //                        targetMachine.M_TicketNum += 1;
        //                        transferedTicketNum++;
        //                        desMachineList.RemoveAt(0);
        //                        desMachineList.Add(targetMachine);
        //                        isTransfered = true;
        //                        LotMachine.Log.Info(string.Concat("תƱɹ[", ticket.L_LotName, "] 淨[", ticket.L_PlayName, "] [", ticket.L_Money.ToString("0"), "] ˮ[" + ticket.L_TicketSn + "] ӲƱ[", LotMachine.MachineInfo.M_Number, "]Ʊ[", targetMachine.M_Number, "]"));
        //                    }
        //                    catch (Exception ex)
        //                    {
        //                        LotMachine.Log.Error(string.Concat("תƱ[", ticket.L_TicketSn, "] 쳣", ex.Message));
        //                        continue;
        //                    }
        //                    break;
        //                }
        //                if (!isTransfered)
        //                {
        //                    LotMachine.Log.Warn(string.Concat("תƱ[", ticket.L_TicketSn, "]ɹзĲƱ㡣ֵˢ»ȡ"));
        //                }
        //            }
        //        }
        //    }
        //    catch (Exception exception)
        //    {
        //        LotMachine.Log.Warn(string.Concat("ֹǰԶƱ쳣Ϣ",exception));
        //    }
        //    return true;
        //}

        private void ReportError(L_LotTicketEntity ticket, DecodePrintData decodePrintData, string errorTitle, string errorMessage)
        {
            //_status = MachineStatusEnum.Error;
            LastSucTicket = null;
            try
            {
                if (null != PrintTicketError)
                {
                    //L_LotTicketEntity entity = ticket.Clone() as L_LotTicketEntity;
                    PrintTicketError(this, new ErrorTicketEventArgs(ticket, decodePrintData, errorTitle));
                }
                int waitTransferTicketNum = 0;
                int transferedTicketNum = 0;
                bool isAutoTransfer = false;

                //if(ticket.LotId==(int)Lottype.Dl)
                //{
                //    isAutoTransfer = AutoTransferTaskOfDlc(out waitTransferTicketNum, out transferedTicketNum);
                //}

                //if (ticket.LotId == (int)Lottype.Dl || ticket.LotId == (int)Lottype.Hd || ticket.LotId == (int)Lottype.Jd || ticket.LotId == (int)Lottype.Xs)
                //{
                //    isAutoTransfer = AutoTransferTaskOfDlc(ticket.LotId, out waitTransferTicketNum, out transferedTicketNum);
                //}

                //ÿղƱͶעģʽлͶעģʽ
                LotMachine.MacCurrentMode = null;

                //»״̬
                LotMachine.MachineInfo.M_Status = (int)MachineStatusEnum.Error;
                LotMachine.MachineInfo.M_LastErrorTitle = isAutoTransfer ? "ԶתƱ" + transferedTicketNum + "" : errorTitle;
                LotMachine.MachineInfo.M_LastErrorTime = DateTime.Now;
                LotMachine.MachineInfo.M_ErrorNum += 1;

                this.UpdateMachineErrorInfoAndStatus();
                //M_MachineService machineService = new M_MachineService();
                //LotMachine.Log.Debug("»Ϣʼ");
                //machineService.UpdateMachineErrorInfo(LotMachine.MachineInfo);
                //LotMachine.Log.Debug("»Ϣ");
                //this.UpdateMachineStatus(MachineStatusEnum.Error);

                //try
                //{
                //    M_MachineErrorEntity errorEntity = new M_MachineErrorEntity();
                //    errorEntity.L_ErrorMessage = errorMessage;
                //    errorEntity.L_ErrorTime = DateTime.Now;
                //    errorEntity.L_ErrorTitle = errorTitle;
                //    errorEntity.L_TicketSn = ticket.L_TicketSn;
                //    errorEntity.L_LotId = ticket.LotId;
                //    errorEntity.L_MacNumber = LotMachine.MachineInfo.M_Number;
                //    //errorEntity.L_Type = 0;
                //    //M_MachineErrorService errorService=new M_MachineErrorService();
                //    //errorService.Add(errorEntity);
                //}
                //catch (Exception exception)
                //{
                //    LotMachine.Log.Info("¼Ϣ쳣Ϣ" + exception.Message);
                //}

                ////ԶƱ
                ////if (decodePrintData!=null && decodePrintData.InputData.CaptureDataBytes.Length > 60)
                //if (decodePrintData != null && decodePrintData.InputData.CaptureDataBytes.Length > 60)
                //{
                //    HasErrorTicket = true;
                //    LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, decodePrintData.InputData.CaptureDataBytes);

                //    //¼ƱϢݿ
                //ƱƱļ
                string errorticketFilePath = FileService.GetErrorTicketFilePath(LotMachine.MachineInfo.M_Number, ticket.L_TicketSn + "_" + DateTime.Now.ToString("yyyyMMddHHmmss"));
                File.WriteAllText(errorticketFilePath, decodePrintData.L_PrintTicketEntity.P_PrnText);
                LotMachine.Log.Info("Ʊļ");
                //LotMachine.Log.Info(string.Concat("Ʊļ", errorticketFilePath));
                //    //LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, errorticketFilePath, true);
                //    ////ƱϢƱ
                //    //L_ErrorTicketService errorTicketService = new L_ErrorTicketService();
                //    //errorTicketService.AddErrorTicket(ticket, decodePrintData.L_PrintTicketEntity);
                //    LotMachine.Log.Info(string.Concat("ƱϢ⣬ӡƱļ", errorticketFilePath));

                //    //try
                //    //{
                //    //    ChuPiao.Common.Communication.CpdJson.Packs.P12014PrintTicketFile reqPack = new ChuPiao.Common.Communication.CpdJson.Packs.P12014PrintTicketFile();
                //    //    reqPack.MacNumber = LotMachine.MachineInfo.M_Number;
                //    //    reqPack.PrnText =
                //    //        HexStringUtil.ByteToString(decodePrintData.InputData.CaptureDataBytes);
                //    //    ChuPiao.Common.Communication.CpdJson.PackRetBase packRetBase = ChuPiao.Common.Communication.CpdJson.PackManager.Instance.Transaction(LotMachine.MachineInfo.M_Number, reqPack);
                //    //    if (packRetBase == null)
                //    //    {
                //    //        throw new Exception(string.Concat("ִʧܡţ", LotMachine.MachineInfo.M_Number));
                //    //    }
                //    //    if (packRetBase.ReturnCode != 0)
                //    //    {
                //    //        throw new Exception(string.Concat("Ʊش룺", packRetBase.ReturnCode, " Ϣ", packRetBase.ReturnMessage));
                //    //    }
                //    //}
                //    //catch (Exception ex1)
                //    //{
                //    //    LotMachine.Log.Error(string.Concat("ӡƱļ쳣",ex1));
                //    //}
                //}

                LotMachine.Log.Info(string.Concat("", errorTitle));
            }
            catch (Exception exc)
            {
                LotMachine.Log.Error("Ʊ߳вƱʱ»״̬쳣" + exc.Message);
            }
            //LotMachine.Log.Error(string.Concat("Ʊ߳쳣", ex.Message, Environment.NewLine, ex.StackTrace));
            //LotMachine.Log.Error(string.Concat("Ʊ쳣Ϣ", ex));

            Wait4Job.Reset();
            Wait4Job.WaitOne();
        }
        /// <summary>
        /// ά״̬
        /// </summary>
        /// <param name="status"></param>
        public void UpdateMachineErrorInfoAndStatus()
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)LotMachine.MachineInfo.M_Status;
                //M_MachineService machineService = new M_MachineService();
                ////LotMachine.Log.Info(string.Concat("ݿϢ״̬", status, "ʼ"));
                ////Thread.Sleep(1*60*1000);
                //machineService.UpdateMachineErrorInfo(LotMachine.MachineInfo);
                //LotMachine.Log.Info(string.Concat("ݿϢ״̬", status, ""));
                OnStatusChanged(status);
            }
            catch (Exception exception)
            {
                LotMachine.Log.Info(string.Concat("»Ϣ״̬쳣Ϣ", exception.Message));
            }
        }
        /// <summary>
        /// ά״̬
        /// </summary>
        /// <param name="status"></param>
        public void UpdateMachineStatus(MachineStatusEnum status)
        {
            int status_bak = LotMachine.MachineInfo.M_Status;
            try
            {
                LotMachine.MachineInfo.M_Status = (int)status;
                //M_MachineService machineService = new M_MachineService();
                ////LotMachine.Log.Debug(string.Concat("ݿ״̬", status, "ʼ"));
                //machineService.UpdateMachineStatus(LotMachine.MachineInfo);
                //LotMachine.Log.Debug(string.Concat("ݿ״̬", status, ""));
                OnStatusChanged(status);
            }
            catch (Exception exception)
            {
                LotMachine.Log.Info(string.Concat("»״̬", status, "쳣Ϣ", exception.Message));
                LotMachine.MachineInfo.M_Status = status_bak;
                throw exception;
            }

        }
        private ErrorProcessEnum _result;
        public ErrorProcessEnum Result
        {
            get
            {
                return _result;
            }
            set
            {
                _result = value;
            }
        }
        public decimal TotalMoney = 0;
        public int TotalTicket = 0;

        //public DecodeMachinePayMoneyReport PrintPayMoneyReport()
        //{
        //    DecodeMachinePayMoneyReport report=new DecodeMachinePayMoneyReport();
        //    LotMachine.PrintPayMoneyReport(report,true);
        //    return report;
        //}

        public void OnStatusChanged(MachineStatusEnum machineStatus)
        {
            EventHandler<MachineStatusArgs> handler = StatusChanged;
            if (handler != null)
            {
                handler(this, new MachineStatusArgs(machineStatus));
            }
        }

        public void UpdateMachineMoney()
        {
            DecodeMachinePayMoneyReport decodePrintData = new DecodeMachinePayMoneyReport();
            LotMachine.PrintPayMoneyReport(decodePrintData, false);

            if (decodePrintData.DecodeSuccess)
            {
                A10006UploadMachineBalance pack = new A10006UploadMachineBalance();
                pack.AgentId = LotMachine.MachineInfo.M_Number;
                pack.Salt = LotMachine.MachineInfo.M_Salt;

                pack.Balance = decodePrintData.MachinePayMoneyReportEntity.R_Balance;
                pack.QueryTime = decodePrintData.MachinePayMoneyReportEntity.R_QueryTime.ToString("yyyyMMddHHmmss");

                //
                MachineReportTime reportTime = MachineReportTimeList.GetCurrentTime(1);
                pack.From = reportTime.From.ToString("yyyyMMdd");
                pack.To = reportTime.To.ToString("yyyyMMdd");
                pack.Type = 1;
                pack.TypeName = reportTime.ValueMember;
                pack.Prntext = decodePrintData.MachinePayMoneyReportEntity.R_PrnText;

                A10006UploadMachineBalanceRet packRet = PackManager.Instance.Send(pack) as A10006UploadMachineBalanceRet;
                if (packRet.Code <= 0)
                {
                    LotMachine.Log.Warn(LotMachine.MachineInfo.M_Number + " ϴɿʧܣԣ");
                    throw new Exception("ϴɿеʧܣ" + packRet.Code.ToString() + " " + packRet.Message);
                    
                }

                DateTime now = DateTime.Now.AddHours(-7);
                //
                reportTime = MachineReportTimeList.GetCurrentTime(2);
                if (reportTime.To.ToShortDateString() == now.ToShortDateString())
                {
                    pack.From = reportTime.From.ToString("yyyyMMdd");
                    pack.To = reportTime.To.ToString("yyyyMMdd");
                    pack.Type = 2;
                    pack.TypeName = reportTime.ValueMember;

                    packRet = PackManager.Instance.Send(pack) as A10006UploadMachineBalanceRet;
                    if (packRet.Code <= 0)
                    {
                        LotMachine.Log.Warn(LotMachine.MachineInfo.M_Number + " ϴɿʧܣԣ");
                        throw new Exception("ϴɿеʧܣ" + packRet.Code.ToString() + " " + packRet.Message);

                    }
                }
                //
                reportTime = MachineReportTimeList.GetCurrentTime(3);
                if (reportTime.To.ToShortDateString() == now.ToShortDateString())
                {
                    pack.From = reportTime.From.ToString("yyyyMMdd");
                    pack.To = reportTime.To.ToString("yyyyMMdd");
                    pack.Type = 3;
                    pack.TypeName = reportTime.ValueMember;

                    packRet = PackManager.Instance.Send(pack) as A10006UploadMachineBalanceRet;
                    if (packRet.Code <= 0)
                    {
                        LotMachine.Log.Warn(LotMachine.MachineInfo.M_Number + " ϴɿʧܣԣ");
                        throw new Exception("ϴɿеʧܣ" + packRet.Code.ToString() + " " + packRet.Message);

                    }
                }

                if (decodePrintData.MachinePayMoneyReportEntity.R_DataList.Count > 0)
                {
                    A10007UploadMachinePay pack1 = new A10007UploadMachinePay();
                    pack1.AgentId = LotMachine.MachineInfo.M_Number;
                    pack1.Salt = LotMachine.MachineInfo.M_Salt;

                    pack1.QueryTime = decodePrintData.MachinePayMoneyReportEntity.R_QueryTime;
                    foreach (PayMoneyDataItem item in decodePrintData.MachinePayMoneyReportEntity.R_DataList)
                    {
                        pack1.PaymentList.Add(new UploadMachinePayItem(item.PayType, item.PayMoney, item.PayTime,item.Fee));
                    }

                    A10007UploadMachinePayRet packRet1 = PackManager.Instance.Send(pack1) as A10007UploadMachinePayRet;
                    if (packRet1.Code <= 0)
                    {
                        LotMachine.Log.Warn(LotMachine.MachineInfo.M_Number + " ϴɿʧܣԣ");
                        throw new Exception("ϴɿеĽɿ¼ʧܣ" + packRet1.Code.ToString() + " " + packRet1.Message);

                    }
                }

                LotMachine.Log.Info(LotMachine.MachineInfo.M_Number + " ϴɿɹ");

            }
            else
            {
                LotMachine.Log.Warn(LotMachine.MachineInfo.M_Number + " ϴɿʧܣԣ");
                throw new Exception(string.Concat("ɿʧܡϢ", decodePrintData.ErrorMessage));
                
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="typename">-20130101 -201301-1 201301</param>
        /// <param name="from"></param>
        /// <param name="to"></param>
        public void PrintDayReport(int type,string typename,DateTime from,DateTime to)
        {
            DecodeMachineReport decodeMachineReport = new DecodeMachineReport();
            LotMachine.PrintReport(from, to, decodeMachineReport, false);

            if (decodeMachineReport.DecodeSuccess)
            {
                A10005UploadMachineSale pack = new A10005UploadMachineSale();
                pack.AgentId = LotMachine.MachineInfo.M_Number;
                pack.Salt = LotMachine.MachineInfo.M_Salt;

                pack.SaleMoney = decodeMachineReport.MachineReportEntity.R_SaleMoney;
                pack.SaleNum = decodeMachineReport.MachineReportEntity.R_SaleTicket;
                pack.EncashMoney = decodeMachineReport.MachineReportEntity.R_EncashMoney;
                pack.EncashNum = decodeMachineReport.MachineReportEntity.R_EncashTicket;
                pack.ReturnMoney = decodeMachineReport.MachineReportEntity.R_ReturnMoney;
                pack.ReturnNum = decodeMachineReport.MachineReportEntity.R_ReturnTicket;
                pack.QueryTime = decodeMachineReport.MachineReportEntity.R_QueryTime.ToString("yyyyMMddHHmmss");
                pack.From = decodeMachineReport.MachineReportEntity.R_StartTime.ToString("yyyyMMdd");
                pack.To = decodeMachineReport.MachineReportEntity.R_EndTime.ToString("yyyyMMdd");
                pack.Type = type;
                pack.TypeName = typename; 
                pack.Prntext = decodeMachineReport.MachineReportEntity.R_PrnText;

                A10005UploadMachineSaleRet packRet = PackManager.Instance.Send(pack) as A10005UploadMachineSaleRet;
                if (packRet.Code <= 0)
                {
                    LotMachine.Log.Warn(LotMachine.MachineInfo.M_Number + " ϴʱαʧܣԣ");
                    throw new Exception("ϴʱαʧܣ" + packRet.Code.ToString() + " " + packRet.Message);
                    
                }

                LotMachine.Log.Info(LotMachine.MachineInfo.M_Number + " ϴʱαɹ");

            }
            else
            {
                LotMachine.Log.Warn(LotMachine.MachineInfo.M_Number + " ϴʱαʧܣԣ");
                throw new Exception(string.Concat("ʱαʧܡϢ", decodeMachineReport.ErrorMessage));
                
            }

        }

        /// <summary>
        /// ϼֵ
        /// </summary>
        public void ClearAmount()
        {
            try
            {
                LotMachine.ClearMahineMoney();
                TotalTicket = 0;
                TotalMoney = 0;
                OnAmountCleared();
            }
            catch (Exception exception)
            {
                LotMachine.Log.Info(string.Concat("ƱϼʧܡϢ", exception));
            }

        }
        /// <summary>
        /// 
        /// </summary>
        public void ClearError(int errorType)
        {
            try
            {
                if (CurrentTicket != null)
                {
                    //StopSync();
                    LotMachine.ClearError(errorType);
                    //Wait(3000);
                    //Start();
                    OnErrorCleared();
                }
            }
            catch (Exception exception)
            {
                LotMachine.Log.Info(string.Concat("ƱʧܡϢ", exception));
            }
        }


        public void GetAndPrintLastTicket()
        {
            try
            {
                LotMachine.Log.Info("ȡһƱ");
                CaptureDataInfo dataInfo = LotMachine.GetCacheTicket();
                if (dataInfo == null)
                {
                    return;
                }
                if (dataInfo.CaptureDataBytes.Length == 0)
                {
                    dataInfo = LotMachine.GetLastTicket();
                }
                if (dataInfo == null)
                {
                    return;
                }
                if (dataInfo.CaptureDataBytes.Length > 0)
                {
                    LotMachine.Log.Info("ӡһƱ");
                    LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, dataInfo.CaptureDataBytes);
                }
            }
            catch (Exception exception)
            {
                LotMachine.Log.Info(string.Concat("ӡһŵƱʧܡϢ", exception));
            }
        }


        public bool StopSync()
        {
            bool success = false;
            MachineStatusEnum status = (MachineStatusEnum)LotMachine.MachineInfo.M_Status;
            if (status == MachineStatusEnum.Printing || status == MachineStatusEnum.Error)
            {
                Stop();
                Wait4Job.Set();//ĻҲֹͣ
                int waitTime = 0;
                while (waitTime < 30000)
                {
                    status = (MachineStatusEnum)LotMachine.MachineInfo.M_Status;
                    if (status == MachineStatusEnum.Stopped)
                    {
                        success = true;
                        break;
                    }
                    Thread.Sleep(100);
                    waitTime += 100;
                }
            }
            else if (status == MachineStatusEnum.Stopped)
            {
                success = true;
            }
            return success;
        }


        ///// <summary>
        ///// תƳƱ
        ///// </summary>
        //public int TransferTasks()
        //{
        //    int _minMachineMoney = 2000;
        //    try
        //    {
        //        M_MachineEntity machine = this.LotMachine.MachineInfo;
        //        M_MachinePlayService _machinePlayService = new M_MachinePlayService();
        //        List<M_MachinePlayEntity> machinePlayEntityList = _machinePlayService.GetMachineLotListByMid(machine);
        //        if (null != machinePlayEntityList && machinePlayEntityList.Count > 0)
        //        {
        //            L_LotTicketService _lotTicketService = new L_LotTicketService();
        //            M_MachineService _machineService = new M_MachineService();
        //            foreach (M_MachinePlayEntity entity in machinePlayEntityList)
        //            {
        //                List<L_LotTicketEntity> waitTranferTickets = _lotTicketService.GetWaitTransferTicketList(entity.P_LotId, machine.M_Number, entity.P_PlayId);
        //                if (waitTranferTickets.Count == 0)
        //                {
        //                    this.LotMachine.Log.Info(string.Concat(LotPlayTypeHashTable.LotTypeHashTable[entity.P_LotId], LotPlayTypeHashTable.PlayTypeHashTable[entity.P_PlayId], "ûҪתƵƱ"));
        //                    continue;
        //                }
        //                this.LotMachine.Log.Info(string.Concat(LotPlayTypeHashTable.LotTypeHashTable[entity.P_LotId], LotPlayTypeHashTable.PlayTypeHashTable[entity.P_PlayId], "пתƵƱ ", waitTranferTickets.Count, " "));
        //                List<M_MachineEntity> machineList = _machineService.GetEnableAndUseMachineList(entity.P_LotId, entity.P_PlayId);

        //                if (machineList.Count <= 0)
        //                {
        //                    this.LotMachine.Log.Warn(string.Concat(LotPlayTypeHashTable.LotTypeHashTable[entity.P_LotId], LotPlayTypeHashTable.PlayTypeHashTable[entity.P_PlayId], "ƱûпɹתƵĲƱ...",
        //                                       "ȷ", LotPlayTypeHashTable.LotTypeHashTable[entity.P_LotId], LotPlayTypeHashTable.PlayTypeHashTable[entity.P_PlayId], "ĿɳƱƱ"));
        //                    continue;
        //                }
        //                int transferedTicketNum = 0;
        //                foreach (L_LotTicketEntity ticket in waitTranferTickets)
        //                {
        //                    machineList.Sort(delegate(M_MachineEntity mac1, M_MachineEntity mac2) { return mac1.M_TicketNum.CompareTo(mac2.M_TicketNum); });
        //                    bool isTransfered = false;
        //                    while (machineList.Count >= 1)
        //                    {
        //                        M_MachineEntity targetMachine = machineList[0];
        //                        if (targetMachine.M_Money < _minMachineMoney)
        //                        {
        //                            machineList.RemoveAt(0);
        //                            this.LotMachine.Log.Warn(string.Concat("תƱ", ticket.L_TicketSn, "ɹƱ", targetMachine.M_Number, "㡣򽫳Ʊתơ"));
        //                            continue;
        //                        }
        //                        string macNumber = ticket.L_MacNumber;
        //                        ticket.L_MacNumber = targetMachine.M_Number;
        //                        targetMachine.M_TicketNum += 1;
        //                        transferedTicketNum++;
        //                        try
        //                        {
        //                            _lotTicketService.TransferTaskLottickets(ticket.LotId, ticket.L_Id, macNumber, targetMachine.M_Number);
        //                        }
        //                        catch (Exception ex)
        //                        {
        //                            this.LotMachine.Log.Error(string.Concat("תƱ", ticket.L_TicketSn, "쳣", ex.Message));
        //                            continue;
        //                        }
        //                        isTransfered = true;
        //                        this.LotMachine.Log.Info(string.Concat("תƱ" + ticket.L_TicketSn + "ӲƱ", machine.M_Number, "ɹתƵƱ", targetMachine.M_Number));
        //                        break;
        //                    }
        //                    if (!isTransfered)
        //                    {
        //                        this.LotMachine.Log.Warn(string.Concat("תƱ", ticket.L_TicketSn, "ɹзĲƱ㡣ֵˢ»ȡ"));
        //                    }
        //                }
        //                this.LotMachine.Log.Info(string.Concat(LotPlayTypeHashTable.LotTypeHashTable[entity.P_LotId], LotPlayTypeHashTable.PlayTypeHashTable[entity.P_PlayId], "ɹתƵƱ ", transferedTicketNum, " "));
        //            }
        //        }
        //        else
        //        {
        //            this.LotMachine.Log.Info(string.Concat("Ʊ ", machine.M_Number, " ûÿɳƱ͡"));
        //        }
        //        return (int)(WcfCodeEnum.TransferTasksSucess);
        //    }
        //    catch (Exception ex)
        //    {
        //        this.LotMachine.Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "תƳƱ", this.LotMachine.MachineInfo.M_Number, ex.Message, ex.StackTrace));
        //        return (int)(WcfCodeEnum.TransferTasksException);
        //    }
        //}

        //public void TransferTasks(List<M_MachineEntity> machineList)
        //{
        //    M_LotTypeService lotTypeService=new M_LotTypeService();
        //    List<M_LotTypeEntity> lotTypeList = lotTypeService.GetEnabledLotTypeList();
        //    foreach (M_LotTypeEntity lotTypeEntity in lotTypeList)
        //    {
        //        int transferedTicketNum = 0;
        //        if(lotTypeEntity.L_LotId==(int)Lottype.Bd)
        //        {
        //            //תƱ
        //            BdL_LotTicketService bdLotTicketService=new BdL_LotTicketService();
        //            List<L_LotTicketEntity> waitTranferTickets =
        //                bdLotTicketService.GetWaitTransferTicketList(lotTypeEntity.L_LotId,
        //                                                             LotMachine.MachineInfo.M_Number, 0);
        //            if (waitTranferTickets == null || waitTranferTickets.Count == 0)
        //            {
        //                LotMachine.Log.Info(string.Concat(lotTypeEntity.L_LotName, "ûҪתƵƱ"));
        //                continue;
        //            }
        //            foreach (L_LotTicketEntity ticket in waitTranferTickets)
        //            {
        //                M_MachineEntity targetMachine = null;
        //                for (int i = 0; i < machineList.Count; i++)
        //                {
        //                    M_MachineEntity machine = machineList[i];
        //                    if (machine.M_Money < ticket.L_Money)
        //                    {
        //                        continue;
        //                    }
        //                    targetMachine = machine;
        //                    machineList.RemoveAt(i);
        //                    machineList.Add(machine);
        //                    break;
        //                }
        //                if (targetMachine == null)
        //                {
        //                    LotMachine.Log.Warn(string.Concat("תƱ[", ticket.L_TicketSn, "]ɹĿ"));
        //                    continue;
        //                }
        //                string macNumber = ticket.L_MacNumber;
        //                string targetMacNumber = targetMachine.M_Number;
        //                ticket.L_MacNumber = targetMacNumber;

        //                try
        //                {
        //                    bdLotTicketService.TransferTicket(ticket.LotId, ticket.L_Id, macNumber, targetMacNumber);
        //                    targetMachine.M_TicketNum += 1;
        //                    transferedTicketNum++;
        //                    LotMachine.Log.Info(string.Concat("תƱɹ[", ticket.L_LotName, "] 淨[", ticket.L_PlayName, "] [", ticket.L_Money.ToString("0"), "] ˮ[" + ticket.L_TicketSn + "] ӲƱ[", macNumber, "]Ʊ[", targetMacNumber, "]"));
        //                }
        //                catch (Exception ex)
        //                {
        //                    LotMachine.Log.Error(string.Concat("תƱ[", ticket.L_TicketSn, "] 쳣", ex.Message));
        //                    continue;
        //                }
        //            }
        //        }
        //        else if (lotTypeEntity.L_LotId == (int)Lottype.Jz || lotTypeEntity.L_LotId == (int)Lottype.Jl || lotTypeEntity.L_LotId == (int)Lottype.Jm)
        //        {
        //            //תƱ
        //            JcL_LotTicketService jcLotTicketService=new JcL_LotTicketService();
        //            List<L_LotTicketEntity> waitTranferTickets=jcLotTicketService.GetWaitTransferTicketList(lotTypeEntity.L_LotId, LotMachine.MachineInfo.M_Number,
        //                                                         0);
        //            if(waitTranferTickets==null || waitTranferTickets.Count==0)
        //            {
        //                LotMachine.Log.Info(string.Concat(lotTypeEntity.L_LotName, "ûҪתƵƱ"));
        //                continue;
        //            }
        //            foreach (L_LotTicketEntity ticket in waitTranferTickets)
        //            {
        //                M_MachineEntity targetMachine = null;
        //                for (int i = 0; i < machineList.Count; i++)
        //                {
        //                    M_MachineEntity machine = machineList[i];
        //                    if(machine.M_Money<ticket.L_Money)
        //                    {
        //                        continue;
        //                    }
        //                    targetMachine = machine;
        //                    machineList.RemoveAt(i);
        //                    machineList.Add(machine);
        //                    break;
        //                }
        //                if(targetMachine==null)
        //                {
        //                    LotMachine.Log.Warn(string.Concat("תƱ[", ticket.L_TicketSn, "]ɹĿ"));
        //                    continue;
        //                }
        //                string macNumber = ticket.L_MacNumber;
        //                string targetMacNumber = targetMachine.M_Number;
        //                ticket.L_MacNumber = targetMacNumber;

        //                try
        //                {
        //                    jcLotTicketService.TransferTicket(ticket.LotId, ticket.L_Id, macNumber, targetMacNumber);
        //                    targetMachine.M_TicketNum += 1;
        //                    transferedTicketNum++;
        //                    LotMachine.Log.Info(string.Concat("תƱɹ[", ticket.L_LotName, "] 淨[", ticket.L_PlayName, "] [", ticket.L_Money.ToString("0"), "] ˮ[" + ticket.L_TicketSn + "] ӲƱ[", macNumber, "]Ʊ[", targetMacNumber, "]"));
        //                }
        //                catch (Exception ex)
        //                {
        //                    LotMachine.Log.Error(string.Concat("תƱ[", ticket.L_TicketSn, "] 쳣", ex.Message));
        //                    continue;
        //                }
        //            }
        //        }
        //        else
        //        {
        //            //ʼֲתƱ
        //            L_LotTicketService lotTicketService = new L_LotTicketService();
        //            List<L_LotTicketEntity> waitTranferTickets = lotTicketService.GetWaitTransferTicketList(lotTypeEntity.L_LotId, LotMachine.MachineInfo.M_Number, 0);
        //            if (waitTranferTickets == null || waitTranferTickets.Count == 0)
        //            {
        //                LotMachine.Log.Info(string.Concat(lotTypeEntity.L_LotName, "ûҪתƵƱ"));
        //                continue;
        //            }
        //            LotMachine.Log.Info(string.Concat(lotTypeEntity.L_LotName, "пתƵƱ ", waitTranferTickets.Count, " "));

        //            //waitTranferTickets.Sort(delegate(L_LotTicketEntity ticket1, L_LotTicketEntity ticket2)
        //            //                            { return ticket1.L_Money.CompareTo(ticket2.L_Money); });



        //            foreach (L_LotTicketEntity ticket in waitTranferTickets)
        //            {
        //                //machineList.Sort(delegate(M_MachineEntity mac1, M_MachineEntity mac2) { return mac1.M_TicketNum.CompareTo(mac2.M_TicketNum); });
        //                bool isTransfered = false;
        //                while (machineList.Count >= 1)
        //                {
        //                    M_MachineEntity targetMachine = machineList[0];
        //                    if (targetMachine.M_Money < ticket.L_Money)
        //                    {
        //                        machineList.RemoveAt(0);
        //                        LotMachine.Log.Warn(string.Concat("תƱ[", ticket.L_TicketSn, "]ɹƱ[", targetMachine.M_Number, "]㡣򽫳Ʊתơ"));
        //                        continue;
        //                    }
        //                    string macNumber = ticket.L_MacNumber;
        //                    ticket.L_MacNumber = targetMachine.M_Number;

        //                    try
        //                    {
        //                        lotTicketService.TransferTaskLottickets(ticket.LotId, ticket.L_Id, macNumber, targetMachine.M_Number);
        //                        targetMachine.M_TicketNum += 1;
        //                        transferedTicketNum++;
        //                        machineList.RemoveAt(0);
        //                        machineList.Add(targetMachine);
        //                        isTransfered = true;
        //                        LotMachine.Log.Info(string.Concat("תƱɹ[", ticket.L_LotName, "] 淨[", ticket.L_PlayName, "] [", ticket.L_Money.ToString("0"), "] ˮ[" + ticket.L_TicketSn + "] ӲƱ[", LotMachine.MachineInfo.M_Number, "]Ʊ[", targetMachine.M_Number, "]"));
        //                    }
        //                    catch (Exception ex)
        //                    {
        //                        LotMachine.Log.Error(string.Concat("תƱ[", ticket.L_TicketSn, "] 쳣", ex.Message));
        //                        continue;
        //                    }
        //                    break;
        //                }
        //                if (!isTransfered)
        //                {
        //                    LotMachine.Log.Warn(string.Concat("תƱ[", ticket.L_TicketSn, "]ɹзĲƱ㡣ֵˢ»ȡ"));
        //                }
        //            }
        //        }
        //        LotMachine.Log.Info(string.Concat(lotTypeEntity.L_LotName, "ɹתƵƱ ", transferedTicketNum, " "));
        //        LoggingService.Info(string.Concat("", LotMachine.MachineInfo.M_Number, "", lotTypeEntity.L_LotName, "ɹתƵƱ ", transferedTicketNum, " "));
        //    }
        //}

        ///// <summary>
        ///// û
        ///// </summary>
        //public int Forbid()
        //{
        //    try
        //    {
        //        M_MachineService _machineService = new M_MachineService();
        //        LotMachine.MachineInfo.M_IsUse = false;
        //        //_machineService.Update(LotMachine.MachineInfo);
        //        _machineService.UpdateIsUse(LotMachine.MachineInfo);
        //        LotMachine.Log.Info("ûɹ");
        //        return (int)(WcfCodeEnum.SetNotUseSucess);
        //    }
        //    catch (Exception ex)
        //    {
        //        this.LotMachine.Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "û", this.LotMachine.MachineInfo.M_Number, ex.Message, ex.StackTrace));
        //        return (int)(WcfCodeEnum.SetNotUseException);
        //    }
        //}
        /// <summary>
        /// û
        /// </summary>
        public bool UseMachine()
        {
            try
            {
                //M_MachineService _machineService = new M_MachineService();
                //LotMachine.MachineInfo.M_IsUse = true;
                ////_machineService.Update(LotMachine.MachineInfo);
                //_machineService.UpdateIsUse(LotMachine.MachineInfo);
                //LotMachine.Log.Info("ûɹ");
                return true;
            }
            catch (Exception ex)
            {
                this.LotMachine.Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "û", this.LotMachine.MachineInfo.M_Number, ex.Message, ex.StackTrace));
                return false;
            }
        }
        /// <summary>
        /// ¼
        /// </summary>
        public bool ReloadConfig()
        {
            try
            {
                //M_MachineConfigService machineConfigService = new M_MachineConfigService();
                //M_MachineModeConfigService machineModeConfigService = new M_MachineModeConfigService();
                //LotMachine.MachineInfo.MachineConfigEntity = machineConfigService.GetMachineConfig(LotMachine.MachineInfo.M_Id);
                //LotMachine.MachineInfo.MachineModeConfigs = machineModeConfigService.GetMachineConfigSortedDictionary(LotMachine.MachineInfo.M_Id);
                //this.LotMachine.Log.Info("¼óɹ");
                return true;
            }
            catch (Exception exception)
            {
                this.LotMachine.Log.Info(string.Concat("¼쳣Ϣ", exception.Message));
                return false;
            }
        }

        public void PrintTestTicket()
        {
            try
            {
                CaptureDataInfo captureData = LotMachine.PrintTestTicket(true);
                //if(captureData.CaptureDataBytes.Length>0)
                //{
                //    if (LotMachineService.IsUseComputerPrinter)
                //    {
                //        //LotMachineService.PrintETicket(LotMachine.MachineInfo.M_Number, captureData.CaptureDataBytes);
                //        LotMachineService.PrinterClient.AddBytes(captureData.CaptureDataBytes);
                //    }
                //}
            }
            catch (Exception exception)
            {
                this.LotMachine.Log.Error(string.Concat("ӡƱ쳣Ϣ", exception));
            }
        }
    }
}
