using System;
using System.IO;
using System.Text;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using ChuPiao.Common.Utils;
using ChuPiao.Common.Core.Security;

namespace ChuPiao.Common.Communication.GtdJson
{
    /// <summary>
    /// Ϣ
    /// </summary>
    public abstract class PackRetBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="strpack"></param>
        public void UnPack(string strpack)
        {
            JObject jo = (JObject)JsonConvert.DeserializeObject(strpack);
            JToken head = jo["head"];
            AgentId = head["agentId"].ToString();
            MessageId = head["msgId"].ToString();
            Timestamp = head["timestamp"].ToString();
            string sign = head["sign"].ToString();
            JToken body = jo["body"];

            //body.ToString();    //{\r\n  \"message\": \"Ʊȡ\",\r\n  \"status\": \"301\"\r\n}      bodyȥʱ򣬻ԴʽԲַʽȥȡbodyַ

            //ǰǩ鲻ͲýˣевͨҪȽ
            int index_start = strpack.IndexOf("\"body\":"); body.ToString();
            int index_end = strpack.IndexOf("}}", index_start);
            string bodystr = strpack.Substring(index_start + 7, index_end - index_start - 7 + 1);   //{"lotId":911}
            Logger.Log.Debug(string.Format("{0} <--{1}", AgentId, bodystr));

            bodystr = bodystr.Replace(" ", "#*#*#");   //ոתǰǰ滻һ£Ժ˵û취˵unicodeͽMD5ģǵɣ
            bodystr = GetUnicode(bodystr);
            bodystr = bodystr.Replace("#*#*#", " ");

            string enstr = string.Format("{0}{1}{2}{3}{4}", MessageId, AgentId, Timestamp, Salt, bodystr);   //û취˵unicodeͽMD5ģǵɣ
            string tosign = MD5Util.Encrypt(enstr, Encoding.GetEncoding("utf-8"));
            if (sign != tosign)
            {
                throw new Exception("󣬰Уʧ-" + enstr);

            }
            UnPackBody(body);
        }

        protected string GetUnicode(string text)
        {
            string result = "";
            for (int i = 0; i < text.Length; i++)
            {
                if ((int)text[i] > 32 && (int)text[i] < 127)
                {
                    result += text[i].ToString();
                }
                else
                    result += string.Format("\\u{0:x4}", (int)text[i]);
            }
            return result;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="body"></param>
        public abstract void UnPackBody(JToken body);


        #region 

        /// <summary>
        /// վ
        /// </summary>
        public string AgentId
        {
            get { return _agentId; }
            set { _agentId = value; }
        }

        ///<summary>
        ///Կ
        ///</summary>
        public string Salt
        {
            get { return _salt; }
            set { _salt = value; }
        }
        /// <summary>
        /// ϢID
        /// </summary>
        public string MessageId
        {
            get { return _messageId; }
            set { _messageId = value; }
        }
        /// <summary>
        /// ʱ
        /// </summary>
        public string Timestamp
        {
            get { return _timestamp; }
            set { _timestamp = value; }
        }

        private string _salt = "";
        private string _messageId = "";
        private string _timestamp = "";
        private string _agentId = "";
        #endregion
    }
}
