using System;
using System.Collections.Generic;
using System.Text;
using ChuPiao.Common.Enums;

namespace ChuPiao.Common.Communication.CpdJson.Packs
{
    /// <summary>
    /// Ͷע빤
    /// </summary>
    public class CodeUtil
    {
        /// <summary>
        /// Ͷע
        /// </summary>
        /// <param name="playId"></param>
        /// <param name="code"></param>
        /// <returns></returns>
        public static List<JcOneMatchCodeEntity> JcCodeSplit(int playId,string code)
        {
            //ȷּ촮еıȷֺʽת
            if(playId==91102 || playId==91199)
            {
                code=code.Replace("ʤ", "9:0").Replace("ƽ", "9:9").Replace("", "0:9");
            }
            List<JcOneMatchCodeEntity> result=new List<JcOneMatchCodeEntity>();
            string[] arr = code.Split('/');
            foreach (string s in arr)
            {
                result.Add(new JcOneMatchCodeEntity(s));
            }
            return result;
        }

        /// <summary>
        /// ʺת
        /// </summary>
        /// <param name="lotId"></param>
        /// <param name="playId"></param>
        /// <param name="code"></param>
        /// <returns></returns>
        public static string CgCodeConvert(int lotId,int playId,string code)
        {
            string result = code;
            Lottype lottype = (Lottype) lotId;
            switch (lottype)
            {
                case Lottype.Sf:
                    result = code.Replace("|", ",");
                    break;
                case Lottype.Xs:
                    result = code.Replace("$", ",");
                    break;
            }
            return result;
        }
    }
    /// <summary>
    /// ĳεͶע
    /// </summary>
    public class JcOneMatchCodeEntity
    {
        public JcOneMatchCodeEntity(string oneMatchCode)
        {
            //4001[0]/4002[1,0]/4003[0]/4004[3]
            //700491103[1,2,3]/700691101[3]/702191101[0]/703091101[3]
            int index1 = oneMatchCode.IndexOf('');
            int index2 = oneMatchCode.IndexOf('[');
            int index3 = oneMatchCode.IndexOf(']');
            _match = oneMatchCode.Substring(0, index1);
            if(index2-index1>1)
            {
                //촮淨
                _playId = int.Parse(oneMatchCode.Substring(index1 + 1, index2 - index1 - 1));
            }
            _code = oneMatchCode.Substring(index2 + 1, index3 - index2 - 1);
        }
        public JcOneMatchCodeEntity(string match,string code,int? playId)
        {
            _match = match;
            _code = code;
            _playId = playId;
        }
        public JcOneMatchCodeEntity()
        {
            
        }
        private string _match="";
        private string _code="";
        private int ? _playId;

        public string Match
        {
            get { return _match; }
            set { _match = value; }
        }

        public string Code
        {
            get { return _code; }
            set { _code = value; }
        }

        public int? PlayId
        {
            get { return _playId; }
            set { _playId = value; }
        }
        public override string ToString()
        {
            return string.Format("{0}{1}[{2}]",_match,_playId.HasValue?_playId.ToString():"",_code);
        }
    }
}
