using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace ChuPiao.Common.Utils
{
    public class ComPortAPI
    {
        public string PortNum;
        public int BaudRate;
        public byte ByteSize;
        public byte Parity; // 0-4=no,odd,even,mark,space 
        public byte StopBits; // 0,1,2 = 1, 1.5, 2 
        public int ReadTimeout;
        //comm port win32 file handle
        private int hComm = -1;
        public bool Opened = false;
        //win32 api constants
        private const uint GENERIC_READ = 0x80000000;
        private const uint GENERIC_WRITE = 0x40000000;
        private const int OPEN_EXISTING = 3;
        private const int INVALID_HANDLE_VALUE = -1;
        [StructLayout(LayoutKind.Sequential)]
        public struct DCB
        {
            //taken from c struct in platform sdk 
            public int DCBlength; // sizeof(DCB) 
            public int BaudRate; // ָǰ current baud rate
            // these are the c struct bit fields, bit twiddle flag to set
            public int fBinary; // ָǷģʽ,windows95бTRUE binary mode, no EOF check 
            public int fParity; // ָǷżУ enable parity checking 
            public int fOutxCtsFlow; // ָCTSǷڼⷢͿƣΪTRUECTSΪOFFͽ CTS output flow control 
            public int fOutxDsrFlow; // ָCTSǷڼⷢͿ DSR output flow control 
            public int fDtrControl; // DTR_CONTROL_DISABLEֵDTRΪOFF, DTR_CONTROL_ENABLEֵDTRΪON, DTR_CONTROL_HANDSHAKEDTR"" DTR flow control type 
            public int fDsrSensitivity; // ֵΪTRUEʱDSRΪOFFʱյֽڱ DSR sensitivity 
            public int fTXContinueOnXoff; // ָջ,ѾͳXoffCharַʱǷֹͣTRUEʱڽջյֽXoffLimѾͳXoffCharַֹֽ֮󣬷ͼСFALSEʱڽջյѿյֽXonCharѾͳָ͵XonChar֮󣬷ͼСXOFF continues Tx 
            public int fOutX; // TRUEʱյXoffCharֹ֮ͣͽյXonChar֮¿ʼ XON/XOFF out flow control 
            public int fInX; // TRUEʱջյXoffLim֮XoffCharͳȥջյյXonLim֮XonCharͳȥ XON/XOFF in flow control 
            public int fErrorChar; // ֵΪTRUEfParityΪTRUEʱErrorChar ԱַָżУĽַ enable error replacement 
            public int fNull; // eTRUEʱʱȥգ0ֵֽ enable null stripping 
            public int fRtsControl; // RTS flow control 
            /*RTS_CONTROL_DISABLEʱ,RTSΪOFF
              RTS_CONTROL_ENABLEʱ, RTSΪON
               RTS_CONTROL_HANDSHAKEʱ,
               ջСڰʱRTSΪON
                ջķ֮ʱRTSΪOFF
               RTS_CONTROL_TOGGLEʱ,
               ջʣֽʱRTSΪON ,ȱʡΪOFF*/
            public int fAbortOnError; // TRUEʱ,дʱֹд abort on error 
            public int fDummy2; // δʹ reserved
            public uint flags;
            public ushort wReserved; // δʹ,Ϊ0 not currently used 
            public ushort XonLim; // ָXONַǰջпСֽ transmit XON threshold 
            public ushort XoffLim; // ָXOFFַǰջпСֽ transmit XOFF threshold 
            public byte ByteSize; // ָ˿ڵǰʹõλ number of bits/byte, 4-8 
            public byte Parity; // ָ˿ڵǰʹõżУ鷽,Ϊ:EVENPARITY,MARKPARITY,NOPARITY,ODDPARITY 0-4=no,odd,even,mark,space 
            public byte StopBits; // ָ˿ڵǰʹõֹͣλ,Ϊ:ONESTOPBIT,ONE5STOPBITS,TWOSTOPBITS 0,1,2 = 1, 1.5, 2 
            public char XonChar; // ָڷͺͽַXONֵ Tx and Rx XON character 
            public char XoffChar; // ָڷͺͽַXOFFֵ Tx and Rx XOFF character 
            public char ErrorChar; // ַյżУ鷢ʱֵ error replacement character 
            public char EofChar; // ûʹöģʽʱ,ַָʾݵĽ end of input character 
            public char EvtChar; // յַʱ,һ¼ received event character 
            public ushort wReserved1; // δʹ reserved; do not use 
        }
        [StructLayout(LayoutKind.Sequential)]
        private struct COMMTIMEOUTS
        {
            public int ReadIntervalTimeout;
            public int ReadTotalTimeoutMultiplier;
            public int ReadTotalTimeoutConstant;
            public int WriteTotalTimeoutMultiplier;
            public int WriteTotalTimeoutConstant;
        }
        [StructLayout(LayoutKind.Sequential)]
        private struct OVERLAPPED
        {
            public int Internal;
            public int InternalHigh;
            public int Offset;
            public int OffsetHigh;
            public int hEvent;
        }
        [DllImport("kernel32.dll")]
        private static extern int CreateFile(
        string lpFileName, // Ҫ򿪵Ĵ
        uint dwDesiredAccess, // ָڵķʷʽһΪɶдʽ
        int dwShareMode, // ָڵĹģʽڲܹΪ0
        int lpSecurityAttributes, // ôڵİȫԣWIN9X²֧֣ӦΪNULL
        int dwCreationDisposition, // ڴͨţʽֻΪOPEN_EXISTING
        int dwFlagsAndAttributes, // ָ־ΪFILE_FLAG_OVERLAPPED(صI/O)ָ첽ʽͨ
        int hTemplateFile // ڴͨűΪNULL
        );
        [DllImport("kernel32.dll")]
        private static extern bool GetCommState(
        int hFile, //ͨ豸
        ref DCB lpDCB // 豸ƿDCB
        );
        [DllImport("kernel32.dll")]
        private static extern bool BuildCommDCB(
        string lpDef, // 豸ַ
        ref DCB lpDCB // 豸ƿ
        );
        [DllImport("kernel32.dll")]
        private static extern bool SetCommState(
        int hFile, // ͨ豸
        ref DCB lpDCB // 豸ƿ
        );
        [DllImport("kernel32.dll")]
        private static extern bool GetCommTimeouts(
        int hFile, // ͨ豸 handle to comm device
        ref COMMTIMEOUTS lpCommTimeouts // ʱʱ time-out values
        );
        [DllImport("kernel32.dll")]
        private static extern bool SetCommTimeouts(
        int hFile, // ͨ豸 handle to comm device
        ref COMMTIMEOUTS lpCommTimeouts // ʱʱ time-out values
        );
        [DllImport("kernel32.dll")]
        private static extern bool ReadFile(
        int hFile, // ͨ豸 handle to file
        byte[] lpBuffer, // ݻ data buffer
        int nNumberOfBytesToRead, // ֽڵȴȡ number of bytes to read
        ref int lpNumberOfBytesRead, // ȡֽ number of bytes read
        ref OVERLAPPED lpOverlapped //  overlapped buffer
        );
        [DllImport("kernel32.dll")]
        private static extern bool WriteFile(
        int hFile, // ͨ豸 handle to file
        byte[] lpBuffer, // ݻ data buffer
        int nNumberOfBytesToWrite, // ֽڵȴд number of bytes to write
        ref int lpNumberOfBytesWritten, // Ѿдֽ number of bytes written
        ref OVERLAPPED lpOverlapped //  overlapped buffer
        );
        [DllImport("kernel32.dll")]
        private static extern bool CloseHandle(
        int hObject // handle to object
        );
        [DllImport("kernel32.dll")]
        private static extern uint GetLastError();
        public void Open()
        {
            DCB dcbCommPort = new DCB();
            COMMTIMEOUTS ctoCommPort = new COMMTIMEOUTS();
            // 򿪴 OPEN THE COMM PORT.
            hComm = CreateFile(PortNum, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
            // ûд򿪣ʹ IF THE PORT CANNOT BE OPENED, BAIL OUT.
            if (hComm == INVALID_HANDLE_VALUE)
            {
                throw (new ApplicationException("Ƿܴ򿪴ڣ"));
            }
            // ͨųʱʱ SET THE COMM TIMEOUTS.
            GetCommTimeouts(hComm, ref ctoCommPort);
            ctoCommPort.ReadTotalTimeoutConstant = ReadTimeout;
            ctoCommPort.ReadTotalTimeoutMultiplier = 0;
            ctoCommPort.WriteTotalTimeoutMultiplier = 0;
            ctoCommPort.WriteTotalTimeoutConstant = 0;
            SetCommTimeouts(hComm, ref ctoCommPort);
            // ô SET BAUD RATE, PARITY, WORD SIZE, AND STOP BITS.
            GetCommState(hComm, ref dcbCommPort);
            dcbCommPort.BaudRate = BaudRate;
            dcbCommPort.flags = 0;
            //dcb.fBinary=1;
            dcbCommPort.flags |= 1;
            if (Parity > 0)
            {
                //dcb.fParity=1
                dcbCommPort.flags |= 2;
            }
            dcbCommPort.Parity = Parity;
            dcbCommPort.ByteSize = ByteSize;
            dcbCommPort.StopBits = StopBits;
            if (!SetCommState(hComm, ref dcbCommPort))
            {
                //uint ErrorNum=GetLastError();
                throw (new ApplicationException("Ƿܴ򿪴ڣ"));
            }
            //unremark to see if setting took correctly
            //DCB dcbCommPort2 = new DCB();
            //GetCommState(hComm, ref dcbCommPort2);
            Opened = true;
        }
        public void Close()
        {
            if (hComm != INVALID_HANDLE_VALUE)
            {
                CloseHandle(hComm);
            }
        }
        public byte[] Read(int NumBytes)
        {
            byte[] BufBytes;
            byte[] OutBytes;
            BufBytes = new byte[NumBytes];
            if (hComm != INVALID_HANDLE_VALUE)
            {
                OVERLAPPED ovlCommPort = new OVERLAPPED();
                int BytesRead = 0;
                ReadFile(hComm, BufBytes, NumBytes, ref BytesRead, ref ovlCommPort);
                OutBytes = new byte[BytesRead];
                Array.Copy(BufBytes, OutBytes, BytesRead);
            }
            else
            {
                throw (new ApplicationException("δ򿪣"));
            }
            return OutBytes;
        }
        public void Write(byte[] WriteBytes)
        {
            if (hComm != INVALID_HANDLE_VALUE)
            {
                OVERLAPPED ovlCommPort = new OVERLAPPED();
                int BytesWritten = 0;
                WriteFile(hComm, WriteBytes, WriteBytes.Length, ref BytesWritten, ref ovlCommPort);
            }
            else
            {
                throw (new ApplicationException("δ򿪣"));
            }
        }
    }
    class HexCon
    {
        // ʮַתֽͺͰֽתʮַ converter hex string to byte and byte to hex string
        public static string ByteToString(byte[] InBytes)
        {
            string StringOut = "";
            foreach (byte InByte in InBytes)
            {
                StringOut = StringOut + String.Format("{0:X2} ", InByte);
            }
            return StringOut;
        }
        public static byte[] StringToByte(string InString)
        {
            string[] ByteStrings;
            ByteStrings = InString.Split(" ".ToCharArray());
            byte[] ByteOut;
            ByteOut = new byte[ByteStrings.Length - 1];
            for (int i = 0; i == ByteStrings.Length - 1; i++)
            {
                ByteOut[i] = Convert.ToByte(("0x" + ByteStrings[i]));
            }
            return ByteOut;
        }
    }
    //class send
    //{
    //    /// 
    //    /// Ӧóڵ㡣
    //    /// 
    //    [STAThread]
    //    static void Main(string[] args)
    //    {
    //        //
    //        // TODO: ڴ˴ӴӦó
    //        //
    //        ComPortAPI ss_port = new ComPortAPI();
    //        ss_port.PortNum = "COM1"; //˿ں
    //        ss_port.BaudRate = 19200; //ͨŲ
    //        ss_port.ByteSize = 8; //λ
    //        ss_port.Parity = 0; //żУ
    //        ss_port.StopBits = 1;//ֹͣλ
    //        ss_port.ReadTimeout = 1000; //ʱ
    //        try
    //        {
    //            if (ss_port.Opened)
    //            {
    //                ss_port.Close();
    //                ss_port.Open(); //򿪴
    //            }
    //            else
    //            {
    //                ss_port.Open();//򿪴
    //            }
    //            //return true;
    //        }
    //        catch (Exception e)
    //        {
    //            Console.WriteLine("" + e.Message);
    //            //return false;
    //        }
    //        try
    //        {
    //            ss_port.Write(System.Text.Encoding.Default.GetBytes("xxxxxxxxxxxxx"));
    //        }
    //        catch (Exception e)
    //        {
    //            Console.WriteLine("" + e.Message);
    //            //return false;
    //        }
    //        Console.WriteLine("");
    //        Console.ReadLine();
    //    }
    //}
}



