using System;
using System.Collections.Generic;
using System.Text;
using System.IO.Ports;
using System.Threading;
using System.Net;

namespace ChuPiao.Common.Utils
{
    public class ComPortServer
    {
        public ComPortServer(string port, int portBps, Encoding encoding)
        {
            _port = port;
            _portBps = portBps;
            _com = new SerialPort(_port, _portBps, Parity.None);

            _charset = encoding;
        }

        private Encoding _charset;
        private SerialPort _com;
        private string _port;
        private int _portBps;

        private Thread _workThread;

        /// <summary>
        /// 
        /// </summary>
        public void Start()
        {
            try
            {
                if (_com == null)
                {
                    _com = new SerialPort(_port, _portBps, Parity.None);
                }
                if (!_com.IsOpen)
                {
                    _com.Open();
                }

                _workThread = new Thread(new ThreadStart(DoTask));
                _workThread.Start();
            }
            catch (Exception exception)
            {
                throw new Exception(string.Concat("쳣", exception.Message));
            }

        }

        /// <summary>
        /// ֹͣ
        /// </summary>
        public void Stop()
        {
            if (_com != null)
            {
                if (_com.IsOpen)
                {
                    _com.Close();
                }
                _com.Dispose();
            }
        }

        /// <summary>
        /// Ϣ
        /// </summary>
        /// <param name="message"></param>
        private void Send(string message)
        {
            byte[] contentData = _charset.GetBytes(message);
            //ΪBitConverter.GetBytesǰСֽתbyte飬ֽǴֽԽת
            byte[] headerData = BitConverter.GetBytes(IPAddress.HostToNetworkOrder(contentData.Length));
            _com.Write(headerData, 0, headerData.Length);
            _com.Write(contentData, 0, contentData.Length);
        }

        /// <summary>
        /// ȡظϢ
        /// </summary>
        /// <returns></returns>
        private string Read()
        {
            string content = string.Empty;
            byte[] buffer = new byte[4];
            _com.Read(buffer, 0, buffer.Length);
            //ΪBitConverter.GetBytesǰСֽתbyte飬ֽǴֽԽת
            int contentLength = IPAddress.NetworkToHostOrder(BitConverter.ToInt32(buffer, 0));
            if (contentLength > 0)
            {
                byte[] contentData = new byte[contentLength];

                int offset = 0;
                int num = 0;
                do
                {
                    num = _com.Read(contentData, offset, contentLength - offset);
                    offset += num;
                } while (num > 0 && offset < contentLength);
                if (offset != contentLength)
                {
                    throw new Exception("װʵʽݳȲ");
                }
                content = _charset.GetString(contentData);
            }
            return content;
        }

        /// <summary>
        /// ύ
        /// </summary>
        /// <param name="requestMsg"></param>
        /// <returns></returns>
        public string CommitRequest(string requestMsg)
        {
            lock (this)
            {
                try
                {
                    Start();
                    Send(requestMsg);
                    return Read();
                }
                catch (Exception e)
                {
                    throw new Exception(string.Concat("ͨѶ쳣", e));
                }
            }
        }

        /// <summary>
        /// ִݽ
        /// </summary>
        private void DoTask()
        {
            try
            {
                while (true)
                {
                    Thread.Sleep(100);
                    int bytesToRead = _com.BytesToRead;
                    if (bytesToRead > 0)
                    {
                        string rec = Read();
                        Console.WriteLine("recieve:" + rec);
                        string ret = "return:" + rec;
                        Send(ret);
                        Console.WriteLine(ret);
                    }

                }
            }
            catch (Exception ex)
            {
                throw new Exception(string.Concat("ͨѶ쳣", ex));
            }


        }

    }
}
