using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;
using System.Text;

namespace ChuPiao.Common.Utils
{
    /// <summary>
    /// GZipѹѹ
    /// </summary>
    public class GZipUtil
    {
        /// <summary> 
        /// byteѹ 
        /// </summary> 
        /// <param name="data">ѹbyte</param> 
        /// <returns>ѹbyte</returns> 
        public static byte[] Compress(byte[] data)
        {
            using (MemoryStream ms = new MemoryStream())
            {
                using (GZipStream zip=new GZipStream(ms ,CompressionMode.Compress,true))
                {
                    zip.Write(data,0,data.Length);
                    zip.Close();
                    byte[] buffer = new byte[ms.Length];
                    ms.Position = 0;
                    ms.Read(buffer, 0, buffer.Length);
                    ms.Close();
                    return buffer;
                }
            }
        }
        /// <summary>
        /// byteнѹ 
        /// </summary>
        /// <param name="data">ѹbyte</param>
        /// <returns>ѹbyte</returns>
        public static byte[] Decompress(byte[] data)
        {
            using (MemoryStream ms = new MemoryStream(data))
            {
                using (GZipStream zip = new GZipStream(ms, CompressionMode.Decompress, true))
                {
                    using(MemoryStream msreader = new MemoryStream())
                    {

                        byte[] buffer = new byte[4096];
                        while (true)
                        {
                            int reader = zip.Read(buffer, 0, buffer.Length);
                            if (reader <= 0)
                            {
                                break;
                            }
                            msreader.Write(buffer, 0, reader);
                        }
                        zip.Close();
                        ms.Close();
                        msreader.Position = 0;
                        buffer = msreader.ToArray();
                        msreader.Close();
                        return buffer;
                    }
                }
            }
        }
    }
}
