using System;
using System.Collections.Generic;
using System.Text;

namespace ChuPiao.Common.Utils
{
    /// <summary>
    /// 16ַתַ֮ࣨ޿ո
    /// </summary>
    public class HexStringUtil
    {
        /// <summary>
        /// ֽתΪ16ַ
        /// </summary>
        /// <param name="inputBytes"></param>
        /// <returns></returns>
        public static string ByteToString(byte[] inputBytes)
        {
            if (inputBytes == null || inputBytes.Length < 1)
            {
                return string.Empty;
            }
            StringBuilder stringBuilder = new StringBuilder(inputBytes.Length * 2);
            foreach (byte b in inputBytes)
            {
                stringBuilder.Append(String.Format("{0:X2}", b));
            }

            return stringBuilder.ToString().Trim();
        }
        /// <summary>
        /// 16ַתΪֽ
        /// </summary>
        /// <param name="inputString"></param>
        /// <returns></returns>
        public static byte[] StringToByte(string inputString)
        {
            byte[] bytes;
            if (string.IsNullOrEmpty(inputString))
            {
                bytes = new byte[] { };
            }
            else
            {
                int length = inputString.Length / 2;
                bytes = new byte[length];
                for (int i = 0; i < length; i++)
                {
                    bytes[i] = Convert.ToByte(inputString.Substring(i * 2, 2), 16);
                }
            }
            return bytes;
        }

        /// <summary>
        /// <Encode>
        /// ãַתΪ16ݱ룬Decode
        /// ˵
        /// strEncode Ҫתԭʼַ
        /// תĹֱӰַתUnicodeַ,"3"-->0033,""-->U+6211
        /// decodeĹencode.
        /// </summary>
        /// <param name="strEncode"></param>
        /// <returns></returns>
        public static string Encode(string strEncode)
        {
            string strReturn = "";//洢תı
            foreach (short shortx in strEncode.ToCharArray())
            {
                strReturn += shortx.ToString("X4");
            }
            return strReturn;
        }
        /// <summary>
        /// <Decode>
        ///ã16ݱתΪַEncode
        /// </summary>
        /// <param name="strDecode"></param>
        /// <returns></returns>
        public static string Decode(string strDecode)
        {
            string sResult = "";
            for (int i = 0; i < strDecode.Length / 4; i++)
            {
                sResult += (char)short.Parse(strDecode.Substring(i * 4, 4), global::System.Globalization.NumberStyles.HexNumber);
            }
            return sResult;
        }
    }
}
