using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Win32;
using log4net;

namespace ChuPiao.Common.Utils
{
    /// <summary>
    /// ע
    /// </summary>
    public class RegistryUtil
    {
        private static ILog _log = LogManager.GetLogger("default");

        /// <summary>
        /// עԶ
        /// </summary>
        /// <param name="key">עֵ</param>
        /// <param name="applicationPath">.exeļ·.exeļ</param>
        /// <returns>Ƿɹ</returns>
        public static bool ConfigureAutoRun(string key,string applicationPath)
        {
            RegistryKey autoRunItems = null;
            try
            {
                autoRunItems = Registry.LocalMachine.CreateSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run");
                string value = (string)autoRunItems.GetValue(key, "no");
                if ("no" == value || applicationPath != value)
                {
                    autoRunItems.SetValue(key, applicationPath);
                    return true;
                }
            }
            catch (Exception e) 
            {
                _log.Warn("ÿԶСʧܣ" + e.Message);
            }
            finally
            {
                if (autoRunItems != null)
                {
                    autoRunItems.Close();
                }
            }
            return false;
        }
        /// <summary>
        ///  עȡԶ
        /// </summary>
        /// <param name="key">עֵ</param>
        /// <returns>Ƿɹ</returns>
        public static bool CancelAutoRun(string key)
        {
            RegistryKey autoRunItems = null;
            try
            {
                autoRunItems = Registry.LocalMachine.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run", true);
                string[] itemNames = autoRunItems.GetValueNames();
                foreach (string name in itemNames)
                {
                    if (key.ToUpper() == name.ToUpper())
                    {
                        autoRunItems.DeleteValue(name);
                        return true;
                    }
                }
            }
            catch (Exception e) 
            {
                _log.Warn("ÿԶСʧܣ" + e.Message);
            }
            finally
            {
                if (autoRunItems != null)
                {
                    autoRunItems.Close();
                }
            }
            return false;
        }
        /// <summary>
        /// 鿪ԶעǷָļֵ
        /// </summary>
        /// <param name="key"></param>
        /// <param name="applicationPath">.exeļ·.exeļ</param>
        /// <returns>Ƿ</returns>
        public static bool AutoRunItemExits(string key,string applicationPath)
        {
            RegistryKey autoRunItems = null;
            try
            {
                autoRunItems = Registry.LocalMachine.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run",true);
                return RegistryItemExits(autoRunItems, key, applicationPath);
            }
            catch (Exception e) { }
            finally
            {
                if (autoRunItems != null)
                {
                    autoRunItems.Close();
                }
            }
            return false;
        }
        /// <summary>
        /// עǷָļֵ
        /// </summary>
        /// <param name="subKey">עжڵ</param>
        /// <param name="keyName"></param>
        /// <returns>Ƿ</returns>
        private static bool RegistryItemExits(RegistryKey subKey,string keyName,string value)
        {
            string[] itemNames = subKey.GetValueNames();
            foreach (string name in itemNames)
            {
                if (keyName.ToUpper() == name.ToUpper())
                {
                    string targetValue = (string)subKey.GetValue(name);
                    if (value != targetValue)
                    {
                        subKey.DeleteValue(name);
                        return false;
                    }
                    return true;
                }
            }
            return false;
        }
    }
}
